<?php
/***************************************************************
* Copyright notice
*
* (c) 2005 Andreas Bulling (typo3@taekwondo-homepage.de)
* All rights reserved
*
* This script is part of the TYPO3 project. The TYPO3 project is
* free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* The GNU General Public License can be found at
* http:// www.gnu.org/copyleft/gpl.html.
*
* This script is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

/**
 * [CLASS/FUNCTION INDEX of SCRIPT]
 *
 *
 *
 *   73: class tx_ablinklist_module1 extends t3lib_SCbase
 *   85:     function init()
 *   97:     function menuConfig()
 *  120:     function main()
 *  139:     function jumpToUrl(URL)
 *  188:     function printContent()
 *  203:     function moduleContent()
 *  347:     function getViewLinksToApprove()
 *  492:     function getViewLinksReportedBroken()
 *  565:     function getViewCheckForBrokenLinks()
 *  769:     function getViewSendPromotion()
 *  928:     function getViewImportCategoriesLinks( $type = null, $table = null, $generateQuery = null )
 * 1082:     function getViewPromoteLink( $uid = null, $error )
 * 1114:     function doAcceptLink( $uid = null )
 * 1161:     function doDisableLink( $uid = null )
 * 1180:     function doDeleteLink( $uid = null )
 * 1197:     function doPromoteLink( $uid = null )
 * 1324:     function doPromoteLinkConfirm( $uid = null )
 * 1343:     function doCheckLink( $href )
 * 1450:     function makePageBrowser( $showResultCount = 1, $tableParams = '', $pointerName = 'pointer' )
 *
 * TOTAL FUNCTIONS: 19
 * (This index is automatically created/updated by the extension "extdeveval")
 *
 */

unset( $MCONf );
require ( 'conf.php' );
require ( $BACK_PATH. 'init.php' );
require ( $BACK_PATH. 'template.php' );
include ( 'locallang.php' );
require_once ( PATH_t3lib . 'class.t3lib_scbase.php' );
require_once ( PATH_t3lib . 'class.t3lib_div.php' );

$BE_USER->modAccess( $MCONF, 1 );	//  This checks permissions and exits if the users has no permission for entry.

/**
 * Module 'Modern Linklist' for the 'ab_linklist' extension.
 *
 * @author	Andreas Bulling <typo3@taekwondo-homepage.de>
 * @package TYPO3
 * @subpackage	tx_ablinklist
 */
class tx_ablinklist_module1 extends t3lib_SCbase {
	var $pageinfo;
	var $debug = false;
	var $tablePrefix ='tx_ablinklist_';

	/**
	 * init()
	 *
	 * Calls the parent init() function.
	 *
	 * @return	void
	 */
	function init()	{
		global $AB, $BE_USER, $LANG, $BACK_PATH, $TCA_DESCR, $TCA, $HTTP_GET_VARS, $HTTP_POST_VARS, $CLIENT, $TYPO3_CONF_VARS;
		parent::init();
	}

	/**
	 * menuConfig()
	 *
	 * Adds items to the ->MOD_MENU array. Used for the function menu selector.
	 *
	 * @return	void
	 */
	function menuConfig()	{
		global $LANG;

		$this->MOD_MENU = Array (
			'function' => Array (
				'1' => $LANG->getLL( 'function1'),
				'2' => $LANG->getLL( 'function2'),
				'3' => $LANG->getLL( 'function3'),
				'4' => $LANG->getLL( 'function4'),
				'5' => $LANG->getLL( 'function5'),
			)
		);

		parent::menuConfig();
	}

	/**
	 * main()
	 *
	 * Main function of the module. Write the content to $this->content
	 *
	 * @return	void
	 */
	function main()	{
		global $AB, $BE_USER, $LANG, $BACK_PATH, $TCA_DESCR, $TCA, $HTTP_GET_VARS, $HTTP_POST_VARS, $CLIENT, $TYPO3_CONF_VARS;

		//  Access check!
		//  The page will show only if there is a valid page and if this page may be viewed by the user
		$this->pageinfo = t3lib_BEfunc::readPageAccess( $this->id, $this->perms_clause);
		$access = is_array( $this->pageinfo ) ? 1 : 0;

		if( ( $this->id && $access ) || ( $BE_USER->user['admin'] && !$this->id ) )	{

			// Draw the header
			$this->doc = t3lib_div::makeInstance('mediumDoc');
			$this->doc->backPath = $BACK_PATH;
			$this->doc->form= '<form action="" method="POST">';

			// JavaScript
			$this->doc->JScode = '
				<script language="javascript">
					script_ended = 0;
					function jumpToUrl(URL)	{
						document.location = URL;
					}
				</script>
			';

			$this->doc->postCode= '
				<script language="javascript">
					script_ended = 1;
					if(top.theMenu) top.theMenu.recentuid = ' . intval( $this->id ) . ';
				</script>
			';

			$headerSection = $this->doc->getHeader( 'pages', $this->pageinfo, $this->pageinfo['_thePath'] ) . '<br />' . $LANG->php3Lang['labels']['path'] . ': ' . t3lib_div::fixed_lgd_pre( $this->pageinfo['_thePath'],50);

			$this->content .= $this->doc->startPage( $LANG->getLL( 'title') );
			$this->content .= $this->doc->header( $LANG->getLL( 'title') );
			$this->content .= $this->doc->spacer( 5 );
			$this->content .= $this->doc->section( '', $this->doc->funcMenu( $headerSection, t3lib_BEfunc::getFuncMenu( $this->id, 'SET[function]', $this->MOD_SETTINGS['function'], $this->MOD_MENU['function'] ) ) );
			$this->content .= $this->doc->divider( 5 );

			// Render content
			$this->moduleContent();

			// ShortCut
			if( $BE_USER->mayMakeShortcut() )	{
				$this->content .= $this->doc->spacer(20) . $this->doc->section( '', $this->doc->makeShortcutIcon( 'id', implode( ', ', array_keys( $this->MOD_MENU) ), $this->MCONF['name'] ) );
			}

			$this->content .= $this->doc->spacer(10);
		} else	{
			// If no access or if ID == zero
			$this->doc = t3lib_div::makeInstance('mediumDoc');
			$this->doc->backPath = $BACK_PATH;

			$this->content .= $this->doc->startPage( $LANG->getLL( 'title') );
			$this->content .= $this->doc->header( $LANG->getLL( 'title') );
			$this->content .= $this->doc->spacer( 5 );
			$this->content .= $this->doc->spacer( 10 );
		}
	}

	/**
	 * printContent()
	 *
	 * Prints the generated HTML source for the module.
	 *
	 * @return	string		The generated HTML source for the module.
	 */
	function printContent()	{
		global $SOBE;

		$this->content .= $this->doc->middle();
		$this->content .= $this->doc->endPage();
		echo $this->content;
	}

	/**
	 * moduleContent()
	 *
	 * Decides which function to call and adds its output to the content.
	 *
	 * @return	void
	 */
	function moduleContent()	{
		global $LANG;

		// Check for correct page
		$theTable = 'tt_content';
		$whereClause = 'pid=' . $this->id . ' AND list_type="ab_linklist_pi1" AND deleted=0';
		$groupBy = '';
		$orderBy = '';
		$limit = '';
		$tt_content = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows( '*', $theTable, $whereClause, $groupBy, $orderBy, $limit );

		if( !$tt_content )	{
			$content .= $LANG->getLL( 'errorPageSelect');
			$this->content .= $this->doc->section( $LANG->getLL( 'error'), $content, 0, 1 );
			return;
		}

		// Get action and uid values
		$action = $GLOBALS['HTTP_POST_VARS']['action'] ? $GLOBALS['HTTP_POST_VARS']['action'] : $GLOBALS['HTTP_GET_VARS']['action'];
		$uid = $GLOBALS['HTTP_POST_VARS']['uid'] ? $GLOBALS['HTTP_POST_VARS']['uid'] : $GLOBALS['HTTP_GET_VARS']['uid'];

		switch( (string)$this->MOD_SETTINGS['function'] )	{
			/**
			 * FUNCTION: Approve Links
			 */
			case 1:
				// Decide what to do
				if( $action == null || $action == '' )	{
					$content .= $this->getViewLinksToApprove();

				} elseif( $action == 'getViewAcceptLink' )	{
					// Update the database
					$this->doAcceptLink( $uid );

					$content .= $this->getViewLinksToApprove();

				} elseif( $action == 'getViewDeleteLink' )	{
					// Update the database
					$this->doDeleteLink( $uid );

					$content .= $this->getViewLinksToApprove();
				}

				$this->content .= $this->doc->section( $LANG->getLL( 'function1'), $content, 0, 1 );
			break;

			/**
			 * FUNCTION: Links reported broken
			 */
			case 2:
				// Decide what to do
				if( $action == null || $action == '' )	{
					$content .= $this->getViewLinksReportedBroken();

				} elseif( $action == 'getViewAcceptLink' )	{
					// Update the database
					$this->doAcceptLink( $uid );

					$content .= $this->getViewLinksReportedBroken();

				} elseif( $action == 'getViewDisableLink' )	{
					// Update the database
					$this->doDisableLink( $uid );

					$content .= $this->getViewLinksReportedBroken();
				}

				$this->content .= $this->doc->section( $LANG->getLL( 'function2'), $content, 0, 1 );
			break;

			/**
			 * FUNCTION: Check for non-working links
			 */
  			case 3:
  				// Decide what to do
  				if( $action == null || $action == '' )	{
  					$content .= $this->getViewCheckForBrokenLinks();

  				} elseif( $action == 'getViewEnableLink' )	{
  					// Update the database
  					$this->doAcceptLink( $uid );

  					$content .= $this->getViewCheckForBrokenLinks();

  				} elseif( $action == 'getViewDisableLink' )	{
  					// Update the database
  					$this->doDisableLink( $uid );

  					$content .= $this->getViewCheckForBrokenLinks();
  				}

  				$this->content .= $this->doc->section( $LANG->getLL( 'function3'), $content, 0, 1 );
  			break;

			/**
			 * FUNCTION: Send promotion
			 */
  			case 4:
  				// Decide what to do
  				if( $action == null || $action == '' )	{
  					$content .= $this->getViewSendPromotion();

  				} elseif( $action == 'getViewPromoteLink' )	{
  					// Update the database
  					$error = $this->doPromoteLink( $uid );

  					$content .= $this->getViewPromoteLink( $uid, $error );

				} elseif( $action == 'getViewPromoteLinkConfirm' )	{
  					// Update the database
  					$this->doPromoteLinkConfirm( $uid );

  					$content .= $this->getViewSendPromotion();
				}

  				$this->content .= $this->doc->section( $LANG->getLL( 'function4'), $content, 0, 1 );
  			break;

			/**
			 * FUNCTION: Import categories/links
			 */
  			case 5:
				$type = $GLOBALS['HTTP_GET_VARS']['type'];
				$table = $GLOBALS['HTTP_GET_VARS']['table'];
				$generateQuery = $GLOBALS['HTTP_GET_VARS']['generateQuery'];

  				// Decide what to do
  				if( $action == null || $action == '' )	{
  					$content .= $this->getViewImportCategoriesLinks( $type, $table, $generateQuery );
  				}

  				$this->content .= $this->doc->section( $LANG->getLL( 'function5'), $content, 0, 1 );
  			break;
  		}
  	}

	/**
	 * getViewLinksToApprove()
	 *
	 * Checks for links proposed by frontend users.
	 * Provides the possibility to accept and delete links.
	 *
	 * @return	string		The generated HTML source for this view.
	 */
	function getViewLinksToApprove()	{
		global $LANG;

		// Init some vars
		$content = null;
		$linksToApprove = null;
		$doc = get_object_vars( $this->doc);
		$switch = true;

		// Output description
		$content .= $LANG->getLL( 'ViewLinksToApprove_text') . '<br /><br />';

		// Get links from database
		$theTable = $this->tablePrefix . 'link AS link, ' . $this->tablePrefix . 'category AS cat';
		$theField = 'link.status';
		$theValue = '0';
		$whereClause = 'AND link.sys_language_uid=0 AND link.category=cat.uid AND link.deleted=0 AND link.hidden=0';
		$groupBy = '';
		$orderBy = '';
		$limit = '';
		$linksToApprove = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows( 'link.label,link.description,link.href,link.uid,link.category,cat.label AS catlabel', $theTable, $theField . '=' . $GLOBALS['TYPO3_DB']->quoteStr( $theValue, $theTable ) . ' ' . $whereClause, $groupBy, $orderBy, $limit );

		$theTable = $this->tablePrefix . 'link';
		$theField = 'status';
		$theValue = '0';
		$whereClause = 'AND sys_language_uid=0 AND category=0 AND deleted=0 AND hidden=0';
		$groupBy = '';
		$orderBy = '';
		$limit = '';
		$linksToApproveWithoutCategory = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows( 'label,description,href,uid', $theTable, $theField . '=' . $GLOBALS['TYPO3_DB']->quoteStr( $theValue, $theTable ) . ' ' . $whereClause, $groupBy, $orderBy, $limit );

		// Get categories from database
		$theTable = $this->tablePrefix . 'category';
		$whereClause = 'sys_language_uid=0 AND deleted=0 AND hidden=0';
		$groupBy = '';
		$orderBy = '';
		$limit = '';
		$categories = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows( '*', $theTable, $whereClause, $groupBy, $orderBy, $limit );

		// Debugging output
		if( $this->debug )	{
			t3lib_div::print_array( $linksToApprove );
			t3lib_div::print_array( $linksToApproveWithoutCategory );
			t3lib_div::print_array( $categories );
		}

		$content .= '<table width="100%">';
		$content .= '<tr bgcolor="' . $doc['bgColor5'] . '">';
		$content .= '<td><b>Label</b></td>';
		$content .= '<td><b>Description</b></td>';
		$content .= '<td><b>URI</b></td>';
		$content .= '<td><b>Category</b></td>';
		$content .= '<td>&nbsp;</td>';
		$content .= '<td>&nbsp;</td>';
		$content .= '</tr>';

		if( count( $linksToApprove ) > 0 )	{
			// Links with category
			for( $i = 0; $i < count( $linksToApprove ); $i++ )	{
					$content .= '<form action="">';

				// Alternating row colors
				if( $switch == true)	{
					$switch = false;
					$content .= "<tr bgcolor=\"" . $doc['bgColor3'] . "\">";
				} elseif( $switch == false)	{
					$switch = true;
					$content .= '<tr>';
				}
	
				// Starting content
				$content .= '<td style="vertical-align:top;"><input type="text" name="label" value="' . $linksToApprove[$i]['label'] . '" size="30" /></td>';
				$content .= '<td><textarea name="description" rows="5">' . $linksToApprove[$i]['description'] . '</textarea></td>';
				$content .= '<td style="vertical-align:top;"><input type="text" name="href" value="' . $linksToApprove[$i]['href'] . '" size="30" /></td>';
	
				$content .= '<td style="vertical-align:top;"><select name="categoryUID"><option value="0"></option>';
				foreach( $categories as $category )	{
					if( $linksToApprove[$i]['category'] == $category['uid'] )	{
						$content .= '<option value="' . $category['uid']  . '" selected="selected">' . $category['label'] . '</option>';
					} else	{
						$content .= '<option value="' . $category['uid']  . '">' . $category['label'] . '</option>';
					}
				}
				$content .= '</select></td>';
	
				$content .= '<td style="vertical-align:top;"><input type="image" name="uid" value="' . $linksToApprove[$i]['uid'] . '" src="action_accept.gif" alt="' . $LANG->getLL( 'ViewLinksToApprove_accept') . '" title="' . $LANG->getLL( 'ViewLinksToApprove_accept') . '" /></td>';
				$content .= "<td style=\"vertical-align:top;\"><a href=\"?action=getViewDeleteLink&id=" . $this->id . "&uid=" . $linksToApprove[$i]['uid'] . "\"><img src=\"action_delete.gif\" border=\"0\" alt=\"" . $LANG->getLL( 'ViewLinksToApprove_delete') . "\" title=\"" . $LANG->getLL( 'ViewLinksToApprove_delete') . "\"></a></td>";
				$content .= '</tr>';

				$content .= '<input type="hidden" name="id" value="' . $this->id . '" /><input type="hidden" name="action" value="getViewAcceptLink" /></form>';
			}
		}

		if( count( $linksToApproveWithoutCategory ) > 0 )	{
			// Links without category
			for( $i = 0; $i < count( $linksToApproveWithoutCategory ); $i++ )	{
				$content .= '<form action="">';
	
				// Alternating row colors
				if( $switch == true)	{
					$switch = false;
					$content .= "<tr bgcolor=\"" . $doc['bgColor3'] . "\">";
				} elseif( $switch == false)	{
					$switch = true;
					$content .= '<tr>';
				}
	
				// Starting content
				$content .= '<td style="vertical-align:top;"><input type="text" name="label" value="' . $linksToApproveWithoutCategory[$i]['label'] . '" size="30" /></td>';
				$content .= '<td><textarea name="description" rows="5">' . $linksToApproveWithoutCategory[$i]['description'] . '</textarea></td>';
				$content .= '<td style="vertical-align:top;"><input type="text" name="href" value="' . $linksToApproveWithoutCategory[$i]['href'] . '" size="30" /></td>';
	
				$content .= '<td style="vertical-align:top;"><select name="categoryUID"><option value="0"></option>';
				foreach( $categories as $category )	{
					$content .= '<option value="' . $category['uid']  . '">' . $category['label'] . '</option>';
				}
				$content .= '</select></td>';
	
				$content .= '<td style="vertical-align:top;"><input type="image" name="uid" value="' . $linksToApproveWithoutCategory[$i]['uid'] . '" src="action_accept.gif" alt="' . $LANG->getLL( 'ViewLinksToApprove_accept') . '" title="' . $LANG->getLL( 'ViewLinksToApprove_accept') . '" /></td>';
				$content .= "<td style=\"vertical-align:top;\"><a href=\"?action=getViewDeleteLink&id=" . $this->id . "&uid=" . $linksToApproveWithoutCategory[$i]['uid'] . "\"><img src=\"action_delete.gif\" border=\"0\" alt=\"" . $LANG->getLL( 'ViewLinksToApprove_delete') . "\" title=\"" . $LANG->getLL( 'ViewLinksToApprove_delete') . "\"></a></td>";
				$content .= '</tr>';

				$content .= '<input type="hidden" name="id" value="' . $this->id . '" /><input type="hidden" name="action" value="getViewAcceptLink" /></form>';
			}
		}

		$content .= '</table>';

		// Legend
		$content .= $this->doc->divider(10);
		$content .= '<b>' . $LANG->getLL( 'legend') . '</b><br /><br />';
		$content .= '<img src="action_accept.gif" border="0" alt="' . $LANG->getLL( 'ViewLinksToApprove_accept') . '" title="' . $LANG->getLL( 'ViewLinksToApprove_accept') . '">&nbsp;' . $LANG->getLL( 'ViewLinksToApprove_accept' );
		$content .= '<br /><img src="action_delete.gif" border="0" alt="' . $LANG->getLL( 'ViewLinksToApprove_delete') . '" title="' . $LANG->getLL( 'ViewLinksToApprove_delete') . '">&nbsp;' . $LANG->getLL( 'ViewLinksToApprove_delete' );

		return $content;
	}

	/**
	 * getViewLinksReportedBroken()
	 *
	 * Checks for links reported broken by frontend users.
	 * Provides the possibility to accept and disable links.
	 *
	 * @return	string		The generated HTML source for this view.
	 */
	function getViewLinksReportedBroken()	{
		global $LANG;

		// Init some vars
		$content = null;
		$linksReportedBroken = null;
		$doc = get_object_vars( $this->doc);
		$switch = true;

		// Output header and description
		$content .= $LANG->getLL( 'ViewLinksReportedBroken_text') . '<br /><br />';

		// Get links from database
		$theTable = $this->tablePrefix . 'link';
		$theField = 'status';
		$theValue = '2';
		$whereClause = 'AND sys_language_uid=0 AND deleted=0 AND hidden=0';
		$groupBy = '';
		$orderBy = '';
		$limit = '';
		$linksReportedBroken = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows( 'label,href,uid', $theTable, $theField . '=' . $GLOBALS['TYPO3_DB']->quoteStr( $theValue, $theTable ) . ' ' . $whereClause, $groupBy, $orderBy, $limit );

		// Debugging output
		if( $this->debug )	{
			t3lib_div::print_array( $linksReportedBroken );
		}

		// Ouput links
		$content .= '<table width="100%">';
		$content .= '<tr bgcolor="' . $doc['bgColor5'] . '">';
		$content .= '<td><b>Label</b></td>';
		$content .= '<td><b>URI</b></td>';
		$content .= '<td>&nbsp;</td>';
		$content .= '<td>&nbsp;</td>';
		$content .= '</tr>';

		for( $i = 0; $i < count( $linksReportedBroken); $i++ )	{
			// Alternating row colors
			if( $switch == true)	{
				$switch = false;
				$content  .= "<tr bgcolor=\"" . $doc['bgColor3'] . "\">";
			}
			elseif( $switch == false)	{
				$switch = true;
				$content  .= '<tr>';
			}

			// Starting content
			$content .= '<td>' . $linksReportedBroken[$i]['label'] . '</td>';
			$content .= '<td><a href="' . $linksReportedBroken[$i]['href'] . '" target="_blank">' . $linksReportedBroken[$i]['href'] . '</a></td>';
			$content .= '<td><a href="?action=getViewAcceptLink&uid=' . $linksReportedBroken[$i]['uid'] . '&id=' . $this->id. '"><img src="action_accept.gif" border="0" alt="' . $LANG->getLL( 'ViewLinksToApprove_accept' ) . '" title="' . $LANG->getLL( 'ViewLinksToApprove_accept' ) . '"></a></td>';
			$content .= '<td><a href="?action=getViewDisableLink&uid=' . $linksReportedBroken[$i]['uid'] . '&id=' . $this->id. '"><img src="action_disable.gif" border="0" alt="' . $LANG->getLL( 'ViewLinksReportedBroken_disable' ) . '" title="' . $LANG->getLL( 'ViewLinksReportedBroken_disable' ) . '"></a></td>';
			$content .= '</tr>';
		}
		$content .= '</table>';

		// Legend
		$content .= $this->doc->divider(10);
		$content .= '<b>' . $LANG->getLL( 'legend') . '</b><br /><br />';
		$content .= '<img src="action_accept.gif" border="0" alt="' . $LANG->getLL( 'ViewLinksToApprove_accept' ) . '" title="' . $LANG->getLL( 'ViewLinksToApprove_accept' ) . '">&nbsp;' . $LANG->getLL( 'ViewLinksToApprove_accept' );
		$content .= '<br /><img src="action_disable.gif" border="0" alt="' . $LANG->getLL( 'ViewLinksReportedBroken_disable' ) . '" title="' . $LANG->getLL( 'ViewLinksReportedBroken_disable' ) . '">&nbsp;' . $LANG->getLL( 'ViewLinksReportedBroken_disable' );

		return $content;
	}

	/**
	 * getViewCheckForBrokenLinks()
	 *
	 * Checks for non-working links.
	 * Provides the possibility to enable and disable links.
	 *
	 * @return	string		The generated HTML source for this view.
	 */
	function getViewCheckForBrokenLinks()	{
		global $LANG;

		// Init some vars
		$content = null;
		$links = null;
		$doc = get_object_vars( $this->doc);
		$switch = true;
		$linksOnline = array();
		$linksOffline = array();
		$linksNotChecked = array();

		// Get flexform config
		$theTable = 'tt_content';
		$whereClause = 'pid=' . $this->id . ' AND list_type="ab_linklist_pi1" AND deleted=0';
		$groupBy = '';
		$orderBy = '';
		$limit = '';
		$flexform = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows( '*', $theTable, $whereClause, $groupBy, $orderBy, $limit );
		$flexarray = t3lib_div::xml2array( $flexform[0]['pi_flexform'] );

		if( $this->debug )
			t3lib_div::print_array( $flexarray );

		if( is_array( $flexarray ) )	{
			$listLimit = $flexarray['data']['s_display']['lDEF']['listLimit']['vDEF'] ? $flexarray['data']['s_display']['lDEF']['listLimit']['vDEF'] : 10;
 		} else	{
			$listLimit = 10;
		}

		// Get and set pagebrowser values
		$pointer = $GLOBALS['HTTP_GET_VARS']['pointer'];
		if ( $pointer > 0 )	{
			$pointer = $pointer * $listLimit;
		} else	{
			$pointer = 0;
		}

		// Output header and description
		$content .= $LANG->getLL( 'ViewCheckForBrokenLinks_text') . '<br /><br />';

		// Get total number of links from database (without links which haven't been approved yet)
		$theTable = $this->tablePrefix . 'link';
		$theField = 'status';
		$theValue = 'IN (1,2)';
		$whereClause = 'AND sys_language_uid=0 AND deleted=0 AND hidden=0';
		$groupBy = '';
		$orderBy = '';
		$limit = '';
		$linksTotal = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows( 'uid,label,href,status', $theTable, $theField . ' ' . $theValue . $whereClause, $groupBy, $orderBy, $limit );

		// Get links from database (without links which haven't been approved yet)
		$theTable = $this->tablePrefix . 'link';
		$theField = 'status';
		$theValue = 'IN (1,2)';
		$whereClause = 'AND sys_language_uid=0 AND deleted=0 AND hidden=0';
		$groupBy = '';
		$orderBy = '';
		$limit = $pointer . ', ' . $listLimit;
		$links = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows( 'uid,label,href,status', $theTable, $theField . ' ' . $theValue . $whereClause, $groupBy, $orderBy, $limit );

		// Debugging output
		if( $this->debug )	{
			t3lib_div::print_array( $links );
		}

		// Check the links
		for( $i = 0; $i < count( $links ); $i++ )	{
			// Get link status
			$linkstatus = $this->doCheckLink( $links[$i]['href'] );

			if( strstr( $linkstatus, 'ERROR' ) )	{
				// Link couldn't be checked.
				$linksNotChecked[] = $links[$i];
			} elseif( $linkstatus == true )	{
				// Link is online.
				$linksOnline[] = $links[$i];
			} elseif( $linkstatus == false )	{
				// Link seems to be offline.
				$linksOffline[] = $links[$i];
			}
		}

		// Ouput links
		$content .= "<table width=\"100%\">";
		$content .= "<tr bgcolor=\"" . $doc['bgColor5'] . "\">";
		$content .= '<td>&nbsp;</td>';
		$content .= '<td><b>Label</b></td>';
		$content .= '<td><b>URI</b></td>';
		$content .= '<td>&nbsp;</td>';
		$content .= '<td>&nbsp;</td>';
		$content .= '</tr>';

		// Output offline links
		for( $i = 0; $i < count( $linksOffline ); $i++ )	{
			$content .= '<form action="">';

			// Extract url
			$linksOffline[$i]['href'] = explode( ' ', $linksOffline[$i]['href'] );
			$linksOffline[$i]['href'] = $linksOffline[$i]['href'][0];

			// Alternating row colors
			if( $switch == true)	{
				$switch = false;
				$content  .= "<tr bgcolor=\"" . $doc['bgColor3'] . "\">";
			} elseif( $switch == false)	{
				$switch = true;
				$content  .= '<tr>';
			}
			// Starting content
			$content .= "<td><img src=\"icon_offline.gif\" border=\"0\" alt=\"" . $LANG->getLL( 'ViewCheckForBrokenLinks_offline') . "\" title=\"" . $LANG->getLL( 'ViewCheckForBrokenLinks_offline') . "\"></td>";
			$content .= '<td>' . $linksOffline[$i]['label'] . '</td>';
			$content .= '<td><input type="text" name="href" value="' . $linksOffline[$i]['href'] . '" size="30" /></td>';
			$content .= '<td><input type="image" name="uid" value="' . $linksOffline[$i]['uid'] . '" src="action_enable.gif" alt="' . $LANG->getLL( 'ViewCheckForBrokenLinks_enable') . '" title="' . $LANG->getLL( 'ViewCheckForBrokenLinks_enable') . '" /></td>';
			$content .= "<td><a href=\"?action=getViewDisableLink&id=" . $this->id . "&uid=" . $linksOffline[$i]['uid'] . "\"><img src=\"action_disable.gif\" border=\"0\" alt=\"" . $LANG->getLL( 'ViewLinksReportedBroken_disable') . "\" title=\"" . $LANG->getLL( 'ViewLinksReportedBroken_disable') . "\"></a></td>";
			$content .= '</tr>';

			$content .= '<input type="hidden" name="id" value="' . $this->id . '" /><input type="hidden" name="action" value="getViewEnableLink" /></form>';
		}

		// Output online links
		for( $i = 0; $i < count( $linksOnline ); $i++ )	{
			// Extract url
			$linksOnline[$i]['href'] = explode( ' ', $linksOnline[$i]['href'] );
			$linksOnline[$i]['href'] = $linksOnline[$i]['href'][0];

			// Alternating row colors
			if( $switch == true)	{
				$switch = false;
				$content  .= "<tr bgcolor=\"" . $doc['bgColor4'] . "\">";
			} elseif( $switch == false)	{
				$switch = true;
				$content  .= '<tr>';
			}

			// Starting content
			$content .= "<td><img src=\"icon_online.gif\" border=\"0\" alt=\"" . $LANG->getLL( 'ViewCheckForBrokenLinks_online') . "\" title=\"" . $LANG->getLL( 'ViewCheckForBrokenLinks_online') . "\"></td>";
			$content .= '<td>' . $linksOnline[$i]['label'] . '</td>';
			$content .= '<td><a href="' . $linksOnline[$i]['href'] . '">' . $linksOnline[$i]['href'] . '</a></td>';
			$content .= '<td></td>';
			$content .= "<td><a href=\"?action=getViewDisableLink&id=" . $this->id . "&uid=" . $linksOnline[$i]['uid'] . "\"><img src=\"action_disable.gif\" border=\"0\" alt=\"" . $LANG->getLL( 'ViewLinksReportedBroken_disable') . "\" title=\"" . $LANG->getLL( 'ViewLinksReportedBroken_disable') . "\"></a></td>";
			$content .= '</tr>';
		}

		// Output links, that couldn't be checked
		for( $i = 0; $i < count( $linksNotChecked ); $i++ )	{
			$content .= '<form action="">';

			// Extract url
			$linksNotChecked[$i]['href'] = explode( ' ', $linksNotChecked[$i]['href'] );
			$linksNotChecked[$i]['href'] = $linksNotChecked[$i]['href'][0];

			// Alternating row colors
			if( $switch == true)	{
				$switch = false;
				$content  .= "<tr bgcolor=\"" . $doc['bgColor4'] . "\">";
			} elseif( $switch == false)	{
				$switch = true;
				$content  .= '<tr>';
			}

			// Starting content
			$content .= '<td>?</td>';
			$content .= '<td>' . $linksNotChecked[$i]['label'] . '</td>';
			$content .= '<td><input type="text" name="href" value="' . $linksNotChecked[$i]['href'] . '" size="30" /></td>';
			$content .= '<td><input type="image" name="uid" value="' . $linksNotChecked[$i]['uid'] . '" src="action_enable.gif" alt="' . $LANG->getLL( 'ViewCheckForBrokenLinks_enable') . '" title="' . $LANG->getLL( 'ViewCheckForBrokenLinks_enable') . '" /></td>';
			$content .= "<td><a href=\"?action=getViewDisableLink&id=" . $this->id . "&uid=" . $linksNotChecked[$i]['uid'] . "\"><img src=\"action_disable.gif\" border=\"0\" alt=\"" . $LANG->getLL( 'ViewLinksReportedBroken_disable') . "\" title=\"" . $LANG->getLL( 'ViewLinksReportedBroken_disable') . "\"></a></td>";
			$content .= '</tr>';

			$content .= '<input type="hidden" name="id" value="' . $this->id . '" /><input type="hidden" name="action" value="getViewEnableLink" /></form>';
		}
		$content .= '</table>';

		// Pagebrowser
		if( count( $linksTotal ) > $listLimit )	{
			//  configure pagebrowser vars
			$this->internal['res_count'] = count( $linksTotal );
			$this->internal['results_at_a_time'] = $listLimit;
			$this->internal['maxPages'] = 100;
			$this->internal['action'] = '';

			$content .= '<br />';
			$content .= $this->makePageBrowser();
		}

		// Legend
		$content .= $this->doc->divider(10);
		$content .= '<b>' . $LANG->getLL( 'legend') . '</b><br /><br />';
		$content .= '<img src="action_enable.gif" border="0" alt="' . $LANG->getLL( 'ViewCheckForBrokenLinks_enable' ) . '" title="' . $LANG->getLL( 'ViewCheckForBrokenLinks_enable' ) . '">&nbsp;' . $LANG->getLL( 'ViewCheckForBrokenLinks_enable' ) . '<br />';
		$content .= '<img src="action_disable.gif" border="0" alt="' . $LANG->getLL( 'ViewLinksToApprove_delete' ) . '" title="' . $LANG->getLL( 'ViewLinksToApprove_delete' ) . '">&nbsp;' . $LANG->getLL( 'ViewLinksReportedBroken_disable' ) . '<br />';
		$content .= '<img src="icon_offline.gif" border="0" alt="' . $LANG->getLL( 'ViewCheckForBrokenLinks_offline' ) . '" title="' . $LANG->getLL( 'ViewCheckForBrokenLinks_offline' ) . '"> &nbsp;' . $LANG->getLL( 'ViewCheckForBrokenLinks_offline' ) . '<br />';
		$content .= '<img src="icon_online.gif" border="0" alt="' . $LANG->getLL( 'ViewCheckForBrokenLinks_online' ) . '" title="' . $LANG->getLL( 'ViewCheckForBrokenLinks_online' ) . '"> &nbsp;' . $LANG->getLL( 'ViewCheckForBrokenLinks_online' );

		return $content;
	}

	/**
	 * getViewSendPromotion()
	 *
	 * Checks for links and their promotion status.
	 * Provides the possibility to promote links.
	 *
	 * @return	string		The generated HTML source for this view.
	 */
	function getViewSendPromotion()	{
		global $LANG;

		// Init some vars
		$content = null;
		$links = null;
		$doc = get_object_vars( $this->doc);
		$switch = true;

		// Get flexform config
		$theTable = 'tt_content';
		$whereClause = 'pid=' . $this->id . ' AND list_type="ab_linklist_pi1" AND deleted=0';
		$groupBy = '';
		$orderBy = '';
		$limit = '';
		$flexform = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows( '*', $theTable, $whereClause, $groupBy, $orderBy, $limit );
		$flexarray = t3lib_div::xml2array( $flexform[0]['pi_flexform'] );

		if( $this->debug )
			t3lib_div::print_array( $flexarray );

		if( is_array( $flexarray ) )	{
			$listLimit = $flexarray['data']['s_display']['lDEF']['listLimit']['vDEF'] ? $flexarray['data']['s_display']['lDEF']['listLimit']['vDEF'] : 10;
		} else	{
			$listLimit = 10;
		}

		// Get and set pagebrowser values
		$pointer = $GLOBALS['HTTP_GET_VARS']['pointer'];
		if ( $pointer > 0 )	{
			$pointer = $pointer * $listLimit;
		} else	{
			$pointer = 0;
		}

		// Output header and description
		$content .= $LANG->getLL( 'ViewSendPromotion_text') . '<br /><br />';

		// Get total number of links from database
		$theTable = $this->tablePrefix . 'link';
		$theField = 'sys_language_uid';
		$theValue = '0';
		$whereClause = 'AND deleted=0 AND hidden=0 AND contact!=\'\'';
		$groupBy = '';
		$orderBy = '';
		$limit = '';
		$linksTotal = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows( 'label,href,uid,contact,promotion_status', $theTable, $theField . '=' . $GLOBALS['TYPO3_DB']->quoteStr( $theValue, $theTable ) . ' ' . $whereClause, $groupBy, $orderBy, $limit );


		// Get links from database
		$theTable = $this->tablePrefix . 'link';
		$theField = 'sys_language_uid';
		$theValue = '0';
		$whereClause = 'AND deleted=0 AND hidden=0 AND contact!=\'\'';
		$groupBy = '';
		$orderBy = '';
		$limit = $pointer . ', ' . $listLimit;
		$links = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows( 'label,href,uid,contact,promotion_status', $theTable, $theField . '=' . $GLOBALS['TYPO3_DB']->quoteStr( $theValue, $theTable ) . ' ' . $whereClause, $groupBy, $orderBy, $limit );

		// Debugging output
		if( $this->debug )	{
			t3lib_div::print_array( $links );
		}

		// Ouput links
		$content .= "<table width=\"100%\">";
		$content .= "<tr bgcolor=\"" . $doc['bgColor5'] . "\">";
		$content .= '<td>&nbsp;</td>';
		$content .= '<td><b>Label</b></td>';
		$content .= '<td><b>URI</b></td>';
		$content .= '<td>&nbsp;</td>';
		$content .= '</tr>';

		for( $i = 0; $i < count( $links); $i++ )	{
			// Alternating row colors
			if( $switch == true)	{
				$switch = false;
				$content  .= "<tr bgcolor=\"" . $doc['bgColor3'] . "\">";
			}
			elseif( $switch == false)	{
				$switch = true;
				$content  .= '<tr>';
			}

			// Starting content
			switch( $links[$i]['promotion_status'] )	{
				case '0':
					$content .= "<td><img src=\"promotion_status_0.gif\" border=\"0\" alt=\"" . $LANG->getLL( 'ViewSendPromotion_status_0') . "\" title=\"" . $LANG->getLL( 'ViewSendPromotion_status_0') . "\"></td>";
				break;

				case '1':
					$content .= "<td><img src=\"promotion_status_1.gif\" border=\"0\" alt=\"" . $LANG->getLL( 'ViewSendPromotion_status_1') . "\" title=\"" . $LANG->getLL( 'ViewSendPromotion_status_1') . "\"></td>";
				break;

				case '2':
					$content .= "<td><img src=\"promotion_status_2.gif\" border=\"0\" alt=\"" . $LANG->getLL( 'ViewSendPromotion_status_2') . "\" title=\"" . $LANG->getLL( 'ViewSendPromotion_status_2') . "\"></td>";
				break;
			}

			$content .= '<td>' . $links[$i]['label'] . '</td>';
			$content .= "<td><a href=\"" . $links[$i]['href'] . "\" target=\"_blank\">" . $links[$i]['href'] . '</a></td>';

			switch( $links[$i]['promotion_status'] )	{
				case '0':
					if( $links[$i]['contact'] )	{
						$content .= "<td><a href=\"?action=getViewPromoteLink&uid=" . $links[$i]['uid'] . '&id=' . $this->id . "\"><img src=\"action_promote.gif\" border=\"0\" alt=\"" . $LANG->getLL( 'ViewSendPromotion_promote') . "\" title=\"" . $LANG->getLL( 'ViewSendPromotion_promote') . "\"></a></td>";
					} else	{
						$content .= "<td><img src=\"action_promote_disabled.gif\" border=\"0\" alt=\"" . $LANG->getLL( 'ViewSendPromotion_promote_disabled') . "\" title=\"" . $LANG->getLL( 'ViewSendPromotion_promote_disabled') . "\"></td>";
					}
				break;

				case '1':
					$content .= "<td><a href=\"?action=getViewPromoteLinkConfirm&uid=" . $links[$i]['uid'] . '&id=' . $this->id . "\"><img src=\"action_promote_confirm.gif\" border=\"0\" alt=\"" . $LANG->getLL( 'ViewSendPromotion_promote_confirm') . "\" title=\"" . $LANG->getLL( 'ViewSendPromotion_promote_confirm') . "\"></a></td>";
				break;

				case '2':
					$content .= "<td><img src=\"action_promote_disabled.gif\" border=\"0\" alt=\"" . $LANG->getLL( 'ViewSendPromotion_promote_disabled') . "\" title=\"" . $LANG->getLL( 'ViewSendPromotion_promote_disabled') . "\"></td>";
				break;
			}

			$content .= '</tr>';
		}
		$content .= '</table>';

		// Pagebrowser
		if( count( $linksTotal ) > $listLimit )	{
			//  configure pagebrowser vars
			$this->internal['res_count'] = count( $linksTotal );
			$this->internal['results_at_a_time'] = $listLimit;
			$this->internal['maxPages'] = 100;
			$this->internal['action'] = '';

			$content .= '<br />';
			$content .= $this->makePageBrowser();
		}

		// Legend
		$content .= $this->doc->divider(10);
		$content .= '<b>' . $LANG->getLL( 'legend') . '</b><br /><br />';
		$content .= '<img src="action_promote.gif" border="0" alt="' . $LANG->getLL( 'ViewSendPromotion_promote' ) . '" title="' . $LANG->getLL( 'ViewSendPromotion_promote' ) . '">&nbsp;' . $LANG->getLL( 'ViewSendPromotion_promote' ) . '<br />';
		$content .= '<img src="action_promote_disabled.gif" border="0" alt="' . $LANG->getLL( 'ViewSendPromotion_promote_disabled' ) . '" title="' . $LANG->getLL( 'ViewSendPromotion_promote_disabled' ) . '">&nbsp;' . $LANG->getLL( 'ViewSendPromotion_promote_disabled' ) . '<br />';
		$content .= '<img src="action_promote_confirm.gif" border="0" alt="' . $LANG->getLL( 'ViewSendPromotion_promote_confirm' ) . '" title="' . $LANG->getLL( 'ViewSendPromotion_promote_confirm' ) . '">&nbsp;' . $LANG->getLL( 'ViewSendPromotion_promote_confirm' ) . '<br />';
		$content .= '<img src="promotion_status_0.gif" border="0" alt="' . $LANG->getLL( 'ViewSendPromotion_status_0' ) . '" title="' . $LANG->getLL( 'ViewSendPromotion_status_0' ) . '">&nbsp;' . $LANG->getLL( 'ViewSendPromotion_status_0' ) . '<br />';
		$content .= '<img src="promotion_status_1.gif" border="0" alt="' . $LANG->getLL( 'ViewSendPromotion_status_1' ) . '" title="' . $LANG->getLL( 'ViewSendPromotion_status_1' ) . '">&nbsp;' . $LANG->getLL( 'ViewSendPromotion_status_1' ) . '<br />';
		$content .= '<img src="promotion_status_2.gif" border="0" alt="' . $LANG->getLL( 'ViewSendPromotion_status_2' ) . '" title="' . $LANG->getLL( 'ViewSendPromotion_status_2' ) . '">&nbsp;' . $LANG->getLL( 'ViewSendPromotion_status_2' );

		return $content;
	}

	/**
	 * getViewImportCategoriesLinks( $type = null, $table = null, $generateQuery = null )
	 *
	 * Imports categories and links.
	 *
	 * @param	string		$type	What type of record to import.
	 * @param	string		$table	The table name if selected.
	 * @param	string		$generateQuery	If the generateQuery button was pressed.
	 * @return	string		The generated HTML source for this view.
	 */
	function getViewImportCategoriesLinks( $type = null, $table = null, $generateQuery = null )	{
		global $LANG;

		// Init some vars
		$content = null;
		$doc = get_object_vars( $this->doc);

		// Output header and description
		$content .= $LANG->getLL( 'ViewImportCategoriesLinks_text') . '<br /><br />';

		// Step 1: Show type form
		$types = array( '', 'categories', 'links' );

		$content .= '<img src="import_step_1.gif" border="0" /> <b>Select what you want to import:</b><br />';
		$content .= '<form action=""><select name="type" onchange="jumpToUrl(\'?id=' . $this->id . '&amp;type=\'+this.options[this.selectedIndex].value,this);">';
		foreach( $types as $typesType )	{
			if( $type == $typesType )	{
				$content .= '<option value="' . $typesType  . '" selected="selected">' . $typesType . '</option>';
			} else	{
				$content .= '<option value="' . $typesType  . '">' . $typesType . '</option>';
			}
		}

		$content .= '</select></form><br /><br />';

		// Step 2: Show table form
		if( $type != null )	{
			$tableBlacklist = array( 'sys_', 'cache_', 'fe_', 'be_', 'index_', 'static_', 'pages', 'tx_ablinklist' );

			$content .= '<img src="import_step_2.gif" border="0" /> <b>Select the foreign database table where to import the ' . $type . ' from:</b><br />';
			$content .= '<form action=""><select name="table" onchange="jumpToUrl(\'?id=' . $this->id . '&amp;type=' . $type . '&amp;table=\'+this.options[this.selectedIndex].value,this);">';
			$content .= '<option value=""></option>';

			$tables = $GLOBALS['TYPO3_DB']->sql_query( 'SHOW TABLES;' );
			while( $row = $GLOBALS['TYPO3_DB']->sql_fetch_row( $tables ) )	{
				$hide = false;

				foreach( $tableBlacklist as $index => $value )	{
					if( ereg( '^' . $value, $row[0] ) )
						$hide = true;
				}

				if( !$hide )	{
					$content .= '<option value="' . $row[0];

					if( $row[0] == $table )	{
						$content .= '" selected="selected">' . $row[0] . '</option>';
					} else	{
						$content .= '">' . $row[0] . '</option>';
					}

					$content .= "\n";
				}
			}

			$content .= '</select></form><br /><br />';
		}

		// Step 3: Show fields form
		if( $type != null && $table != null )	{
			$fields = $GLOBALS['HTTP_GET_VARS']['field'];
			$defines = $GLOBALS['HTTP_GET_VARS']['define'];

			$fieldBlacklist = array( );

			$content .= '<img src="import_step_3.gif" border="0" /> <b>Assign the foreign database fields to the available database fields of this extension:</b><br />';
			$content .= '<div style="color:red;">Please notice: If you have added "Modern Linklist" ' . $type . ' already <b>don\'t</b> assign or define the "uid" field because then your ' . $type . ' could get overwritten!<br />Just leave the field blank in this case.</div>';
			$content .= '<form action=""><table border="1"><tr><td><b>Database field</b></td><td><b>Foreign field</b></td><td><b>Manually defined value</b></td></tr>';

			$fieldTable = ( $type == 'categories' ) ? 'category' : 'link';
			$extensionFields = $GLOBALS['TYPO3_DB']->sql_query( 'SHOW FIELDS FROM ' . $this->tablePrefix . $fieldTable . ';' );

			while( $row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc( $extensionFields ) )	{
				$hide = false;

				foreach( $fieldBlacklist as $index => $value )	{
					if( ereg( '^' . $value, $row['Field'] ) )
						$hide = true;
				}

				if( !$hide )	{
					$content .= '<tr><td>' . $row['Field'] . '</td><td><select name="field[' . $row['Field'] . ']">';

					$foreignFields = $GLOBALS['TYPO3_DB']->sql_query( 'SHOW FIELDS FROM ' . $table . ';' );
					$content .= '<option value=""></option>';

					while( $row2 = $GLOBALS['TYPO3_DB']->sql_fetch_assoc( $foreignFields ) )	{
						$content .= '<option value="' . $row2['Field'];

						if( $row2['Field'] == $fields[$row['Field']] )	{
							$content .= '" selected="selected">' . $row2['Field'] . '</option>';
						} else	{
							$content .= '">' . $row2['Field'] . '</option>';
						}
					}

					$content .= '</select></td>';
					$content .= '<td><input type="text" name="define[' . $row['Field'] . ']"';
					if( $defines[$row['Field']] != null && $fields[$row['Field']] == null )	{
						 $content .= 'value="' . $defines[$row['Field']] . '" /></td></tr>';
					} else	{
						 $content .= '/></td></tr>';
					}
					$content .= "\n";
				}
			}

			$content .= '</table><br />';
			$content .= '<input type="submit" name="generateQuery" value="Generate SQL query" />';
			$content .= '<input type="hidden" name="type" value="' . $type . '" />';
			$content .= '<input type="hidden" name="table" value="' . $table . '" />';
			$content .= '<input type="hidden" name="id" value="' . $this->id . '" />';
			$content .= '</form><br /><br />';
		}

		// Step 4: Show query
		if( $type != null && $table != null && $generateQuery != null )	{
			$content .= '<img src="import_step_4.gif" border="0" /> <b>Use the following SQL query to import the ' . $type . ' manually:</b><br />';

			$content .= '<div style="border:solid 1px;padding:5px;background-color:' . $doc['bgColor4'] . ';">INSERT INTO ' . $this->tablePrefix . $fieldTable . ' SELECT ';
			$i = 0;
			while( list( $extensionField, $foreignField ) = each( $fields ) )	{
				if( $foreignField != null )	{
					$content .= $foreignField . ' AS ' . $extensionField . ', ';
				} else	{
					if( $defines[$extensionField] != null )	{
						$content .= $defines[$extensionField] . ' AS ' . $extensionField;
					} else	{
						$content .= '\'\' AS ' . $extensionField;
					}

					if( $i != count( $fields ) - 1 )	{
						$content .= ', ';
					}
				}

				$i++;
			}

			$content .= ' FROM ' . $table . ';</div>';
		}

		return $content;
	}

	/**
	 * getViewPromoteLink( $uid, $error )
	 *
	 * Displays the "Promote Link" view.
	 *
	 * @param	integer		$uid	UID of the link record.
	 * @param	boolean		$error	True if an error occured.
	 * @return	string		The generated HTML source for this view.
	 */
	function getViewPromoteLink( $uid = null, $error )	{
		global $LANG;

		// Init some vars
		$content = null;
		$doc = get_object_vars( $this->doc);

		if( $uid != null )	{

			if( $error )	{
				$content = $LANG->getLL( 'ViewSendPromotion_promote_link_error');
			} else	{
				$content = $LANG->getLL( 'ViewSendPromotion_promote_link_text');
			}

			$content .= '<br /><br />';
			$content .= "<a href=\"index.php?id=" . $this->id. "\">" . $LANG->getLL( 'label_back') . '</a>';
			$content .= '<hr />';

			return $content;
		}
	}

	/**
	 * doAcceptLink( $uid )
	 *
	 * Updates the status of a link in the database to '1' (--> Approved ).
	 * So the link is displayed after that.
	 *
	 * @param	integer		$uid	UID of the link record.
	 * @return	void
	 */
	function doAcceptLink( $uid = null )	{
		if( $uid != null )	{

			// Get link from database
			$theTable = $this->tablePrefix . 'link';
			$theField = 'uid';
			$theValue = $uid;
			$whereClause = 'AND sys_language_uid=0 AND deleted=0 AND hidden=0';
			$groupBy = '';
			$orderBy = '';
			$limit = '';
			$link = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows( 'label,description,href,category', $theTable, $theField . '=' . $GLOBALS['TYPO3_DB']->quoteStr( $theValue, $theTable ) . ' ' . $whereClause, $groupBy, $orderBy, $limit );			

			// Get variables from POST values or database record
			$label = $GLOBALS['HTTP_POST_VARS']['label'] ? $GLOBALS['HTTP_POST_VARS']['label'] : $link[0]['label'];
			$description = $GLOBALS['HTTP_POST_VARS']['description'] ? $GLOBALS['HTTP_POST_VARS']['description'] : $link[0]['description'];
			$href = $GLOBALS['HTTP_POST_VARS']['href'] ? $GLOBALS['HTTP_POST_VARS']['href'] : $link[0]['href'];
			$categoryUID = $GLOBALS['HTTP_POST_VARS']['categoryUID'] ? $GLOBALS['HTTP_POST_VARS']['categoryUID'] : $link[0]['category'];

			if( $this->debug )	{
				echo urldecode( $_SERVER['QUERY_STRING'] ) . "<br />";
				echo "uid: " . $uid . "<br />";
				t3lib_div::print_array( $link );
			}

			// Update the link record
			$whereClause = "uid=$uid";
			$updateFields = array(
					'label' => $label,
					'description' => $description,
					'href' => $href,
					'status' => '1',
					'category' => $categoryUID,
			);
			$GLOBALS['TYPO3_DB']->exec_UPDATEquery( $this->tablePrefix . 'link', $whereClause, $updateFields );
		}
	}

	/**
	 * doDisableLink( $uid )
	 *
	 * Updates the status of a link in the database to '3' (--> Disabled ).
	 * So the link will not be displayed any further.
	 *
	 * @param	integer		$uid	UID of the link record.
	 * @return	void
	 */
	function doDisableLink( $uid = null )	{
		if( $uid != null )	{
			// Update the link record
			$whereClause = "uid=$uid";
			$updateFields = array(
					'status' => '3',
			);
			$GLOBALS['TYPO3_DB']->exec_UPDATEquery( $this->tablePrefix . 'link', $whereClause, $updateFields );
		}
	}

	/**
	 * doDeleteLink( $uid )
	 *
	 * Deletes the link with given UID from the database.
	 *
	 * @param	integer		$uid	UID of the link record.
	 * @return	void
	 */
	function doDeleteLink( $uid = null )	{
		if( $uid != null )	{
			// Delete link from database
			$theTable = $this->tablePrefix . 'link';
			$whereClause = "uid=$uid";
			$GLOBALS['TYPO3_DB']->exec_DELETEquery( $theTable, $whereClause );
		}
	}

	/**
	 * doPromoteLink( $uid )
	 *
	 * Promotes the link with given UID.
	 *
	 * @param	integer		$uid	UID of the link record.
	 * @return	void
	 */
	function doPromoteLink( $uid = null )	{
		if( $uid != null )	{
			// Get flexform config
			$theTable = 'tt_content';
			$whereClause = 'pid=' . $this->id . ' AND list_type="ab_linklist_pi1" AND deleted=0';
			$groupBy = '';
			$orderBy = '';
			$limit = '';
			$flexform = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows( '*', $theTable, $whereClause, $groupBy, $orderBy, $limit );
			$flexarray = t3lib_div::xml2array( $flexform[0]['pi_flexform'] );

			if( $this->debug )
				t3lib_div::print_array( $flexarray );

			if( is_array( $flexarray ) )	{
				$adminEmail = $flexarray['data']['sDEF']['lDEF']['adminEmail']['vDEF'];
				$subject = $flexarray['data']['s_promotion']['lDEF']['emailSubject']['vDEF'];
				$text = $flexarray['data']['s_promotion']['lDEF']['emailText']['vDEF'];
				$bccToAdmin = $flexarray['data']['s_promotion']['lDEF']['bccToAdmin']['vDEF'];
				$image = $flexarray['data']['s_promotion']['lDEF']['emailImage']['vDEF'];
			} else	{
				return true;
			}

			if( !$adminEmail || !$subject || !$text )	{
				return true;
			} else	{
/*
				// Get template config
				$theTable = 'sys_template';
				$whereClause = 'pid=' . $this->id . ' AND deleted=0';
				$groupBy = '';
				$orderBy = '';
				$limit = '';
				$configResult = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows( '*', $theTable, $whereClause, $groupBy, $orderBy, $limit );
				$config = $configResult[0]['config'];
				echo $config['date_stdWrap.'];
*/
				// Get link values
				$theTable = $this->tablePrefix . 'link';
				$theField = 'uid';
				$theValue = $uid;
				$whereClause = 'AND sys_language_uid=0 AND deleted=0 AND hidden=0';
				$groupBy = '';
				$orderBy = '';
				$limit = '';
				$link = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows( '*', $theTable, $theField . '=' . $GLOBALS['TYPO3_DB']->quoteStr( $theValue, $theTable ) . ' ' . $whereClause, $groupBy, $orderBy, $limit );
	
				$email = $link[0]['contact'];
	
				// Send the promotion e-mail
				$boundary = md5( time().rand( 1, 100 ) );
				$encoding = $GLOBALS['TSFE']->tmpl->setup['config.']['notification_email_encoding'] ? $GLOBALS['TSFE']->tmpl->setup['config.']['notification_email_encoding'] : 'quoted-printable';
				$charset = $GLOBALS['TSFE']->tmpl->setup['config.']['notification_email_charset'] ? $GLOBALS['TSFE']->tmpl->setup['config.']['notification_email_charset'] : 'ISO-8859-1';

				$headers = "From: \"Modern Linklist\" <$adminEmail>\n";

				if( $bccToAdmin == 1 )
					$headers .= "Bcc: $adminEmail\n";

				$headers .= "Mime-Version: 1.0\n";

				if( $image )	{
					$headers .= "Content-Type: multipart/mixed;\n boundary=\"$boundary\"\n";
					$message = "This is a multi-part message in MIME format.\n\n--$boundary\n" .
						   "Content-Type: text/plain;\n charset=\"$charset\"\n" .
						   "Content-Transfer-Encoding: $encoding\n";
				} else	{
					$headers .= "Content-Type: text/plain;\n charset=\"$charset\"\n" .
						    "Content-Transfer-Encoding: $encoding\n";
					$message = '';
				}

				$headers .= "X-Mailer: Modern Linklist Info Mailer\n";

				// Create replacement array and replace the markers in the email message
				$replacements = array(
//					'###date###' => stdWrap( $link[0]['crdate'], $this->conf['date_stdWrap.'] ),
					'###label###' => $link[0]['label'],
					'###href###' => $link[0]['href'],
				);

				// Do the replacements
				foreach( $replacements as $marker => $value )	{
					$text = str_replace( $marker, $value, $text );
				}
				$message .= $text . "\n\n";

				// Add attachment
				if( $image )	{
					$filetype = 'image/' . substr( strrchr( $image, '.' ), 1 );

					$message .= "--$boundary\nContent-type: $filetype;\n name=\"$image\"\n";
					$message .= "Content-Transfer-Encoding: base64\nContent-Disposition: attachment;\n filename=\"$image\"\n";

					$lineSize = filesize( PATH_site . 'uploads/tx_ablinklist/' . $image ) + 1;

					$fp = fopen( PATH_site . 'uploads/tx_ablinklist/' . $image, 'r' );
					$content = chunk_split( base64_encode( fread( $fp, $lineSize ) ) );
					fclose( $fp );

					$message .= $content;
				}

//				t3lib_div::plainMailEncoded( $email, $subject, $message, $headers, $encoding );
				mail( $email, $subject, $message, $headers );

				// Update the promotion status
				$whereClause = "uid=$uid";
				$updateFields = array(
						'promotion_status' => '1',
				);
				$GLOBALS['TYPO3_DB']->exec_UPDATEquery( $this->tablePrefix . 'link', $whereClause, $updateFields );

				return false;
			}
		}
	}

	/**
	 * doPromoteLinkConfirm( $uid )
	 *
	 * Confirms the promotion of the link with given UID.
	 *
	 * @param	integer		$uid	UID of the link record.
	 * @return	void
	 */
	function doPromoteLinkConfirm( $uid = null )	{
		if( $uid != null )	{
			// Update the promotion status
			$whereClause = "uid=$uid";
			$updateFields = array(
					'promotion_status' => '2',
			);
			$GLOBALS['TYPO3_DB']->exec_UPDATEquery( $this->tablePrefix . 'link', $whereClause, $updateFields );
		}
	}

	/**
	 * doCheckLink( $href )
	 *
	 * Checks if a link is online or offline.
	 *
	 * @param	string		The link to check.
	 * @return	boolean		TRUE if online, FALSE otherwise.
	 */
	function doCheckLink( $href )	{
		// Extract the url from href
		$href = explode( ' ', $href );
		$href = $href[0];

		// Parse the link
		$url = parse_url( $href );

		// Set timeout
		$timeout = 20;

		// Check if scheme is present and add http:// otherwise
		if( $url['scheme'] == null || $url['scheme'] == '' )	{
			$url['scheme'] = 'http';
		}

		// Check if curl shall be used
		if( $GLOBALS['TYPO3_CONF_VARS']['SYS']['curlUse'] == '1' )	{

			$ch = curl_init();
			curl_setopt( $ch, CURLOPT_URL, $href );
			curl_setopt( $ch, CURLOPT_HEADER, 0 );
			curl_setopt( $ch, CURLOPT_TIMEOUT, $timeout );
			curl_setopt( $ch, CURLOPT_RETURNTRANSFER, 1 );
			curl_setopt( $ch, CURLOPT_HEADER, 1 );
			curl_setopt( $ch, CURLOPT_NOBODY, 1 );

			// Check if a proxy server shall be used
			if ( $GLOBALS['TYPO3_CONF_VARS']['SYS']['curlProxyServer'] )	{
				curl_setopt( $ch, CURLOPT_PROXY, $GLOBALS['TYPO3_CONF_VARS']['SYS']['curlProxyServer'] );
			 
				if ( $GLOBALS['TYPO3_CONF_VARS']['SYS']['curlProxyTunnel'])	{
					curl_setopt( $ch, CURLOPT_HTTPPROXYTUNNEL, $GLOBALS['TYPO3_CONF_VARS']['SYS']['curlProxyTunnel'] );
				}
				if ( $GLOBALS['TYPO3_CONF_VARS']['SYS']['curlProxyUserPass'])	{
					curl_setopt( $ch, CURLOPT_PROXYUSERPWD, $GLOBALS['TYPO3_CONF_VARS']['SYS']['curlProxyUserPass'] );
				}
			}
			curl_exec( $ch );

			if( curl_getinfo( $ch, CURLINFO_HTTP_CODE ) != '200' )	{
				return false;
			} else	{
				return true;
			}

			curl_close( $ch );

		} else	{
			// Use the standard fopen method
			@$fp = fsockopen( $url['host'], 80, $errno, $errstr, $timeout );

			// Return
			if( !$fp )	{
				return false;
			} else	{
				// Check the path
				socket_set_timeout( $fp, $timeout );

				// Append query parameters and anchors to the path
				if ( strlen( $url['path'] ) > 1 )	{
					$path .= $url['path'];
				}
				if ( strlen( $url['query'] ) > 1 )	{
					$path .= '?' . $url['query'];
				}
				if ( strlen( $url['fragment'] ) > 1 )	{
					$path .= '#' . $url['fragment'];	
				}

				// Do the check
				if( $path != '' && $path != null )	{
					$queryString = "GET $path HTTP/1.0\r\nHost: " . $url['host'] . "\r\nConnection: Keep-Alive\r\nUser-Agent: Modern Linklist Link Checker\r\n";
					$queryString .= "\r\n";
					
					fputs( $fp, $queryString );
					
					$queryResponse = fgets( $fp );
					
					if ( substr_count( $queryResponse, '200 OK' ) > 0 )	{
						// Path and filename exist
						fclose( $fp );
						return true;
					} else	{ 
						// Path and filename don't exist
						fclose( $fp );
						return false;
					}
				  }

				  fclose( $fp );
				  return true;
			}
		}
	}

	/**
	 * This is a copy of the function pi_list_browseresults from class.tslib_piBase.php
	 * Returns a results browser. This means a bar of page numbers plus a "previous" and "next" link. For each entry in the bar the piVars "$pointerName" will be pointing to the "result page" to show.
	 * Using $this->piVars['$pointerName'] as pointer to the page to display
	 * Using $this->internal['res_count'], $this->internal['results_at_a_time'] and $this->internal['maxPages'] for count number, how many results to show and the max number of pages to include in the browse bar.
	 *
	 * @param	boolean		If set (default) the text "Displaying results... " will be show, otherwise not.
	 * @param	string		Attributes for the table tag which is wrapped around the table cells containing the browse links
	 * @param	string		varname for the pointer
	 * @return	string		Output HTML, wrapped in <div>-tags with a class attribute
	 */
	function makePageBrowser( $showResultCount = 1, $tableParams = '', $pointerName = 'pointer' )	{
		global $LANG;

		// Initializing variables:
		$pointer = intval( $GLOBALS['HTTP_GET_VARS'][$pointerName] );
		$count = $this->internal['res_count'];
		$results_at_a_time = t3lib_div::intInRange( $this->internal['results_at_a_time'], 1, 1000);
		$maxPages = t3lib_div::intInRange( $this->internal['maxPages'], 1, 100);
		$max = t3lib_div::intInRange( ceil( $count/$results_at_a_time), 1, $maxPages );
		$links = array();

		// Make browse-table/links:
		if( $pointer > 0 )	{
			$links[] = '<td nowrap="nowrap"><p><a href="?id=' . $this->id . '&amp;' . $pointerName . '=' . ( $pointer - 1 ? $pointer - 1 : '' ) . '">&laquo;</a></p></td>';
		} elseif( $this->pi_alwaysPrev )	{
			$links[] = '<td nowrap="nowrap"><p>Previous</p></td>';
		}

		for( $a = 0; $a < $max; $a++ )	{
			if( $pointer != $a )	{
				$links[] = '<td nowrap="nowrap"><p><a href="?id=' . $this->id . '&amp;' . $pointerName . '=' . ( $a ? $a : '' ) . '">' . ( $a + 1 ) . '</a></p></td>';
			} else	{
				$links[] = '<td nowrap="nowrap"><p>' . ( $a + 1 ) . '</p></td>';
			}
		}

		if( $pointer < ceil( $count/$results_at_a_time ) - 1 )	{
			$links[] = '<td nowrap="nowrap"><p><a href="?id=' . $this->id . '&amp;' . $pointerName . '=' . ( $pointer + 1 ) . '">&raquo;</a></p></td>';
		}

		$pR1 = $pointer * $results_at_a_time + 1;
		$pR2 = $pointer * $results_at_a_time + $results_at_a_time;
		$sTables = '
			<!--
			 List browsing box:
			-->
			<div>' . ( $showResultCount ? '<p>' .
				( $this->internal['res_count'] ?
				   sprintf(
				 str_replace( '###SPAN_BEGIN###', '<span>', $LANG->getLL( 'pi_list_browseresults_displays', 'Displaying results ###SPAN_BEGIN###%s to %s</span> out of ###SPAN_BEGIN###%s</span>' ) ),
				 $this->internal['res_count'] > 0 ? $pR1 : 0,
				 min(array( $this->internal['res_count'], $pR2) ),
				 $this->internal['res_count']
				) :
				$LANG->getLL( 'pi_list_browseresults_noResults', 'Sorry, no items were found. ' ) ) . '</p>' : '' ) . '

			   <' .trim( 'table ' . $tableParams ) . '>
				<tr>
				 ' .implode( '', $links ) . '
				</tr>
			   </table>
			  </div>';

		return $sTables;
	}
}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/ab_linklist/mod1/index.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/ab_linklist/mod1/index.php']);
}

// Make instance:
$SOBE = t3lib_div::makeInstance('tx_ablinklist_module1');
$SOBE->init();

// Include files?
reset( $SOBE->include_once);
while( list(, $INC_FILE) = each( $SOBE->include_once) )	{ include_once( $INC_FILE); }

$SOBE->main();
$SOBE->printContent();
?>
