<?php
/***************************************************************
* Copyright notice
*
* (c) 2005 Andreas Bulling (typo3@taekwondo-homepage.de)
* All rights reserved
*
* This script is part of the TYPO3 project. The TYPO3 project is
* free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* The GNU General Public License can be found at
* http:// www.gnu.org/copyleft/gpl.html.
*
* This script is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

/**
 * [CLASS/FUNCTION INDEX of SCRIPT]
 *
 *
 *
 *   71: class tx_ablinklist_pi1 extends tslib_pibase
 *   94:     function main( $content, $conf )
 *+  307:     function displayList( $categoryUID = 0 )
 *+  679:     function displayTree( $categoryUID = 0, $level = 0 )
 *  942:     function displaySearch()
 *- 1216:     function displayTop( $categoryUID = 0 )
 * 1343:     function getViewClickedLink( $uid = null )
 * 1393:     function getViewDetailsForLink( $uid = null, $categoryUID )
 * 1487:     function getViewAddNewLink( $categoryUID, $errormsg = null )
 * 1584:     function getViewAddNewLinkResult( $categoryUID = 0 )
 * 1706:     function getViewReportBrokenLink( $uid = null, $categoryUID )
 * 1777:     function getViewReportBrokenLinkResult( $uid = null, $categoryUID )
 * 1856:     function getViewRateLink( $uid = null, $categoryUID )
 * 1933:     function getViewRateLinkResult( $uid = null, $categoryUID )
 * 2013:     function makePageBrowser( $pointerName = 'pointer' )
 * 2068:     function userProcess( $configKey, $variable )
 * 2086:     function initPidList()
 *- 2110:     function recursiveLinkCount( $categoryUID )
 * 2173:     function recursiveCategoryGet( $categoryUID )
 * 2215:     function getCategoryPath( $categoryUID, $showLinks = true )
 * 2298:     function getRecordOverlay( &$resultSet, $databaseTable )
 * 2325:     function getCategorySelect( $categoryUID, $selectedID = 0 )
 * 2382:     function displayFEHelp( $type )
 * 2399:     function validURI( $href )
 * 2416:     function containsBlacklistedWords( $text )
 * 2441:     function returnStarsForRating( $rating )
 *
 * TOTAL FUNCTIONS: 25
 * (This index is automatically created/updated by the extension "extdeveval")
 *
 */

require_once( PATH_tslib . 'class.tslib_pibase.php' );

/**
 * Plugin 'linklist' for the 'ab_linklist' extension.
 *
 * @author	Andreas Bulling	<typo3@taekwondo-homepage.de>
 * @package TYPO3
 * @subpackage	tx_ablinklist
 */
class tx_ablinklist_pi1 extends tslib_pibase {
	var $prefixId = 'tx_ablinklist_pi1';				// Same as class name
	var $scriptRelPath ='pi1/class.tx_ablinklist_pi1.php';		// Path to this script relative to the extension directory.
	var $extKey = 'ab_linklist';					// The extension key.
	var $tablePrefix = 'tx_ablinklist_';				// The database table prefix.
	var $originalTemplateCode = null;				// Holds template code.
	var $cObj;							// Reference to the calling cObj.
	var $debug = false;						// Global debug switch. Change to 'true' for debugging information.
	var $full_debug = false;					// Full debug switch. Change to 'true' for full debugging information.
	var $sysfolderList = null;					// Holds the 'Starting Point' PIDs.
	var $flexform = null;						// Holds the flexform configuration for the plugin.
	var $pi_checkCHash = true;					// Enable cHash check.
	var $allowCaching;						// Holds cache setting.
	var $sys_language_mode;					// Holds the language mode.
	var $linkMode;							// Holds the link mode.

	/**
	 * Main function: Decides by the given CODE(s) which of the views to display.
	 *
	 * @param	string		$content Function output is added to this.
	 * @param	array		$conf Configuration array.
	 * @return	string		$content Complete content generated by the tx_ablinklist plugin.
	 */
	function main( $content, $conf )	{

		// Initialize new cObj object
		$this->local_cObj = t3lib_div::makeInstance( 'tslib_cObj' );

		// Init config for flexform
		$this->pi_initPIflexForm();
		$this->flexform = $this->cObj->data['pi_flexform'];

		// Initialize new FreeCap object
		$useCaptchaLibrary = $this->pi_getFFvalue( $this->flexform, 'useCaptchaLibrary', 'sDEF' );

		if( t3lib_extMgm::isLoaded( 'sr_freecap' ) && $useCaptchaLibrary )	{
			require_once( t3lib_extMgm::extPath( 'sr_freecap' ) . 'pi2/class.tx_srfreecap_pi2.php' );
			$this->freeCap = t3lib_div::makeInstance( 'tx_srfreecap_pi2' );
		}

		// Do some configuration
		$this->conf = $conf;
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();

		// Configure caching
		$this->allowCaching = $this->conf['allowCaching'] ? 1 : 0;
		if ( !$this->allowCaching ) {
			$GLOBALS['TSFE']->set_no_cache();
		}
		$this->pi_USER_INT_obj = 0;

		// Get the 'Starting Point' PID(s)
		if( $this->cObj->data['pages'] != null )	{
			$this->sysfolderList = $this->cObj->data['pages'];
		} else	{
			// If no 'Starting Point' is defined use the PID of the plugin page
			$this->sysfolderList = $GLOBALS['TSFE']->id;
		}

		// Extend enable fields
		$this->enableFields = ' AND '.$this->tablePrefix . 'link'.'.sys_language_uid=0 AND '.$this->tablePrefix . 'link'.'.pid IN (' . $this->sysfolderList . ')' . $this->cObj->enableFields( $this->tablePrefix . 'link' );
		$this->enableFieldsCategory = ' AND '.$this->tablePrefix . 'category'.'.sys_language_uid=0 AND  '.$this->tablePrefix . 'category'.'.pid IN (' . $this->sysfolderList . ')' . $this->cObj->enableFields( $this->tablePrefix . 'category' );

		// Set sys_language_mode
		$this->sys_language_mode = $GLOBALS['TSFE']->sys_language_mode;

		// Debugging output
		if( $this->debug )	{
			$GLOBALS['TSFE']->set_no_cache();

			t3lib_div::print_array( $conf );

			if( $this->full_debug )
				t3lib_div::print_array( get_object_vars( $GLOBALS['TSFE'] ) );

			echo "<br />FLEXFORM CONFIGURATION:<br />";
			t3lib_div::print_array( $this->flexform );
			echo "<br />";
		}

		// Set the template
		$templateFile = $this->pi_getFFvalue( $this->flexform, 'templateFile', 's_template' );
		$this->originalTemplateCode = $this->cObj->fileResource( $templateFile ? "uploads/tx_ablinklist/" . $templateFile : $this->conf['templateFile'] );

		// Get category UID from piVars or FlexForm or set to 0
		$startCategoryID = intval( $this->pi_getFFvalue( $this->flexform, 'startCategoryID', 's_display' ) );
		$categoryUID = intval( $this->piVars['category_uid'] ) ? intval( $this->piVars['category_uid'] ) : ( $startCategoryID ? $startCategoryID : 0 );

		// Get code
		$code = $this->pi_getFFvalue( $this->flexform, 'whatToDisplay', 'sDEF' );
		$this->conf['code'] = $code ? $code : 'LIST';

		// Get the view mode(s)
		$viewModes = t3lib_div::trimExplode( ',', $this->conf['code'], 1 );
		if( !count( $viewModes ) )	{
			$viewModes = array();
		}

		// Set link mode for getCategoryPath()
		foreach( $viewModes as $id => $viewMode )	{
			switch ( $viewMode )	{
				case 'TREE':
					$this->linkMode = 'TREE';
				break;

				default:
					$this->linkMode = 'LIST';
				break;
			}
		}

		// Get action
		$action = htmlspecialchars( $this->piVars['action'] );

		// 'getviewcategory' has to be excluded as it's only used in the LIST view
		if( $action != null && $action != 'getviewcategory' )	{
			// Get link UID
			$uid = intval( $this->piVars['uid'] );

			switch( $action )	{
				case 'getviewclickedlink':
					$content = $this->getViewClickedLink( $uid );
				break;

				case 'getviewdetailsforlink':
					$content = $this->getViewDetailsForLink( $uid, $categoryUID );
				break;

				case 'getviewaddnewlink':
					if( htmlspecialchars( $this->piVars['submit_button'] ) != null )	{
						$label = htmlspecialchars( strip_tags( $this->piVars['label'] ) );
						$href = htmlspecialchars( strip_tags( $this->piVars['href'] ) );
						$contact = htmlspecialchars( strip_tags( $this->piVars['contact'] ) );
						$description = htmlspecialchars( strip_tags( $this->piVars['description'] ) );
						$captchaResponse = htmlspecialchars( strip_tags( $this->piVars['captchaResponse'] ) );
						$selectedCategoryUID = intval( $this->piVars['selectedCategoryUID'] ) ? intval( $this->piVars['selectedCategoryUID'] ) : $categoryUID;

						if( $label == null || $href == null || $description == null || ( is_object( $this->freeCap ) && $captchaResponse == null ) )	{
							$errormsg = $this->pi_getLL( 'error_required_not_filled' );
							$content = $this->getViewAddNewLink( $categoryUID, $errormsg );
						} elseif( $contact != null && !t3lib_div::validEmail( $contact ) )	{
							$errormsg = $this->pi_getLL( 'error_invalid_contact' );
							$content = $this->getViewAddNewLink( $categoryUID, $errormsg );
						} elseif( $href != null && !$this->validURI( $href ) )	{
							$errormsg = $this->pi_getLL( 'error_invalid_href' );
							$content = $this->getViewAddNewLink( $categoryUID, $errormsg );
						} elseif( ( $label != null && $this->containsBlacklistedWords( $label ) ) || ( $description != null && $this->containsBlacklistedWords( $description ) ) )	{
							$errormsg = $this->pi_getLL( 'error_blacklisted_words' );
							$content = $this->getViewAddNewLink( $categoryUID, $errormsg );
						} elseif( is_object( $this->freeCap ) && !$this->freeCap->checkWord( $captchaResponse ) )	{
							$errormsg = $this->pi_getLL( 'error_invalid_captcha' );
							$content = $this->getViewAddNewLink( $categoryUID, $errormsg );
						} else	{
							$content = $this->getViewAddNewLinkResult( $selectedCategoryUID );
						}
					} elseif( htmlspecialchars( $this->piVars['cancel_button'] ) != null )	{
						if( $this->linkMode == 'TREE' )	{
							// FIXME: startCategoryID not taken into account
							$content = $this->displayTree();
						} else	{
							$content = $this->displayList( $categoryUID );
						}
					} else	{
						$content = $this->getViewAddNewLink( $categoryUID );
					}
				break;

				case 'getviewreportbrokenlink':
					if( htmlspecialchars( $this->piVars['submit_button'] ) != null )	{
						$content = $this->getViewReportBrokenLinkResult( $uid, $categoryUID );
					} elseif( htmlspecialchars( $this->piVars['cancel_button'] ) != null )	{
						if( $this->linkMode == 'TREE' )	{
							// FIXME: startCategoryID not taken into account
							$content = $this->displayTree();
						} else	{
							$content = $this->displayList( $categoryUID );
						}
					} else	{
						$content = $this->getViewReportBrokenLink( $uid, $categoryUID );
					}
				break;

				case 'getviewratelink':
					if( htmlspecialchars( $this->piVars['submit_button'] ) != null )	{
						$content = $this->getViewRateLinkResult( $uid, $categoryUID );
					} elseif( htmlspecialchars( $this->piVars['cancel_button'] ) != null )	{
						if( $this->linkMode == 'TREE' )	{
							// FIXME: startCategoryID not taken into account
							$content = $this->displayTree();
						} else	{
							$content = $this->displayList( $categoryUID );
						}
					} else	{
						$content = $this->getViewRateLink( $uid, $categoryUID );
					}
				break;
			}

			// Don't display any further content
			return $this->pi_wrapInBaseClass( $content );
		}

		// Display main view(s)
		foreach( $viewModes as $id => $view )	{
			switch ( $view )	{
				case 'LIST':
					$content .= $this->displayList( $categoryUID );
				break;

				case 'TREE':
					$content .= $this->displayTree( $categoryUID );
				break;

				case 'SEARCH':
					$content .= $this->displaySearch();
				break;

				case 'TOP':
					$content .= $this->displayTop( $categoryUID );
				break;
			}
		}

		return $this->pi_wrapInBaseClass( $content );
	}

	/**
	 * displayList( $categoryUID = 0 )
	 *
	 * Generates the html for the list view of this extension. In this view the current category with its
	 * subcategories and links is shown.
	 *
	 * @param	integer		$categoryUID	UID of the category that shall be shown.
	 * @return	string		The generated HTML source for this view.
	 */
	function displayList( $categoryUID = 0 )	{

		// Init some vars
		$action = 'getviewcategory';
		$content = '';
		$templateCode = null;
		$conf['subpartMarker'] = 'VIEW_CATEGORY';
		$subSub_1 = 'CATEGORIES';
		$subSub_2 = 'LINKS';
		$subSub_3 = 'PATHMENU';
		$subSub_4 = 'ADDITIONAL';
		$subSubSub_1 = 'CATEGORY';
		$subSubSub_2 = 'LINK';

		// Get the html source between subpart markers from the template file
		$templateCode = $this->cObj->getSubpart( $this->originalTemplateCode, "###" . $conf['subpartMarker'] . '###' );

		// Get local config
		$localConf = $this->conf['listView.'];

		// Save original ATagParams
		$originalATagParams = $GLOBALS['TSFE']->ATagParams;

		/**
		 * CATEGORY PATH
		 */

		// Create marker array
		$markerArray = array();
		$markerArray['###CATEGORY_PATH###'] = $this->local_cObj->stdWrap( $this->getCategoryPath( $categoryUID ), $localConf['categoryPath_stdWrap.'] );

		// Substitute the markers in the given sub sub part
		$subpartContent = null;
		$subpartContent = $this->cObj->substituteMarkerArray( $this->cObj->getSubpart( $templateCode, "###" . $subSub_3. '###' ), $markerArray );

		// Substitute the template code with the given subpartcontent
		$templateCode = $this->cObj->substituteSubpart( $templateCode, $subSub_3, $subpartContent );

		/**
		 * ADD LINK
		 */

		// Check if anonymous users are allowed to add links
		$allowAddLinks = $this->pi_getFFvalue( $this->flexform, 'allowAddLinks', 'sDEF' ) ? $this->pi_getFFvalue( $this->flexform, 'allowAddLinks', 'sDEF' ) : $this->conf['allowAddLinks'];

		// Check if a frontend user is logged in
		$isLoggedIn = $GLOBALS['TSFE']->loginUser;

		// Create add link
		if( $isLoggedIn == 1 || $allowAddLinks == 1 )	{
			// Create marker array
			$markerArray = array();

			$GLOBALS['TSFE']->ATagParams = $GLOBALS['TSFE']->ATagParams . ( $localConf['linkAddNew.']['ATagParams'] ? ' ' . $localConf['linkAddNew.']['ATagParams'] : '' );
			$link = $this->pi_LinkTP( $this->pi_getLL( 'll_add_link' ), array( 'tx_ablinklist_pi1[action]' => 'getviewaddnewlink', 'tx_ablinklist_pi1[category_uid]' => $categoryUID ), $this->allowCaching );
			$markerArray['###LINK_ADD_NEW###'] = $this->local_cObj->stdWrap( $link, $localConf['linkAddNew_stdWrap.'] );
			$GLOBALS['TSFE']->ATagParams = $originalATagParams;

			// Substitute the markers in the given sub sub part
			$subpartContent = null;
			$subpartContent = $this->cObj->substituteMarkerArray( $this->cObj->getSubpart( $templateCode, "###" . $subSub_4. '###' ), $markerArray );

			// Substitute the template code with the given subpartcontent
			$templateCode = $this->cObj->substituteSubpart( $templateCode, $subSub_4, $subpartContent );
		} else	{
			$templateCode = $this->cObj->substituteSubpart( $templateCode, $subSub_4, '' );
		}

		/**
		 * CATEGORIES
		 */

		// Init total link count
		$categoryLinkCountTotal = null;

//		$linksInCurrentCategoryResults = $GLOBALS['TYPO3_DB']->exec_SELECTquery( '*', $databaseTable, $theField . '=' . $GLOBALS['TYPO3_DB']->quoteStr( $theValue, $databaseTable ) . ' ' . $whereClause, $groupBy, $orderBy, $limit );

// Count number of links in current category
		$databaseTable = $this->tablePrefix . 'link';
		$relationTable = $this->tablePrefix .'link_category_mm';
		$foreignTable = $this->tablePrefix .'category';
		$theField = $foreignTable.'.uid';
		$theValue = $categoryUID;
		$whereClause = 'AND '.$databaseTable.'.status IN (1,2)'. $this->enableFields;
		$groupBy = '';
		$orderBy = '';
		$limit = '';

$linksInCurrentCategoryResults = $GLOBALS['TYPO3_DB']->exec_SELECT_mm_query( $databaseTable.'.*', $databaseTable,$relationTable,$foreignTable, ' AND '.$theField . '=' . $GLOBALS['TYPO3_DB']->quoteStr( $theValue, $databaseTable ) . ' ' . $whereClause, $groupBy, $orderBy, $limit );
//		debug ($GLOBALS['TYPO3_DB']->debug_lastBuiltQuery,"// Count number of links in current category" );
		
//t3lib_DB::
		//	function exec_SELECT_mm_query($select,$local_table,$mm_table,$foreign_table,$whereClause='',$groupBy='',$orderBy='',$limit='')	{
		/*
		* @param	string		Field list for SELECT
	 * @param	string		Tablename, local table
	 * @param	string		Tablename, relation table
	 * @param	string		Tablename, foreign table
	 * @param	string		Optional additional WHERE clauses put in the end of the query. NOTICE: You must escape values in this argument with $this->fullQuoteStr() yourself! DO NOT PUT IN GROUP BY, ORDER BY or LIMIT!
	 * @param	string		Optional GROUP BY field(s), if none, supply blank string.
	 * @param	string		Optional ORDER BY field(s), if none, supply blank string.
	 * @param	string		Optional LIMIT value ([begin,]max), if none, supply blank string.
	 * @return	pointer		MySQL result pointer / DBAL object
	 * @see exec_SELECTquery()
	 */

		
		
		// Get record overlay
		$linksInCurrentCategory = $this->getRecordOverlay( $linksInCurrentCategoryResults, $databaseTable );

		// Get category labels
		$databaseTable = $this->tablePrefix . 'category';
		$theField = 'catuid_before';
		$theValue = $categoryUID;
		$whereClause = $this->enableFieldsCategory;
		$groupBy = '';
		$orderBy = 'label ASC';
		$limit = '';
		$categoryLabelsResults = $GLOBALS['TYPO3_DB']->exec_SELECTquery( '*', $databaseTable, $theField . '=' . $GLOBALS['TYPO3_DB']->quoteStr( $theValue, $databaseTable ) . ' ' . $whereClause, $groupBy, $orderBy, $limit );

		// Get record overlay
		$categoryLabels = $this->getRecordOverlay( $categoryLabelsResults, $databaseTable );

		// Output the labels
		if( count( $categoryLabels ) > 0 )	{
			$categoryList = null;
			$subpartContent = null;

			for( $i = 0; $i < count( $categoryLabels ); $i++ )	{
				// Start the recursion to count the total number of links below the current category
				$categoryLinkCount = $this->recursiveLinkCount( $categoryLabels[$i]['uid'] );
				$categoryLinkCountTotal += $categoryLinkCount;
//				debug($i,'counter');
//				debug($categoryLinkCount,'categoryLinkCount');

				$GLOBALS['TSFE']->ATagParams = $GLOBALS['TSFE']->ATagParams . ( $localConf['categoryLabel.']['ATagParams'] ? ' ' . $localConf['categoryLabel.']['ATagParams'] : '' );
				$link = $this->pi_LinkTP( $categoryLabels[$i]['label'], array( 'tx_ablinklist_pi1[action]' => $action, 'tx_ablinklist_pi1[category_uid]' => $categoryLabels[$i]['uid'] ), $this->allowCaching );
				$GLOBALS['TSFE']->ATagParams = $originalATagParams;

				// Create marker array
				$markerArrayCategory = array();

				// Show category image if defined
				if( $categoryLabels[$i]['image'] )	{
					// Get flexform config for displaying of image and create config
					$imageMaxHeight = intval( $this->pi_getFFvalue( $this->flexform, 'categoryImageMaxHeight', 's_image' ) ? $this->pi_getFFvalue( $this->flexform, 'categoryImageMaxHeight', 's_image' ) : $this->conf['categoryImageMaxHeight'] );
					$imageMaxWidth = intval( $this->pi_getFFvalue( $this->flexform, 'categoryImageMaxWidth', 's_image' ) ? $this->pi_getFFvalue( $this->flexform, 'categoryImageMaxWidth', 's_image' ) : $this->conf['categoryImageMaxWidth'] );

					$pictureConfig = array();
					$pictureConfig['image.']['file'] = 'uploads/tx_ablinklist/categoryImages/' . $categoryLabels[$i]['image'];
					$pictureConfig['image.']['file.']['maxW'] = intval( $imageMaxWidth );
					$pictureConfig['image.']['file.']['maxH'] = intval( $imageMaxHeight );
					$pictureConfig['image.']['altText'] = $categoryLabels[$i]['label'];
					$pictureConfig['image.']['titleText'] = $categoryLabels[$i]['label'];
	
					$markerArrayCategory['###CATEGORY_ICON###'] = $this->local_cObj->IMAGE( $pictureConfig['image.'] );
				} else	{
					$markerArrayCategory['###CATEGORY_ICON###'] = $this->local_cObj->fileResource( $this->conf['iconCategory'], 'alt="'.$categoryLabels[$i]['label'].'" title="'.$categoryLabels[$i]['label'].'"' );
				}

				$markerArrayCategory['###CATEGORY_LABEL###'] = $this->local_cObj->stdWrap( $link, $localConf['categoryLabel_stdWrap.'] );
				$markerArrayCategory['###CATEGORY_LINK_COUNT###'] = $this->local_cObj->stdWrap( $categoryLinkCount, '' );
				$markerArrayCategory['###LL_LIS###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_links' ), '' );
				$markerArrayCategory['###LL_TOTAL###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_total' ), '' );
				$markerArrayCategory['###CATEGORY_DESCRIPTION###'] = $this->local_cObj->stdWrap( $categoryLabels[$i]['description'], $localConf['categoryDescription_stdWrap.'] );

				// Substitute the markers in the given sub sub part
				$categoryList .= $this->cObj->substituteMarkerArray( $this->cObj->getSubpart( $templateCode, "###" . $subSubSub_1 . '###' ), $markerArrayCategory );
			}

			// Prepare title array
			$markerArrayTitle = array();
			$markerArrayTitle['###LL_CATS###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_cats' ), '' );
			$markerArrayTitle['###LL_LIS###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_links' ), $localConf['links_stdWrap.'] );
			$markerArrayTitle['###LL_TOTAL###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_total' ), '' );
			$markerArrayTitle['###LINK_COUNT_TOTAL###'] = $this->local_cObj->stdWrap( $categoryLinkCountTotal + count( $linksInCurrentCategory ), '' );

			$wrappedSubpartArray = array();
			$subpartArray['###CATEGORY###'] = $categoryList;
			$subpartContent = $this->cObj->substituteMarkerArrayCached( $this->cObj->getSubpart( $templateCode, "###" . $subSub_1 . '###' ), $markerArrayTitle, $subpartArray, $wrappedSubpartArray );

			$templateCode = $this->cObj->substituteSubpart( $templateCode, $subSub_1, $subpartContent );
		} else	{
			$templateCode = $this->cObj->substituteSubpart( $templateCode, $subSub_1, '' );
		}

		/**
		 * LINKS
		 */

		// Get flexform config for displaying of links
		$sortBy = $this->pi_getFFvalue( $this->flexform, 'sortBy', 's_display' );
		$sortOrder = $this->pi_getFFvalue( $this->flexform, 'sortOrder', 's_display' );
		$listLimit = intval( $this->pi_getFFvalue( $this->flexform, 'listLimit', 's_display' ) ? $this->pi_getFFvalue( $this->flexform, 'listLimit', 's_display' ) : $this->conf['listLimit'] );

		$limitStart = 0;
		if ( intval( $this->piVars['pointer'] ) > 0 )	{
			$limitStart = intval( $this->piVars['pointer'] ) * $listLimit;
		}

		// Get links (only those, which are approved)
/*
		$databaseTable = $this->tablePrefix . 'link';
		$theField = 'category';
		$theValue = $categoryUID;
		$whereClause = 'AND sys_language_uid=0 AND status IN (1,2)' . $this->enableFields;
		$groupBy = '';
		$orderBy = $sortBy . ' ' . $sortOrder;
		$limit = $limitStart . ', ' . $listLimit;
		$linksResults = $GLOBALS['TYPO3_DB']->exec_SELECTquery( '*', $databaseTable, $theField . '=' . $GLOBALS['TYPO3_DB']->quoteStr( $theValue, $databaseTable ) . ' ' . $whereClause, $groupBy, $orderBy, $limit );
*/


		$databaseTable = $this->tablePrefix . 'link';
		$relationTable = $this->tablePrefix .'link_category_mm';
		$foreignTable = $this->tablePrefix .'category';
		$theField = $foreignTable.'.uid';
		$theValue = $categoryUID;
		$whereClause = 'AND '.$databaseTable.'.sys_language_uid=0 AND '.$databaseTable.'.status IN (1,2)' . $this->enableFields;
		$orderBy = $sortBy . ' ' . $sortOrder;
		$limit = $limitStart . ', ' . $listLimit;
		$linksResults = $GLOBALS['TYPO3_DB']->exec_SELECT_mm_query( $databaseTable.'.*', $databaseTable,$relationTable,$foreignTable, ' AND '.$theField . '=' . $GLOBALS['TYPO3_DB']->quoteStr( $theValue, $databaseTable ) . ' ' . $whereClause, $groupBy, $orderBy, $limit );

		
		// Get record overlay
		$links = $this->getRecordOverlay( $linksResults, $databaseTable );

		// Display links
		if( count( $links ) > 0 )	{
			$linkList = null;
			$subpartContent = null;

			for( $i = 0; $i < count( $links ); $i++ )	{
				// Get link UID
				$uid = $links[$i]['uid'];

				// Create marker array
				$markerArrayLink = array();
				$markerArrayLink['###LINK_ICON###'] = $this->local_cObj->fileResource( $this->conf['iconLink'], 'alt="Link Icon" title="Link Icon"' );

				if( $links[$i]['image'] )	{
					// Get flexform config for displaying of image and create config
					$imageMaxHeight = intval( $this->pi_getFFvalue( $this->flexform, 'imageMaxHeightCategory', 's_image' ) ? $this->pi_getFFvalue( $this->flexform, 'imageMaxHeightCategory', 's_image' ) : $this->conf['imageMaxHeightCategory'] );
					$imageMaxWidth = intval( $this->pi_getFFvalue( $this->flexform, 'imageMaxWidthCategory', 's_image' ) ? $this->pi_getFFvalue( $this->flexform, 'imageMaxWidthCategory', 's_image' ) : $this->conf['imageMaxWidthCategory'] );
	
					$pictureConfig = array();
					$pictureConfig['image.']['file'] = 'uploads/tx_ablinklist/linkImages/' . $links[$i]['image'];
					$pictureConfig['image.']['file.']['maxW'] = intval( $imageMaxWidth );
					$pictureConfig['image.']['file.']['maxH'] = intval( $imageMaxHeight );
					$pictureConfig['image.']['altText'] = $links[$i]['label'];
					$pictureConfig['image.']['titleText'] = $links[$i]['label'];
	
					$markerArrayLink['###IMAGE###'] = $this->local_cObj->IMAGE( $pictureConfig['image.'] );
				} else	{
					$markerArrayLink['###IMAGE###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'no_image_message' ), '' );
				}

				// Generate and insert link teaser
				$teaseLinks = $this->conf['teaseLinks'];
				$linkteaser = '';
				if( $teaseLinks && $links[$i]['description'] != null )	{
					$linkteaser = $this->local_cObj->stdWrap( $links[$i]['description'], $localConf['linkTeaser_stdWrap.'] );
				}
				$markerArrayLink['###LINK_TEASER###'] = $linkteaser;

				$GLOBALS['TSFE']->ATagParams = $GLOBALS['TSFE']->ATagParams . ( $localConf['linkLabel.']['ATagParams'] ? ' ' . $localConf['linkLabel.']['ATagParams'] : '' );
				$linkLabel = $this->pi_LinkTP(  $links[$i]['label'], array( 'tx_ablinklist_pi1[action]' => 'getviewclickedlink', 'tx_ablinklist_pi1[uid]' => $uid ), $this->allowCaching );
				$markerArrayLink['###LINK_LABEL###'] = $this->local_cObj->stdWrap( $linkLabel, $localConf['linkLabel_stdWrap.'] );
				$GLOBALS['TSFE']->ATagParams = $originalATagParams;

				$GLOBALS['TSFE']->ATagParams = $GLOBALS['TSFE']->ATagParams . ( $localConf['linkDetails.']['ATagParams'] ? ' ' . $localConf['linkDetails.']['ATagParams'] : '' );
				if( $this->pi_getFFvalue( $this->flexform, 'iconsForLinks', 's_display' ) )	{
					$linkDetails = $this->pi_LinkTP( $this->local_cObj->fileResource( $this->conf['iconDetails'], 'alt="' . $this->pi_getLL( 'll_details' ) . '" title="' . $this->pi_getLL( 'll_details' ) . '"' ), array( 'tx_ablinklist_pi1[action]' => 'getviewdetailsforlink', 'tx_ablinklist_pi1[uid]' => $uid, 'tx_ablinklist_pi1[category_uid]' => $categoryUID ), $this->allowCaching );
				} else	{
					$linkDetails = $this->pi_LinkTP( $this->local_cObj->stdWrap( $this->pi_getLL( 'll_details' ), '' ), array( 'tx_ablinklist_pi1[action]' => 'getviewdetailsforlink', 'tx_ablinklist_pi1[uid]' => $uid, 'tx_ablinklist_pi1[category_uid]' => $categoryUID ), $this->allowCaching );
				}
				$markerArrayLink['###LINK_DETAILS###'] = $this->local_cObj->stdWrap( $linkDetails, $localConf['linkDetails_stdWrap.'] );
				$GLOBALS['TSFE']->ATagParams = $originalATagParams;

				$markerArrayLink['###LINK_CLICKS###'] = $links[$i]['clicks'];
				$markerArrayLink['###LL_CLICKS###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_clicks' ), '' );

				if( $this->pi_getFFvalue( $this->flexform, 'noStarsInCategoryView', 's_display' ) || $this->conf['noStarsInCategoryView'] )	{
					$markerArrayLink['###LINK_RATING_STARS###'] = '';
				} else	{
					$markerArrayLink['###LINK_RATING_STARS###'] = $this->returnStarsForRating( $links[$i]['rating'] );
				}

				if( $links[$i]['status'] == 2 )	{
					if( $this->pi_getFFvalue( $this->flexform, 'iconsForLinks', 's_display' ) )	{
						$markerArrayLink['###LINK_REPORT_BROKEN###'] = $this->local_cObj->stdWrap( $this->local_cObj->fileResource( $this->conf['iconReportBrokenDisabled'], 'alt="' . $this->pi_getLL( 'll_reported_link_broken' ) . '" title="' . $this->pi_getLL( 'll_reported_link_broken' ) . '"' ), $localConf['linkReportBroken_stdWrap.'] );
					} else	{
						$markerArrayLink['###LINK_REPORT_BROKEN###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_reported_link_broken'), $localConf['linkReportBroken_stdWrap.'] );
					}
				} else	{
					$GLOBALS['TSFE']->ATagParams = $GLOBALS['TSFE']->ATagParams . ( $localConf['linkReportBroken.']['ATagParams'] ? ' ' . $localConf['linkReportBroken.']['ATagParams'] : '' );

					if( $this->pi_getFFvalue( $this->flexform, 'iconsForLinks', 's_display' ) )	{
						$link = $this->pi_LinkTP( $this->local_cObj->fileResource( $this->conf['iconReportBroken'], 'alt="' . $this->pi_getLL( 'll_report_link_broken' ) . '" title="' . $this->pi_getLL( 'll_report_link_broken' ) . '"' ), array( 'tx_ablinklist_pi1[action]' => 'getviewreportbrokenlink', 'tx_ablinklist_pi1[uid]' => $uid, 'tx_ablinklist_pi1[category_uid]' => $categoryUID ), $this->allowCaching );
					} else	{
						$link = $this->pi_LinkTP( $this->local_cObj->stdWrap( $this->pi_getLL( 'll_report_link_broken'), '' ), array( 'tx_ablinklist_pi1[action]' => 'getviewreportbrokenlink', 'tx_ablinklist_pi1[uid]' => $uid, 'tx_ablinklist_pi1[category_uid]' => $categoryUID ), $this->allowCaching );
					}
					$markerArrayLink['###LINK_REPORT_BROKEN###'] = $this->local_cObj->stdWrap( $link, $localConf['linkReportBroken_stdWrap.'] );

					$GLOBALS['TSFE']->ATagParams = $originalATagParams;
				}

				if( $this->pi_getFFvalue( $this->flexform, 'noRatingInCategoryView', 's_display' ) || $this->conf['noRatingInCategoryView'] )	{
					$markerArrayLink['###LINK_RATE###'] = '';
				} else	{
					$GLOBALS['TSFE']->ATagParams = $GLOBALS['TSFE']->ATagParams . ( $localConf['linkRate.']['ATagParams'] ? ' ' . $localConf['linkRate.']['ATagParams'] : '' );

					if( $this->pi_getFFvalue( $this->flexform, 'iconsForLinks', 's_display' ) )	{
						$link = $this->pi_LinkTP( $this->local_cObj->fileResource( $this->conf['iconRate'], 'alt="' . $this->pi_getLL( 'll_rate_link' ) . '" title="' . $this->pi_getLL( 'll_rate_link' ) . '"' ), array( 'tx_ablinklist_pi1[action]' => 'getviewratelink', 'tx_ablinklist_pi1[uid]' => $uid, 'tx_ablinklist_pi1[category_uid]' => $categoryUID ), $this->allowCaching );
					} else	{
						$link = $this->pi_LinkTP( $this->local_cObj->stdWrap( $this->pi_getLL( 'll_rate_link'), '' ), array( 'tx_ablinklist_pi1[action]' => 'getviewratelink', 'tx_ablinklist_pi1[uid]' => $uid, 'tx_ablinklist_pi1[category_uid]' => $categoryUID ), $this->allowCaching );
					}
					$markerArrayLink['###LINK_RATE###'] = $this->local_cObj->stdWrap( $link, $localConf['linkRate_stdWrap.'] );

					$GLOBALS['TSFE']->ATagParams = $originalATagParams;
				}

				// Substitute the markers in the given sub sub part
				$linkList .= $this->cObj->substituteMarkerArray( $this->cObj->getSubpart( $templateCode, "###" . $subSubSub_2. '###' ), $markerArrayLink );
			}

			// Prepare title array
			$markerArrayTitle = array();
			$markerArrayTitle['###LL_LIS###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_links' ), $localConf['links_stdWrap.'] );

			$wrappedSubpartArray = array();
			$subpartArray['###LINK###'] = $linkList;
			$subpartContent = $this->cObj->substituteMarkerArrayCached( $this->cObj->getSubpart( $templateCode, "###" . $subSub_2. '###' ), $markerArrayTitle, $subpartArray, $wrappedSubpartArray);

			$templateCode = $this->cObj->substituteSubpart( $templateCode, $subSub_2, $subpartContent );
		} else	{
			$templateCode = $this->cObj->substituteSubpart( $templateCode, $subSub_2, '' );
		}

		/**
		 * PAGEBROWSER
		 */

		// Render the pagebrowser if needed
		$pointerName = $this->pointerName = 'pointer';

		if( count( $linksInCurrentCategory ) > $listLimit && !$this->conf['noPageBrowser'] && !$this->pi_getFFvalue( $this->flexform, 'noPageBrowser', 's_display' ) )	{
			// Configure pagebrowser vars
			$this->internal['res_count'] = count( $linksInCurrentCategory );
			$this->internal['results_at_a_time'] = $listLimit;
			$this->internal['maxPages'] = $this->conf['pageBrowser.']['maxPages'] > 0 ? $this->conf['pageBrowser.']['maxPages'] : 10;
			$this->internal['action'] = $action;
			$this->internal['category_uid'] = $categoryUID;

			if( !$this->conf['pageBrowser.']['showPBrowserText'] )
				$this->LOCAL_LANG[$this->LLkey]['pi_list_browseresults_page'] = '';

			if( $this->conf['userPageBrowserFunc'] )	{
				$markerArray = $this->userProcess( 'userPageBrowserFunc', $markerArray );
			} else	{
				if( $this->conf['usePiBasePagebrowser'] )	{
					$this->internal['pagefloat'] = $this->conf['pageBrowser.']['pagefloat'];
					$this->internal['showFirstLast'] = $this->conf['pageBrowser.']['showFirstLast'];
					$this->internal['showRange'] = $this->conf['pageBrowser.']['showRange'];
					$this->internal['dontLinkActivePage'] = $this->conf['pageBrowser.']['dontLinkActivePage'];

					$wrapArrFields = explode( ',', 'disabledLinkWrap,inactiveLinkWrap,activeLinkWrap,browseLinksWrap,showResultsWrap,showResultsNumbersWrap,browseBoxWrap' );
					$wrapArr = array();
					foreach( $wrapArrFields as $key )	{
						if( $this->conf['pageBrowser.'][$key] )	{
							$wrapArr[$key] = $this->conf['pageBrowser.'][$key];
						}
					}

					// If there is a GETvar in the URL that is not in this list, caching will be disabled for the pagebrowser links
					$this->pi_isOnlyFields = $pointerName . ',action,category_uid';
					$this->pi_alwaysPrev = $this->conf['pageBrowser.']['alwaysPrev'];
					$markerArray['###BROWSE_LINKS###'] = $this->pi_list_browseresults( $this->conf['pageBrowser.']['showResultCount'], $this->conf['pageBrowser.']['tableParams'], $wrapArr, $pointerName, $this->conf['pageBrowser.']['hscText'] );
				} else	{
					$markerArray['###BROWSE_LINKS###'] = $this->makePageBrowser( $pointerName );
				}
			}
		} else	{
			$markerArray['###BROWSE_LINKS###'] = '';
		}

		// Finally substitute the marker array
		$templateCode = $this->cObj->substituteMarkerArray( $templateCode, $markerArray );

		/**
		 * TOP LISTS
		 */

		$templateCode = $templateCode;

		// Return the generated content
		$content = $templateCode;

		return $content;
	}

	/**
	 * displayTree( $categoryUID = 0, $level = 0 )
	 *
	 * Generates the html for the tree view of this extension. In this view a tree of all links is shown.
	 *
	 * @param	integer		$categoryUID	UID of the category that shall be shown.
	 * @param	integer		$level	Level in the tree.
	 * @return	string		The generated HTML source for this view.
	 */
	function displayTree( $categoryUID = 0, $level = 0 )		{

		// Init some vars
		$content = '';
		$templateCode = null;
		$conf['subpartMarker'] = 'VIEW_TREE';
		$subSub_1 = 'TREE_LINK';

		// Get the html source between subpart markers from the template file
		$templateCode = $this->cObj->getSubpart( $this->originalTemplateCode, "###" . $conf['subpartMarker'] . '###' );

		// Get local config
		$localConf = $this->conf['treeView.'];

		// Save original ATagParams
		$originalATagParams = $GLOBALS['TSFE']->ATagParams;

		// Check if anonymous users may add links
		$allowAddLinks = $this->pi_getFFvalue( $this->flexform, 'allowAddLinks', 'sDEF' ) ? $this->pi_getFFvalue( $this->flexform, 'allowAddLinks', 'sDEF' ) : $this->conf['allowAddLinks'];

		// Check if a fe_user is logged in
		$isLoggedIn = $GLOBALS['TSFE']->loginUser;

		// Calculate indention from the current level
		$indention = $level * 40;
		$level++;

		/**
		 * CATEGORY
		 */

		// Get category label
		if( $categoryUID == 0 )	{
			$category[0]['label'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_cats' ), '' );
		} else	{
			$databaseTable = $this->tablePrefix . 'category';
			$theField = 'uid';
			$theValue = $categoryUID;
			$whereClause = $this->enableFieldsCategory;
			$groupBy = '';
			$orderBy = '';
			$limit = '';
			$categoryResult = $GLOBALS['TYPO3_DB']->exec_SELECTquery( '*', $databaseTable, $theField . '=' . $GLOBALS['TYPO3_DB']->quoteStr( $theValue, $databaseTable ) . ' ' . $whereClause, $groupBy, $orderBy, $limit );

			// Get record overlay
			$category = $this->getRecordOverlay( $categoryResult, $databaseTable );
		}

		/**
		 * LINKS
		 */

		// Get flexform config for displaying of links
		$sortBy = $this->pi_getFFvalue( $this->flexform, 'sortBy', 's_display' );
		$sortOrder = $this->pi_getFFvalue( $this->flexform, 'sortOrder', 's_display' );

		// Get links in current category
/*
		$databaseTable = $this->tablePrefix . 'link';
		$theField = 'category';
		$theValue = $categoryUID;
		$whereClause = 'AND sys_language_uid=0 AND status IN (1,2)' . $this->enableFields;
		$groupBy = '';
		$orderBy = $sortBy . ' ' . $sortOrder;
		$limit = '';
		$linksResults = $GLOBALS['TYPO3_DB']->exec_SELECTquery( '*', $databaseTable, $theField . '=' . $GLOBALS['TYPO3_DB']->quoteStr( $theValue, $databaseTable ) . ' ' . $whereClause, $groupBy, $orderBy, $limit );
*/
		$databaseTable = $this->tablePrefix . 'link';
		$relationTable = $this->tablePrefix .'link_category_mm';
		$foreignTable = $this->tablePrefix .'category';
		$theField = $foreignTable.'.uid';
		$theValue = $categoryUID;
		$whereClause = 'AND '.$databaseTable.'.sys_language_uid=0 AND '.$databaseTable.'.status IN (1,2)' . $this->enableFields;
		$orderBy = $sortBy . ' ' . $sortOrder;
		$limit = '';
		$linksResults = $GLOBALS['TYPO3_DB']->exec_SELECT_mm_query( $databaseTable.'.*', $databaseTable,$relationTable,$foreignTable, ' AND '.$theField . '=' . $GLOBALS['TYPO3_DB']->quoteStr( $theValue, $databaseTable ) . ' ' . $whereClause, $groupBy, $orderBy, $limit );
		
		
		// Get record overlay
		$links = $this->getRecordOverlay( $linksResults, $databaseTable );

		// Display links
		if( count( $links ) > 0 )	{
			for( $j = 0; $j < count( $links ); $j++ )	{
				$uid = $links[$j]['uid'];

				// Create marker array
				$markerArray = array();
				$markerArray['###LINK_ICON###'] = $this->local_cObj->fileResource( $this->conf['iconCategory'], 'alt="Category Icon" title="Category Icon"' );

				// Generate and insert link teaser
				$teaseLinks = $this->conf['teaseLinks'];
				$linkteaser = '';
				if( $teaseLinks && $links[$j]['description'] != null )	{
					$linkteaser = $this->local_cObj->stdWrap( $links[$j]['description'], $localConf['linkTeaser_stdWrap.'] );
				}
				$markerArray['###LINK_TEASER###'] = $linkteaser;

				$GLOBALS['TSFE']->ATagParams = $GLOBALS['TSFE']->ATagParams . ( $localConf['linkLabel.']['ATagParams'] ? ' ' . $localConf['linkLabel.']['ATagParams'] : '' );
				$linkLabel = $this->pi_LinkTP(  $links[$j]['label'], array( 'tx_ablinklist_pi1[action]' => 'getviewclickedlink', 'tx_ablinklist_pi1[uid]' => $uid ), $this->allowCaching );
				$markerArray['###LINK_LABEL###'] = $this->local_cObj->stdWrap( $linkLabel, $localConf['linkLabel_stdWrap.'] );
				$GLOBALS['TSFE']->ATagParams = $originalATagParams;

				$GLOBALS['TSFE']->ATagParams = $GLOBALS['TSFE']->ATagParams . ( $localConf['linkDetails.']['ATagParams'] ? ' ' . $localConf['linkDetails.']['ATagParams'] : '' );
				if( $this->pi_getFFvalue( $this->flexform, 'iconsForLinks', 's_display' ) )	{
					$linkDetails = $this->pi_LinkTP( $this->local_cObj->fileResource( $this->conf['iconDetails'], 'alt="' . $this->pi_getLL( 'll_details' ) . '" title="' . $this->pi_getLL( 'll_details' ) . '"' ), array( 'tx_ablinklist_pi1[action]' => 'getviewdetailsforlink', 'tx_ablinklist_pi1[uid]' => $uid, 'tx_ablinklist_pi1[category_uid]' => $categoryUID ), $this->allowCaching );
				} else	{
					$linkDetails = $this->pi_LinkTP( $this->local_cObj->stdWrap( $this->pi_getLL( 'll_details' ), '' ), array( 'tx_ablinklist_pi1[action]' => 'getviewdetailsforlink', 'tx_ablinklist_pi1[uid]' => $uid, 'tx_ablinklist_pi1[category_uid]' => $categoryUID ), $this->allowCaching );
				}
				$markerArray['###LINK_DETAILS###'] = $this->local_cObj->stdWrap( $linkDetails, $localConf['linkDetails_stdWrap.'] );
				$GLOBALS['TSFE']->ATagParams = $originalATagParams;

				$markerArray['###LINK_CLICKS###'] = $links[$j]['clicks'];

				if( $this->pi_getFFvalue( $this->flexform, 'noStarsInCategoryView', 's_display' ) || $this->conf['noStarsInCategoryView'] )	{
					$markerArray['###LINK_RATING_STARS###'] = '';
				} else	{
					$markerArray['###LINK_RATING_STARS###'] = $this->returnStarsForRating( $links[$j]['rating'] );
				}

				if( $links[$j]['status'] == 2 )	{
					if( $this->pi_getFFvalue( $this->flexform, 'iconsForLinks', 's_display' ) )	{
						$markerArray['###LINK_REPORT_BROKEN###'] = $this->local_cObj->stdWrap( $this->local_cObj->fileResource( $this->conf['iconReportBrokenDisabled'], 'alt="' . $this->pi_getLL( 'll_reported_link_broken' ) . '" title="' . $this->pi_getLL( 'll_reported_link_broken' ) . '"' ), $localConf['linkReportBroken_stdWrap.'] );
					} else	{
						$markerArray['###LINK_REPORT_BROKEN###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_reported_link_broken'), $localConf['linkReportBroken_stdWrap.'] );
					}
				} else	{
					$GLOBALS['TSFE']->ATagParams = $GLOBALS['TSFE']->ATagParams . ( $localConf['linkReportBroken.']['ATagParams'] ? ' ' . $localConf['linkReportBroken.']['ATagParams'] : '' );

					if( $this->pi_getFFvalue( $this->flexform, 'iconsForLinks', 's_display' ) )	{
						$link = $this->pi_LinkTP( $this->local_cObj->fileResource( $this->conf['iconReportBroken'], 'alt="' . $this->pi_getLL( 'll_report_link_broken' ) . '" title="' . $this->pi_getLL( 'll_report_link_broken' ) . '"' ), array( 'tx_ablinklist_pi1[action]' => 'getviewreportbrokenlink', 'tx_ablinklist_pi1[uid]' => $uid, 'tx_ablinklist_pi1[category_uid]' => $categoryUID ), $this->allowCaching );
					} else	{
						$link = $this->pi_LinkTP( $this->local_cObj->stdWrap( $this->pi_getLL( 'll_report_link_broken'), '' ), array( 'tx_ablinklist_pi1[action]' => 'getviewreportbrokenlink', 'tx_ablinklist_pi1[uid]' => $uid, 'tx_ablinklist_pi1[category_uid]' => $categoryUID ), $this->allowCaching );
					}
					$markerArray['###LINK_REPORT_BROKEN###'] = $this->local_cObj->stdWrap( $link, $localConf['linkReportBroken_stdWrap.'] );

					$GLOBALS['TSFE']->ATagParams = $originalATagParams;
				}

				if( $this->pi_getFFvalue( $this->flexform, 'noRatingInCategoryView', 's_display' ) || $this->conf['noRatingInCategoryView'] )	{
					$markerArray['###LINK_RATE###'] = '';
				} else	{
					$GLOBALS['TSFE']->ATagParams = $GLOBALS['TSFE']->ATagParams . ( $localConf['linkRate.']['ATagParams'] ? ' ' . $localConf['linkRate.']['ATagParams'] : '' );

					if( $this->pi_getFFvalue( $this->flexform, 'iconsForLinks', 's_display' ) )	{
						$link = $this->pi_LinkTP( $this->local_cObj->fileResource( $this->conf['iconRate'], 'alt="' . $this->pi_getLL( 'll_rate_link' ) . '" title="' . $this->pi_getLL( 'll_rate_link' ) . '"' ), array( 'tx_ablinklist_pi1[action]' => 'getviewratelink', 'tx_ablinklist_pi1[uid]' => $uid, 'tx_ablinklist_pi1[category_uid]' => $categoryUID ), $this->allowCaching );
					} else	{
						$link = $this->pi_LinkTP( $this->local_cObj->stdWrap( $this->pi_getLL( 'll_rate_link'), '' ), array( 'tx_ablinklist_pi1[action]' => 'getviewratelink', 'tx_ablinklist_pi1[uid]' => $uid, 'tx_ablinklist_pi1[category_uid]' => $categoryUID ), $this->allowCaching );
					}
					$markerArray['###LINK_RATE###'] = $this->local_cObj->stdWrap( $link, $localConf['linkRate_stdWrap.'] );

					$GLOBALS['TSFE']->ATagParams = $originalATagParams;
				}

				$markerArray['###LL_CLICKS###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_clicks' ), '' );
				$markerArray['###INDENTION###'] = $indention;

				// Substitute the markers in the given sub sub part
				$linkList .= $this->cObj->substituteMarkerArray( $this->cObj->getSubpart( $templateCode, "###" . $subSub_1. '###' ), $markerArray );
			}

			$markerArrayMessage = array();
			$markerArrayMessage['###CATEGORY_ANCHOR###'] = 'cat_' . $category[0]['uid'];
			$markerArrayMessage['###INDENTION###'] = $indention;

			// Show category image if defined
			if( $category[0]['image'] )	{
				// Get flexform config for displaying of image and create config
				$imageMaxHeight = intval( $this->pi_getFFvalue( $this->flexform, 'categoryImageMaxHeight', 's_image' ) ? $this->pi_getFFvalue( $this->flexform, 'categoryImageMaxHeight', 's_image' ) : $this->conf['categoryImageMaxHeight'] );
				$imageMaxWidth = intval( $this->pi_getFFvalue( $this->flexform, 'categoryImageMaxWidth', 's_image' ) ? $this->pi_getFFvalue( $this->flexform, 'categoryImageMaxWidth', 's_image' ) : $this->conf['categoryImageMaxWidth'] );

				$pictureConfig = array();
				$pictureConfig['image.']['file'] = 'uploads/tx_ablinklist/categoryImages/' . $category[0]['image'];
				$pictureConfig['image.']['file.']['maxW'] = intval( $imageMaxWidth );
				$pictureConfig['image.']['file.']['maxH'] = intval( $imageMaxHeight );
				$pictureConfig['image.']['altText'] = $categoryLabels[$i]['label'];
				$pictureConfig['image.']['titleText'] = $categoryLabels[$i]['label'];

				$markerArrayMessage['###CATEGORY_ICON###'] = $this->local_cObj->IMAGE( $pictureConfig['image.'] );
			} else	{
				$markerArrayMessage['###CATEGORY_ICON###'] = '';
			}

			$markerArrayMessage['###CATEGORY_LABEL###'] = $this->local_cObj->stdWrap( $category[0]['label'], $localConf['categoryLabel_stdWrap.'] );

			if( $isLoggedIn == 1 || $allowAddLinks == 1 )	{
				$GLOBALS['TSFE']->ATagParams = $GLOBALS['TSFE']->ATagParams . ( $localConf['linkAddNew.']['ATagParams'] ? ' ' . $localConf['linkAddNew.']['ATagParams'] : '' );
				$link = $this->pi_LinkTP( $this->pi_getLL( 'll_add_link'), array( 'tx_ablinklist_pi1[action]' => 'getviewaddnewlink', 'tx_ablinklist_pi1[category_uid]' => $categoryUID ), $this->allowCaching );
				$markerArrayMessage['###LINK_ADD_NEW###'] = $this->local_cObj->stdWrap( $link, $localConf['linkAddNew_stdWrap.'] );
				$GLOBALS['TSFE']->ATagParams = $originalATagParams;
			} else	{
				$markerArrayMessage['###LINK_ADD_NEW###'] = '';
			}

			$markerArrayMessage['###CATEGORY_DESCRIPTION###'] = $this->local_cObj->stdWrap( $category[0]['description'], $localConf['categoryDescription_stdWrap.'] );

			$wrappedSubpartArray = array();
			$subpartArray['###TREE_LINK###'] = $linkList;
			$content = $this->cObj->substituteMarkerArrayCached( $templateCode, $markerArrayMessage, $subpartArray, $wrappedSubpartArray);
		} else	{
			$markerArrayMessage = array();
			$markerArrayMessage['###CATEGORY_ANCHOR###'] = 'cat_' . $category[0]['uid'];
			$markerArrayMessage['###INDENTION###'] = $indention;

			// Show category image if defined
			if( $category[0]['image'] )	{
				// Get flexform config for displaying of image and create config
				$imageMaxHeight = intval( $this->pi_getFFvalue( $this->flexform, 'categoryImageMaxHeight', 's_image' ) ? $this->pi_getFFvalue( $this->flexform, 'categoryImageMaxHeight', 's_image' ) : $this->conf['categoryImageMaxHeight'] );
				$imageMaxWidth = intval( $this->pi_getFFvalue( $this->flexform, 'categoryImageMaxWidth', 's_image' ) ? $this->pi_getFFvalue( $this->flexform, 'categoryImageMaxWidth', 's_image' ) : $this->conf['categoryImageMaxWidth'] );

				$pictureConfig = array();
				$pictureConfig['image.']['file'] = 'uploads/tx_ablinklist/categoryImages/' . $category[0]['image'];
				$pictureConfig['image.']['file.']['maxW'] = intval( $imageMaxWidth );
				$pictureConfig['image.']['file.']['maxH'] = intval( $imageMaxHeight );
				$pictureConfig['image.']['altText'] = $categoryLabels[$i]['label'];
				$pictureConfig['image.']['titleText'] = $categoryLabels[$i]['label'];

				$markerArrayMessage['###CATEGORY_ICON###'] = $this->local_cObj->IMAGE( $pictureConfig['image.'] );
			} else	{
				$markerArrayMessage['###CATEGORY_ICON###'] = '';
			}

			$markerArrayMessage['###CATEGORY_LABEL###'] = $this->local_cObj->stdWrap( $category[0]['label'], $localConf['categoryLabel_stdWrap.'] );

			if( $isLoggedIn == 1 || $allowAddLinks == 1 )	{
				$GLOBALS['TSFE']->ATagParams = $GLOBALS['TSFE']->ATagParams . ( $localConf['linkAddNew.']['ATagParams'] ? ' ' . $localConf['linkAddNew.']['ATagParams'] : '' );
				$link = $this->pi_LinkTP( $this->pi_getLL( 'll_add_link'), array( 'tx_ablinklist_pi1[action]' => 'getviewaddnewlink', 'tx_ablinklist_pi1[category_uid]' => $categoryUID ), $this->allowCaching );
				$markerArrayMessage['###LINK_ADD_NEW###'] = $this->local_cObj->stdWrap( $link, $localConf['linkAddNew_stdWrap.'] );
				$GLOBALS['TSFE']->ATagParams = $originalATagParams;
			} else	{
				$markerArrayMessage['###LINK_ADD_NEW###'] = '';
			}

			$markerArrayMessage['###CATEGORY_DESCRIPTION###'] = $this->local_cObj->stdWrap( $category[0]['description'], $localConf['categoryDescription_stdWrap.'] );

			$wrappedSubpartArray = array();
			$subpartArray['###TREE_LINK###'] = '';
			$content = $this->cObj->substituteMarkerArrayCached( $templateCode, $markerArrayMessage, $subpartArray, $wrappedSubpartArray);
		}

		/**
		 * SUBCATEGORIES
		 */

		// Get subcategories
		$databaseTable = $this->tablePrefix . 'category';
		$theField = 'catuid_before';
		$theValue = $categoryUID;
		$whereClause = $this->enableFieldsCategory;
		$groupBy = '';
		$orderBy = 'label ASC';
		$limit = '';
		$subcategoriesResults = $GLOBALS['TYPO3_DB']->exec_SELECTquery( '*', $databaseTable, $theField . '=' . $GLOBALS['TYPO3_DB']->quoteStr( $theValue, $databaseTable ) . ' ' . $whereClause, $groupBy, $orderBy, $limit );

		// Get record overlay
		$subcategories = $this->getRecordOverlay( $subcategoriesResults, $databaseTable );

		if( count( $subcategories ) > 0 )	{
			// Do the recursion for all subcategories
			for( $i = 0; $i < count( $subcategories ); $i++ )	{
				$content .= $this->displayTree( $subcategories[$i]['uid'], $level );
			}
		}

		return $content;
	}

	/**
	 * displaySearch()
	 *
	 * Generates the html for the search view of this extension. In this view a search form and after
	 * submitting the search results are shown.
	 *
	 * @return	string		The generated HTML source for this view.
	 */
	function displaySearch()	{

		// Init some vars
		$content = '';
		$templateCode = null;
		$conf['subpartMarker'] = 'VIEW_SEARCH';
		$subSub_1 = 'LINKS';
		$subSub_2 = 'NOLINKS';

		// Get the html source between subpart markers from the template file
		$templateCode = $this->cObj->getSubpart( $this->originalTemplateCode, "###" . $conf['subpartMarker'] . '###' );

		// Get local config
		$localConf = $this->conf['searchView.'];

		// Save original ATagParams
		$originalATagParams = $GLOBALS['TSFE']->ATagParams;

		// Display search box
		$content = tslib_pibase::pi_list_searchBox();

		// Extract search words
		$searchWords = htmlspecialchars( strip_tags( $this->piVars['sword'] ) );

		if( $searchWords != null )	{
			$searchWordsArray = explode( ' ', $searchWords );

			// Remove duplicates
			$searchWordsArray = array_unique( $searchWordsArray );
			$searchFor = $searchWordsArray[0];

			// Get flexform config for displaying of links
			$sortBy = $this->pi_getFFvalue( $this->flexform, 'sortBy', 's_display' );
			$sortOrder = $this->pi_getFFvalue( $this->flexform, 'sortOrder', 's_display' );
			$listLimit = intval( $this->pi_getFFvalue( $this->flexform, 'listLimit', 's_display' ) ? $this->pi_getFFvalue( $this->flexform, 'listLimit', 's_display' ) : $this->conf['listLimit'] );

			$limitStart = 0;
			if ( intval( $this->piVars['pointer'] ) > 0 )	{
				$limitStart = intval( $this->piVars['pointer'] ) * $listLimit;
			}

			// Get links
			$databaseTable = $this->tablePrefix . 'link';
			$whereClause = 'status IN (1,2)' . $this->enableFields;
			$groupBy = '';
			$orderBy = '';
			$limit = '';
			$linksResults = $GLOBALS['TYPO3_DB']->exec_SELECTquery( '*', $databaseTable, $whereClause, $groupBy, $orderBy, $limit );

			// Get record overlay
			$links = $this->getRecordOverlay( $linksResults, $databaseTable );

			 // Display links
			$linksTotal = 0;

			for( $i = 0; $i < count( $links ); $i++ )	{
				if( eregi( $searchFor, $links[$i]['label'] ) || eregi( $searchFor, $links[$i]['description'] ) ) {
					// Get link UID
					$uid = $links[$i]['uid'];
					$categoryUID = $links[$i]['category'];

					// Create marker array
					$markerArray = array();
					$markerArray['###LINK_ICON###'] = $this->local_cObj->fileResource( $this->conf['iconLink'], 'alt="Link Icon" title="Link Icon"' );

					if( $links[$i]['image'] )	{
						// Get flexform config for displaying of image and create config
						$imageMaxHeight = intval( $this->pi_getFFvalue( $this->flexform, 'imageMaxHeightCategory', 's_image' ) ? $this->pi_getFFvalue( $this->flexform, 'imageMaxHeightCategory', 's_image' ) : $this->conf['imageMaxHeightCategory'] );
						$imageMaxWidth = intval( $this->pi_getFFvalue( $this->flexform, 'imageMaxWidthCategory', 's_image' ) ? $this->pi_getFFvalue( $this->flexform, 'imageMaxWidthCategory', 's_image' ) : $this->conf['imageMaxWidthCategory'] );
	
						$pictureConfig = array();
						$pictureConfig['image.']['file'] = 'uploads/tx_ablinklist/linkImages/' . $links[$i]['image'];
						$pictureConfig['image.']['file.']['maxW'] = intval( $imageMaxWidth );
						$pictureConfig['image.']['file.']['maxH'] = intval( $imageMaxHeight );
						$pictureConfig['image.']['altText'] = $links[$i]['label'];
						$pictureConfig['image.']['titleText'] = $links[$i]['label'];
		
						$markerArray['###IMAGE###'] = $this->local_cObj->IMAGE( $pictureConfig['image.'] );
					} else	{
						$markerArray['###IMAGE###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'no_image_message' ), '' );
					}

					// Get flexform config for the ID of the page with the LIST plugin
					$pageID = intval( $this->pi_getFFvalue( $this->flexform, 'pageIDListPlugin', 'sDEF' ) ? $this->pi_getFFvalue( $this->flexform, 'pageIDListPlugin', 'sDEF' ) : $GLOBALS['TSFE']->id );

					// Generate and insert link teaser
					$teaseLinks = $this->conf['teaseLinks'];
					$linkteaser = '';
					if( $teaseLinks && $links[$i]['description'] != null )	{
						$linkteaser = $this->local_cObj->stdWrap( $links[$i]['description'], $localConf['linkTeaser_stdWrap.'] );
					}
					$markerArray['###LINK_TEASER###'] = $linkteaser;

					// Insert category path
					$markerArray['###CATEGORY_PATH###'] = $this->local_cObj->stdWrap( $this->getCategoryPath( $links[$i]['category'] ), $localConf['categoryPath_stdWrap.'] );

					$GLOBALS['TSFE']->ATagParams = $GLOBALS['TSFE']->ATagParams . ( $localConf['linkLabel.']['ATagParams'] ? ' ' . $localConf['linkLabel.']['ATagParams'] : '' );
					$linkLabel = $this->pi_LinkTP( $links[$i]['label'], array( 'tx_ablinklist_pi1[action]' => 'getviewclickedlink', 'tx_ablinklist_pi1[uid]' => $uid ), $this->allowCaching, $pageID );
					$markerArray['###LINK_LABEL###'] = $this->local_cObj->stdWrap( $linkLabel, $localConf['linkLabel_stdWrap.'] );
					$GLOBALS['TSFE']->ATagParams = $originalATagParams;

					$GLOBALS['TSFE']->ATagParams = $GLOBALS['TSFE']->ATagParams . ( $localConf['linkDetails.']['ATagParams'] ? ' ' . $localConf['linkDetails.']['ATagParams'] : '' );
					if( $this->pi_getFFvalue( $this->flexform, 'iconsForLinks', 's_display' ) )	{
						$linkDetails = $this->pi_LinkTP( $this->local_cObj->fileResource( $this->conf['iconDetails'], 'alt="' . $this->pi_getLL( 'll_details' ) . '" title="' . $this->pi_getLL( 'll_details' ) . '"' ), array( 'tx_ablinklist_pi1[action]' => 'getviewdetailsforlink', 'tx_ablinklist_pi1[uid]' => $uid, 'tx_ablinklist_pi1[category_uid]' => $categoryUID ), $this->allowCaching, $pageID );
					} else	{
						$linkDetails = $this->pi_LinkTP( $this->local_cObj->stdWrap( $this->pi_getLL( 'll_details' ), '' ), array( 'tx_ablinklist_pi1[action]' => 'getviewdetailsforlink', 'tx_ablinklist_pi1[uid]' => $uid, 'tx_ablinklist_pi1[category_uid]' => $categoryUID ), $this->allowCaching, $pageID );
					}
					$markerArray['###LINK_DETAILS###'] = $this->local_cObj->stdWrap( $linkDetails, $localConf['linkDetails_stdWrap.'] );
					$GLOBALS['TSFE']->ATagParams = $originalATagParams;

 					$markerArray['###LINK_CLICKS###'] = $links[$i]['clicks'];

					if( $this->pi_getFFvalue( $this->flexform, 'noStarsInCategoryView', 's_display' ) || $this->conf['noStarsInCategoryView'] )	{
						$markerArray['###LINK_RATING_STARS###'] = '';
					} else	{
						$markerArray['###LINK_RATING_STARS###'] = $this->returnStarsForRating( $links[$i]['rating'] );
					}

					if( $links[$i]['status'] == 2 )	{
						if( $this->pi_getFFvalue( $this->flexform, 'iconsForLinks', 's_display' ) )	{
							$markerArray['###LINK_REPORT_BROKEN###'] = $this->local_cObj->stdWrap( $this->local_cObj->fileResource( $this->conf['iconReportBrokenDisabled'], 'alt="' . $this->pi_getLL( 'll_reported_link_broken' ) . '" title="' . $this->pi_getLL( 'll_reported_link_broken' ) . '"' ), $localConf['linkReportBroken_stdWrap.'] );
						} else	{
							$markerArray['###LINK_REPORT_BROKEN###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_reported_link_broken'), $localConf['linkReportBroken_stdWrap.'] );
						}
					} else	{
						$GLOBALS['TSFE']->ATagParams = $GLOBALS['TSFE']->ATagParams . ( $localConf['linkReportBroken.']['ATagParams'] ? ' ' . $localConf['linkReportBroken.']['ATagParams'] : '' );

						if( $this->pi_getFFvalue( $this->flexform, 'iconsForLinks', 's_display' ) )	{
							$link = $this->pi_LinkTP( $this->local_cObj->fileResource( $this->conf['iconReportBroken'], 'alt="' . $this->pi_getLL( 'll_report_link_broken' ) . '" title="' . $this->pi_getLL( 'll_report_link_broken' ) . '"' ), array( 'tx_ablinklist_pi1[action]' => 'getviewreportbrokenlink', 'tx_ablinklist_pi1[uid]' => $uid, 'tx_ablinklist_pi1[category_uid]' => $categoryUID ), $this->allowCaching, $pageID );
						} else	{
							$link = $this->pi_LinkTP( $this->local_cObj->stdWrap( $this->pi_getLL( 'll_report_link_broken'), '' ), array( 'tx_ablinklist_pi1[action]' => 'getviewreportbrokenlink', 'tx_ablinklist_pi1[uid]' => $uid, 'tx_ablinklist_pi1[category_uid]' => $categoryUID ), $this->allowCaching, $pageID );
						}
						$markerArray['###LINK_REPORT_BROKEN###'] = $this->local_cObj->stdWrap( $link, $localConf['linkReportBroken_stdWrap.'] );

						$GLOBALS['TSFE']->ATagParams = $originalATagParams;
					}

					if( $this->pi_getFFvalue( $this->flexform, 'noRatingInCategoryView', 's_display' ) || $this->conf['noRatingInCategoryView'] )	{
						$markerArray['###LINK_RATE###'] = '';
					} else	{
						$GLOBALS['TSFE']->ATagParams = $GLOBALS['TSFE']->ATagParams . ( $localConf['linkRate.']['ATagParams'] ? ' ' . $localConf['linkRate.']['ATagParams'] : '' );

						if( $this->pi_getFFvalue( $this->flexform, 'iconsForLinks', 's_display' ) )	{
							$link = $this->pi_LinkTP( $this->local_cObj->fileResource( $this->conf['iconRate'], 'alt="' . $this->pi_getLL( 'll_rate_link' ) . '" title="' . $this->pi_getLL( 'll_rate_link' ) . '"' ), array( 'tx_ablinklist_pi1[action]' => 'getviewratelink', 'tx_ablinklist_pi1[uid]' => $uid, 'tx_ablinklist_pi1[category_uid]' => $categoryUID ), $this->allowCaching, $pageID );
						} else	{
							$link = $this->pi_LinkTP( $this->local_cObj->stdWrap( $this->pi_getLL( 'll_rate_link'), '' ), array( 'tx_ablinklist_pi1[action]' => 'getviewratelink', 'tx_ablinklist_pi1[uid]' => $uid, 'tx_ablinklist_pi1[category_uid]' => $categoryUID ), $this->allowCaching, $pageID );
						}
						$markerArray['###LINK_RATE###'] = $this->local_cObj->stdWrap( $link, $localConf['linkRate_stdWrap.'] );

						$GLOBALS['TSFE']->ATagParams = $originalATagParams;
					}

					// Substitute the markers in the given sub sub part
					$subpartContent .= $this->cObj->substituteMarkerArray( $this->cObj->getSubpart( $templateCode, "###" . $subSub_1. '###' ), $markerArray );

					// Increase link counter
					$linksTotal++;
				}
			}

			if( $linksTotal != 0 ) {
				// Substitute the sub sub part markers with the given subpartcontents.
				$templateCode = $this->cObj->substituteSubpart( $templateCode, $subSub_2, '' );
				$templateCode = $this->cObj->substituteSubpart( $templateCode, $subSub_1, $subpartContent );
	
				// For next step -> LL VALUES
				$markerArray = array();
				$markerArray['###RESULT_MESSAGE###'] = sprintf( $this->local_cObj->stdWrap( $this->pi_getLL( 'll_result'), $localConf['resultMessage_stdWrap.'] ), $searchFor ,$linksTotal );
			} else	{
				// Create marker array
				$markerArray = array();
				$markerArray['###RESULT_MESSAGE###'] = '';
				$markerArray['###NO_LINKS_MESSAGE###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'no_links_message' ), $localConf['noLinksMessage_stdWrap.'] );

				// Substitute the markers in the given sub sub part
				$subpartContent = $this->cObj->substituteMarkerArray( $this->cObj->getSubpart( $templateCode, "###" . $subSub_2. '###' ), $markerArray );

				// Substitute the sub sub part markers with the given subpartcontents.
				$templateCode = $this->cObj->substituteSubpart( $templateCode, $subSub_2, $subpartContent );
				$templateCode = $this->cObj->substituteSubpart( $templateCode, $subSub_1, '' );
			}
		} else	{
			// No searchword(s) defined
			$markerArray = array();
			$markerArray['###NO_LINKS_MESSAGE###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'no_links_message' ), $localConf['noLinksMessage_stdWrap.'] );

			// Substitute the markers in the given sub sub part
			$subpartContent = $this->cObj->substituteMarkerArray( $this->cObj->getSubpart( $templateCode, "###" . $subSub_2. '###' ), $markerArray );

			// Substitute the sub sub part markers with the given subpartcontents.
			$templateCode = $this->cObj->substituteSubpart( $templateCode, $subSub_2, $subpartContent );
			$templateCode = $this->cObj->substituteSubpart( $templateCode, $subSub_1, '' );

			// For next step -> LL VALUES
			$markerArray = array();
			$markerArray['###RESULT_MESSAGE###'] = '';
		}

		/**
		 * LL VALUES
		 */

		// Create marker array

		$markerArray['###LL_LIS###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_links' ), $localConf['links_stdWrap.'] );
		$markerArray['###LL_CLICKS###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_clicks' ), '' );

		/**
		 * PAGEBROWSER
		 */

		// Render a pagebrowser if needed
		$pointerName = $this->pointerName = 'pointer';

		if( $linksTotal > $listLimit && !$this->conf['noPageBrowser'] && !$this->pi_getFFvalue( $this->flexform, 'noPageBrowser', 's_display' ) )	{
			//  configure pagebrowser vars
			$this->internal['res_count'] = $linksTotal;
			$this->internal['results_at_a_time'] = $listLimit;
			$this->internal['maxPages'] = $this->conf['pageBrowser.']['maxPages'] > 0 ? $this->conf['pageBrowser.']['maxPages'] : 10;
			$this->internal['action'] = $action;
			$this->internal['category_uid'] = null;

			if( !$this->conf['pageBrowser.']['showPBrowserText'] )	{
				$this->LOCAL_LANG[$this->LLkey]['pi_list_browseresults_page'] = '';
			}

			if( $this->conf['userPageBrowserFunc'] )	{
				$markerArray = $this->userProcess( 'userPageBrowserFunc', $markerArray );
			} else	{
				if( $this->conf['usePiBasePagebrowser'] )	{
					$this->internal['pagefloat'] = $this->conf['pageBrowser.']['pagefloat'];
					$this->internal['showFirstLast'] = $this->conf['pageBrowser.']['showFirstLast'];
					$this->internal['showRange'] = $this->conf['pageBrowser.']['showRange'];
					$this->internal['dontLinkActivePage'] = $this->conf['pageBrowser.']['dontLinkActivePage'];

					$wrapArrFields = explode( ',', 'disabledLinkWrap,inactiveLinkWrap,activeLinkWrap,browseLinksWrap,showResultsWrap,showResultsNumbersWrap,browseBoxWrap' );
					$wrapArr = array();
					foreach( $wrapArrFields as $key )	{
						if( $this->conf['pageBrowser.'][$key] )	{
							$wrapArr[$key] = $this->conf['pageBrowser.'][$key];
						}
					}

					// If there is a GETvar in the URL that is not in this list, caching will be disabled for the pagebrowser links
					$this->pi_isOnlyFields = $pointerName . ',action,category_uid';
					$this->pi_alwaysPrev = $this->conf['pageBrowser.']['alwaysPrev'];
					$markerArray['###BROWSE_LINKS###'] = $this->pi_list_browseresults( $this->conf['pageBrowser.']['showResultCount'], $this->conf['pageBrowser.']['tableParams'], $wrapArr, $pointerName, $this->conf['pageBrowser.']['hscText'] );

				} else	{
					$markerArray['###BROWSE_LINKS###'] = $this->makePageBrowser( $pointerName );
				}
			}
		} else	{
			$markerArray['###BROWSE_LINKS###'] = '';
		}

		// Finally substitute the marker array
		$templateCode = $this->cObj->substituteMarkerArray( $templateCode, $markerArray );

		// Return the generated content
		$content .= $templateCode;

		return $content;
	}

	/**
	 * displayTop( $categoryUID = 0 )
	 *
	 * Generates the html for the top view of this extension. In this view the TOPx number of links
	 * concerning rating, clicks and creation time per category (and below) are shown.
	 *
	 * @param	integer		$categoryUID	UID of the category that shall be shown.
	 * @return	string		The generated HTML source for this view.
	 */
	function displayTop( $categoryUID = 0 )	{

		// Init some vars
		$content = '';
		$templateCode = null;
		$conf['subpartMarker'] = 'VIEW_TOP';
		$subSub_1 = 'TOP_LINK';

		// Get the html source between subpart markers from the template file
		$templateCode = $this->cObj->getSubpart( $this->originalTemplateCode, "###" . $conf['subpartMarker'] . '###' );

		// Get local config
		$localConf = $this->conf['topView.'];

		// Save original ATagParams
		$originalATagParams = $GLOBALS['TSFE']->ATagParams;

		// Get flexform settings
		$showTopRated = $this->pi_getFFvalue( $this->flexform, 'showTopRated', 's_display' );
		$showTopAccessed = $this->pi_getFFvalue( $this->flexform, 'showTopAccessed', 's_display' );
		$showMostRecent = $this->pi_getFFvalue( $this->flexform, 'showMostRecent', 's_display' );
		$stickToStartCategoryID = $this->pi_getFFvalue( $this->flexform, 'stickToStartCategoryID', 's_display' );

		// Reset start category based on stickToStartCategoryID
		if( $stickToStartCategoryID )	{
			$startCategoryID = intval( $this->pi_getFFvalue( $this->flexform, 'startCategoryID', 's_display' ) );
			$categoryUID = $startCategoryID ? $startCategoryID : 0;
		}

		// Get flexform config for the ID of the page with the LIST plugin
		$pageID = intval( $this->pi_getFFvalue( $this->flexform, 'pageIDListPlugin', 'sDEF' ) ? $this->pi_getFFvalue( $this->flexform, 'pageIDListPlugin', 'sDEF' ) : $GLOBALS['TSFE']->id );

		// Check which top list(s) shall be displayed
		if( $showTopRated || $showTopAccessed || $showMostRecent )	{
			// Prepare category UID list
			$categoryUIDs = $this->recursiveCategoryGet( $categoryUID );

			foreach( $categoryUIDs as $key => $value )
				$categoryUIDsImploded .= $value . ',';

			// Finally, append current category UID
			$categoryUIDsImploded .= $categoryUID;

			// Prepare array with fields and limits
			$topLists = array(
				'rating' => $showTopRated,
				'clicks' => $showTopAccessed,
				'crdate' => $showMostRecent,
			);

			// Output top lists
			foreach( $topLists as $field => $linkLimit )	{
				if( $linkLimit )	{
					$linkList = null;

					// Get top links
					$databaseTable = $this->tablePrefix . 'link';
					$whereClause = 'category IN (' . $categoryUIDsImploded . ') AND status IN (1,2)' . $this->enableFields;
					$groupBy = '';
					$orderBy = $field . ' DESC';
					$limit = $linkLimit;
					$topLinksResults = $GLOBALS['TYPO3_DB']->exec_SELECTquery( '*', $databaseTable, $whereClause, $groupBy, $orderBy, $limit );

					// Get record overlay
					$topLinks = $this->getRecordOverlay( $topLinksResults, $databaseTable );

					$fieldName = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_'.$field ), '' );

					for( $i = 0; $i < count( $topLinks ); $i++ )	{
						$GLOBALS['TSFE']->ATagParams = $GLOBALS['TSFE']->ATagParams . ( $localConf['linkLabel.']['ATagParams'] ? ' ' . $localConf['linkLabel.']['ATagParams'] : '' );
						$link = $this->pi_LinkTP( $topLinks[$i]['label'], array( 'tx_ablinklist_pi1[action]' => 'getviewdetailsforlink', 'tx_ablinklist_pi1[uid]' => $topLinks[$i]['uid'], 'tx_ablinklist_pi1[category_uid]' => $topLinks[$i]['category'] ), $this->allowCaching, $pageID );
						$GLOBALS['TSFE']->ATagParams = $originalATagParams;
						$linkValue = $topLinks[$i][$field];

						// Wrap values if necessary
						if( $field == 'rating' )
							$linkValue = round( $linkValue, 2);
						if( $field == 'crdate' )
							$linkValue = $this->local_cObj->stdWrap( $linkValue, $this->conf['date_stdWrap.'] );

						// Create marker array
						$markerArrayLink = array();
						$markerArrayLink['###LINK_LABEL###'] = $this->local_cObj->fileResource( $this->conf['iconCategory'], 'alt="Category Icon" title="Category Icon"' ) . ' ' . $this->local_cObj->stdWrap( $link, $localConf['linkLabel_stdWrap.'] );
						$markerArrayLink['###LINK_VALUE###'] = '(' . $linkValue . ')';

						// Substitute the markers in the given sub sub part
						$linkList .= $this->cObj->substituteMarkerArray( $this->cObj->getSubpart( $templateCode, "###" . $subSub_1. '###' ), $markerArrayLink );
					}

					if( count( $topLinks ) > 0 )	{
						// Prepare top message
						$markerArrayMessage = array();
						$markerArrayMessage['###TOP_MESSAGE###'] = $this->local_cObj->stdWrap( 'TOP' . $linkLimit . ': ' . $fieldName, $localConf['topMessage_stdWrap.'] );
	
						$wrappedSubpartArray = array();
						$subpartArray['###TOP_LINK###'] = $linkList;
						$content .= $this->cObj->substituteMarkerArrayCached( $templateCode, $markerArrayMessage, $subpartArray, $wrappedSubpartArray);
					} else	{
						// Prepare top message
						$markerArrayMessage = array();
						$markerArrayMessage['###TOP_MESSAGE###'] = $this->local_cObj->stdWrap( 'TOP' . $linkLimit . ': ' . $fieldName, $localConf['topMessage_stdWrap.'] );
	
						$wrappedSubpartArray = array();
						$subpartArray['###TOP_LINK###'] = '-';
						$content .= $this->cObj->substituteMarkerArrayCached( $templateCode, $markerArrayMessage, $subpartArray, $wrappedSubpartArray);
					}
				}
			}

		} else	{
			// Don't display any top list(s)
			$type = 'noTopListSet';
			$content = $this->displayFEHelp( $type );
		}

		return $content;
	}

	/**
	 * getViewClickedLink( $uid = null )
	 *
	 * Increases the clicks value of a given link uid.
	 * Then forwards the user to the requested page.
	 *
	 * @param	integer		$uid	UID of the link that was clicked.
	 * @return	string		The generated HTML source for this view.
	 */
	function getViewClickedLink( $uid = null )	{

		if( $uid != null )	{
			// Get link data
			$databaseTable = $this->tablePrefix . 'link';
			$theField = 'uid';
			$theValue = $uid;
			$whereClause = $this->enableFields;
			$groupBy = '';
			$orderBy = '';
			$limit = '';
			$linkResult = $GLOBALS['TYPO3_DB']->exec_SELECTquery( '*', $databaseTable, $theField . '=' . $GLOBALS['TYPO3_DB']->quoteStr( $theValue, $databaseTable ) . ' ' . $whereClause, $groupBy, $orderBy, $limit );

			// Get record overlay
			$link = $this->getRecordOverlay( $linkResult, $databaseTable );

			// Get user's IP address
			$ip = t3lib_div::getIndpEnv( 'REMOTE_ADDR' );

			// Check for multiple-click
			if( !t3lib_div::cmpIP( $ip, $link[0]['click_ip'] ) )	{
				// Update clicks and click_ip of the link
				$whereClause = "uid=$uid";
				$updateFields = array(
						'clicks' => $link[0]['clicks'] + 1,
						'click_ip' => $ip,
				);
				$GLOBALS['TYPO3_DB']->exec_UPDATEquery( $this->tablePrefix . 'link', $whereClause, $updateFields );
			}

			$href = $link[0]['href'];
			$href = explode( ' ', $href );
			$href = $href[0];
		} else	{
			die( 'ERROR: No link UID given!' );
		}

		header( 'Location: ' . $this->local_cObj->getTypoLink_URL( $href, array(), '_blank' ) );
		exit;
	}

	/**
	 * getViewDetailsForLink( $uid = null, $categoryUID )
	 *
	 * Shows the detail page for a link.
	 *
	 * @param	integer		$uid	UID of the link.
	 * @param	integer		$categoryUID	UID of the category the link belongs to.
	 * @return	string		The generated HTML source for this view.
	 */
	function getViewDetailsForLink( $uid = null, $categoryUID )	{

		// Init some vars
		$content = null;
		$templateCode = null;
		$conf['subpartMarker'] = 'VIEW_DETAILS_FOR_LINK';

		// Get the html source between subpart markers from the template file
		$templateCode = $this->cObj->getSubpart( $this->originalTemplateCode, "###" . $conf['subpartMarker'] . '###' );

		if( $uid != null )	{
			// Query db for link
			$databaseTable = $this->tablePrefix . 'link';
			$theField = 'uid';
			$theValue = $uid;
			$whereClause = $this->enableFields;
			$groupBy = '';
			$orderBy = '';
			$limit = '';
			$linkResult = $GLOBALS['TYPO3_DB']->exec_SELECTquery( '*', $databaseTable, $theField . '=' . $GLOBALS['TYPO3_DB']->quoteStr( $theValue, $databaseTable ) . ' ' . $whereClause, $groupBy, $orderBy, $limit );

			// Get record overlay
			$link = $this->getRecordOverlay( $linkResult, $databaseTable );

			$markerArray = array();

			if( $link[0]['image'] )	{
				// Get flexform config for displaying of image and create config
				$imageMaxHeight = intval( $this->pi_getFFvalue( $this->flexform, 'imageMaxHeightDetailed', 's_image' ) ? $this->pi_getFFvalue( $this->flexform, 'imageMaxHeightDetailed', 's_image' ) : $this->conf['imageMaxHeightDetailed'] );
				$imageMaxWidth = intval( $this->pi_getFFvalue( $this->flexform, 'imageMaxWidthDetailed', 's_image' ) ? $this->pi_getFFvalue( $this->flexform, 'imageMaxWidthDetailed', 's_image' ) : $this->conf['imageMaxWidthDetailed'] );
				$pictureConfig = array();
				$pictureConfig['image.']['file'] = 'uploads/tx_ablinklist/linkImages/' . $link[0]['image'];
				$pictureConfig['image.']['file.']['maxW'] = $imageMaxWidth;
				$pictureConfig['image.']['file.']['maxH'] = $imageMaxHeight;
				$pictureConfig['image.']['altText'] = $link[0]['label'];
				$pictureConfig['image.']['titleText'] = $links[0]['label'];

				$markerArray['###IMAGE###'] = $this->local_cObj->IMAGE( $pictureConfig['image.'] );
			} else	{
				$markerArray['###IMAGE###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'no_image_message' ), '' );
			}

			// Insert category path
			$markerArray['###CATEGORY_PATH###'] = $this->local_cObj->stdWrap( $this->getCategoryPath( $categoryUID ), $this->conf['categoryPath_stdWrap.'] );

			$markerArray['###LINK_DATE###'] = $this->local_cObj->stdWrap( $link[0]['crdate'], $this->conf['date_stdWrap.'] );
			$markerArray['###LINK_TIME###'] = $this->local_cObj->stdWrap( $link[0]['crdate'], $this->conf['time_stdWrap.'] );
			$markerArray['###LINK_LABEL###'] = $this->local_cObj->stdWrap( $link[0]['label'], $this->conf['linkLabel_stdWrap.'] );
			$markerArray['###LINK_DESCRIPTION###'] = nl2br( $this->local_cObj->stdWrap( $link[0]['description'], '' ) );
			$markerArray['###LINK_CLICKS###'] = $this->local_cObj->stdWrap( $link[0]['clicks'], '' );
			$markerArray['###LINK_RATING###'] = round( $this->local_cObj->stdWrap( $link[0]['rating'], '' ), 2);
			$markerArray['###LINK_RATING_STARS###'] = $this->returnStarsForRating( $link[0]['rating'] );
			$markerArray['###LINK_VOTES###'] = $this->local_cObj->stdWrap( $link[0]['votes'], '' );
			$markerArray['###LINK_HREFLABEL###'] = $link[0]['href'];
			$markerArray['###LINK_HREF###'] = $this->pi_getPageLink( $GLOBALS['TSFE']->id, '_blank', array( 'tx_ablinklist_pi1[action]' => 'getviewclickedlink', 'tx_ablinklist_pi1[uid]' => $uid ) );

//			$linkBack = $this->pi_LinkTP( $this->pi_getLL( 'll_back' ), array( 'tx_ablinklist_pi1[action]' => 'getviewcategory', 'tx_ablinklist_pi1[category_uid]' => $categoryUID ), $this->allowCaching );
//			$markerArray['###LINK_BACK_TO_CATEGORY###'] = $this->local_cObj->stdWrap( $linkBack, '' );
			$markerArray['###LINK_BACK_TO_CATEGORY###'] = '<a href="javascript:history.back()">' . $this->pi_getLL( 'll_back' ) . '</a>';

			/**
			 * LL VALUES
			 */

			$markerArray['###LL_DESCRIPTION###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_description' ), '' );
			$markerArray['###LL_DATE_ADDED###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_added' ), '' );
			$markerArray['###LL_LI###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_link' ), '' );
			$markerArray['###LL_CLICKS###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_clicks' ), '' );
			$markerArray['###LL_RATING###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_rating' ), '' );
			$markerArray['###LL_VOTES###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_votes' ), '' );
			$markerArray['###LL_IMAGE###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_image' ), '' );

			// Finally substitute the marker array
			$templateCode = $this->cObj->substituteMarkerArray( $templateCode, $markerArray );
		} else	{
			die( 'ERROR: No link UID given!' );
		}

		// Return the generated content
		$content = $templateCode;
		return $content;
	}

	/**
	 * getViewAddNewLink( $categoryUID, $errormsg=null )
	 *
	 * Generates a html form where the user can propose a new link. The status of
	 * the newly added link records will be set to 'Pending' . That is why they are not
	 * displayed at once, but after approval by a typo3 backend user.
	 *
	 * @param	integer		$categoryUID	UID of the category the link shall be added to.
	 * @param	string		$errormsg	Error message that shall be printed if set.
	 * @return	string		The generated HTML source for this view.
	 */
	function getViewAddNewLink( $categoryUID, $errormsg = null )	{

		// Init some vars
		$content ='';
		$templateCode = null;
		$conf['subpartMarker'] = 'VIEW_ADD_NEW_LINK';
		$subSub_1 = 'CAPTCHA';

		// Get the html source between subpart markers from the template file
		$templateCode = $this->cObj->getSubpart( $this->originalTemplateCode, "###" . $conf['subpartMarker'] . '###' );

		$selectedCategoryUID = intval( $this->piVars['selectedCategoryUID'] ) ? intval( $this->piVars['selectedCategoryUID'] ) : 0;

		/**
		 * FORM
		 */

		// Generate values for marker array
		$form_action = $this->pi_getPageLink( $GLOBALS['TSFE']->id, '_self', array( 'tx_ablinklist_pi1[action]' => 'getviewaddnewlink', 'tx_ablinklist_pi1[category_uid]' => $categoryUID ) );
		$form_label_name = $this->prefixId . '[label]';
		$form_label_value = htmlspecialchars( strip_tags( $this->piVars['label'] ) );
		$form_description_name = $this->prefixId . '[description]';
		$form_description_value = t3lib_div::formatForTextarea( strip_tags( $this->piVars['description'] ) );
		$form_href_name = $this->prefixId . '[href]';
		$form_href_value = htmlspecialchars( strip_tags( $this->piVars['href'] ) );
		$form_contact_name = $this->prefixId . '[contact]';
		$form_contact_value = htmlspecialchars( strip_tags( $this->piVars['contact'] ) );
		$form_image_name = $this->prefixId . '[image]';
		$form_submit_button_name = $this->prefixId . '[submit_button]';
		$form_submit_button_value = htmlspecialchars( $this->pi_getLL( 'FORM_SUBMIT_BUTTON' ) );
		$form_cancel_button_name = $this->prefixId . '[cancel_button]';
		$form_cancel_button_value = htmlspecialchars( $this->pi_getLL( 'FORM_CANCEL_BUTTON' ) );
		$form_errormsg = $errormsg;

		// Create marker array
		$markerArray = array();
		$markerArray['###FORM_ACTION###'] = $this->local_cObj->stdWrap( $form_action, '' );
		$markerArray['###FORM_LABEL_NAME###'] = $this->local_cObj->stdWrap( $form_label_name, '' );
		$markerArray['###FORM_LABEL_VALUE###'] = $this->local_cObj->stdWrap( $form_label_value, '' );
		$markerArray['###FORM_HREF_NAME###'] = $this->local_cObj->stdWrap( $form_href_name, '' );
		$markerArray['###FORM_HREF_VALUE###'] = $this->local_cObj->stdWrap( $form_href_value, '' );
		$markerArray['###FORM_CATEGORY###'] = $this->getCategorySelect( $categoryUID, $selectedCategoryUID );
		$markerArray['###FORM_CONTACT_NAME###'] = $this->local_cObj->stdWrap( $form_contact_name, '' );
		$markerArray['###FORM_CONTACT_VALUE###'] = $this->local_cObj->stdWrap( $form_contact_value, '' );
		$markerArray['###FORM_IMAGE_NAME###'] = $this->local_cObj->stdWrap( $form_image_name, '' );
		$markerArray['###FORM_DESCRIPTION_NAME###'] = $this->local_cObj->stdWrap( $form_description_name, '' );
		$markerArray['###FORM_DESCRIPTION_VALUE###'] = $this->local_cObj->stdWrap( $form_description_value, '' );

		if ( is_object( $this->freeCap ) )	{
			$markerArray = array_merge( $markerArray, $this->freeCap->makeCaptcha() );
		} else	{
			$templateCode = $this->cObj->substituteSubpart( $templateCode, $subSub_1, '' );
		}

		$markerArray['###FORM_SUBMIT_BUTTON_NAME###'] = $this->local_cObj->stdWrap( $form_submit_button_name, '' );
		$markerArray['###FORM_SUBMIT_BUTTON_VALUE###'] = $this->local_cObj->stdWrap( $form_submit_button_value, '' );
		$markerArray['###FORM_CANCEL_BUTTON_NAME###'] = $this->local_cObj->stdWrap( $form_cancel_button_name, '' );
		$markerArray['###FORM_CANCEL_BUTTON_VALUE###'] = $this->local_cObj->stdWrap( $form_cancel_button_value, '' );
		$markerArray['###FORM_ERRORMSG###'] = $this->local_cObj->stdWrap( $form_errormsg, $this->conf['formErrorMsg_stdWrap.'] );

//		$linkBack = $this->pi_LinkTP( $this->pi_getLL( 'll_back' ), array( 'tx_ablinklist_pi1[action]' => 'getviewcategory', 'tx_ablinklist_pi1[category_uid]' => $categoryUID ), $this->allowCaching );
//		$markerArray['###LINK_BACK_TO_CATEGORY###'] = $this->local_cObj->stdWrap( $linkBack, '' );
		$markerArray['###LINK_BACK_TO_CATEGORY###'] = '<a href="javascript:history.back()">' . $this->pi_getLL( 'll_back' ) . '</a>';

		/**
		 * LL VALUES
		 */

		$markerArray['###LL_ADD_LINK###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_add_link' ), $this->conf['addLink_stdWrap.'] );
		$markerArray['###LL_ADD_LINK_TEXT###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_add_link_text' ), $this->conf['addLinkText_stdWrap.'] );
		$markerArray['###LL_LABEL###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_label' ), '' );
		$markerArray['###LL_LABEL_EXAMPLE###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_label_example' ), '' );
		$markerArray['###LL_WWW###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_www' ), '' );
		$markerArray['###LL_WWW_EXAMPLE###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_www_example' ), '' );
		$markerArray['###LL_CATEGORY###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_cat' ), '' );
		$markerArray['###LL_CONTACT###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_contact' ), '' );
		$markerArray['###LL_CONTACT_EXAMPLE###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_contact_example' ), '' );
		$markerArray['###LL_IMAGE###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_image' ), '' );
		$markerArray['###LL_IMAGE_EXAMPLE###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_image_example' ), '' );
		$markerArray['###LL_DESCRIPTION###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_description' ), '' );

		// Finally substitute the marker array
		$templateCode = $this->cObj->substituteMarkerArray( $templateCode, $markerArray );

		// Return the generated content
		$content = $templateCode;
		return $content;
	}

	/**
	 * getViewAddNewLinkResult( $categoryUID = 0 )
	 *
	 * Creates a new link record in the database and shows a result page to the submitting user.
	 *
	 * @param	integer		$categoryUID	UID of the category the link shall be added to.
	 * @return	string		The generated HTML source for this view.
	 */
	function getViewAddNewLinkResult( $categoryUID = 0 )	{

		// Init some vars
		$content = null;
		$templateCode = null;
		$conf['subpartMarker'] = 'VIEW_ADD_NEW_LINK_RESULT';

		// Get/Set other values
		$pid = $this->sysfolderList;
		$tstamp = time();
		$crdate = time();
		$cruserID = $GLOBALS['TSFE']->fe_user->user['uid'];
		// FIXME: Perhaps better use removeBadHTML()
		$label = htmlspecialchars( strip_tags( $this->piVars['label'] ) );
		$href = htmlspecialchars( strip_tags( $this->piVars['href'] ) );
		$description = htmlspecialchars( strip_tags( $this->piVars['description'] ) );
		$category = $this->getCategoryPath( $categoryUID, false );
		$contact = htmlspecialchars( strip_tags( $this->piVars['contact'] ) );
		$ip = t3lib_div::getIndpEnv( 'REMOTE_ADDR' );
		$status = 0;

		// Handle image (if present)
		$imageName = $_FILES['image']['name'];
		if( $imageName )	{
			$relativePath = 'uploads/tx_ablinklist/linkImages/' . basename( $_FILES['image']['name'] );
			$uploadFile = t3lib_div::getFileAbsFileName( $relativePath );
			$uploadedTempFile = t3lib_div::upload_to_tempfile( $_FILES['image']['tmp_name'] );
			t3lib_div::upload_copy_move( $uploadedTempFile, $uploadFile );
			t3lib_div::unlink_tempfile( $uploadedTempFile );
		}

		$allowAddLinks = $this->pi_getFFvalue( $this->flexform, 'allowAddLinks', 'sDEF' ) ? $this->pi_getFFvalue( $this->flexform, 'allowAddLinks', 'sDEF' ) : $this->conf['allowAddLinks'];

		if( $cruserID != null )	{
			// Do the query for a logged-in user
			$insertFields = array(
				'pid' => $pid,
				'tstamp' => $tstamp,
				'crdate' => $crdate,
				'cruser_id' => $cruserID,
				'label' => addslashes( $label ),
				'description' => addslashes( $description),
				'href' => addslashes( $href ),
				'click_ip' => $ip,
				'vote_ip' => $ip,
				'status' => $status,
				'category' => $categoryUID,
				'image' => $imageName,
				'contact' => $contact
			);
			$GLOBALS['TYPO3_DB']->exec_INSERTquery( $this->tablePrefix . 'link', $insertFields );

		} elseif( $cruserID == null && $allowAddLinks == 1 )	{
			// Do the query for an anonymous user
			$insertFields = array(
				'pid' => $pid,
				'tstamp' => $tstamp,
				'crdate' => $crdate,
				'label' => addslashes( $label ),
				'description' => addslashes( $description),
				'href' => addslashes( $href ),
				'click_ip' => $ip,
				'vote_ip' => $ip,
				'status' => $status,
				'category' => $categoryUID,
				'image' => $imageName,
				'contact' => $contact
			);
			$GLOBALS['TYPO3_DB']->exec_INSERTquery( $this->tablePrefix . 'link', $insertFields );
		}

		// Generate and send notification email to admin
		$email = $this->pi_getFFvalue( $this->flexform, 'adminEmail', 'sDEF' ) ? $this->pi_getFFvalue( $this->flexform, 'adminEmail', 'sDEF' ) : $this->conf['adminEmail'];
		$subject = $this->pi_getFFvalue( $this->flexform, 'emailSubjectAdd', 'sDEF' ) ? $this->pi_getFFvalue( $this->flexform, 'emailSubjectAdd', 'sDEF' ) : $this->conf['emailSubjectAdd'];
		$ll_label = $this->pi_getLL( 'll_label' );
		$ll_href = $this->pi_getLL( 'll_www' );
		$ll_description = $this->pi_getLL( 'll_description' );
		$ll_category = $this->pi_getLL( 'll_cat' );
		$ll_contact = $this->pi_getLL( 'll_contact' );
		$ll_image = $this->pi_getLL( 'll_image' );

		$headers = "From: \"Modern Linklist\" <$email>\r\n";
		$headers .= "X-Mailer: Modern Linklist Info Mailer\r\n";

		$message = $ll_label . ': ' . $label . "\r\n" .
			   $ll_href . ': ' . $href . "\r\n" .
			   $ll_description . ': ' . $description . "\r\n" .
			   $ll_category . ': ' . $category . "\r\n" .
			   $ll_contact . ': ' . $contact . "\r\n" .
			   $ll_image . ': ' . $imageName;

		$encoding = $GLOBALS['TSFE']->tmpl->setup['config.']['notification_email_encoding'] ? $GLOBALS['TSFE']->tmpl->setup['config.']['notification_email_encoding'] : 'quoted-printable';

		t3lib_div::plainMailEncoded( $email, $subject, $message, $headers, $encoding );

		// Get the html source between subpart markers from the template file
		$templateCode = $this->cObj->getSubpart( $this->originalTemplateCode, "###" . $conf['subpartMarker'] . '###' );

		$markerArray = array();
//		$linkBack = $this->pi_LinkTP( $this->pi_getLL( 'll_back' ), array( 'tx_ablinklist_pi1[action]' => 'getviewcategory', 'tx_ablinklist_pi1[category_uid]' => $categoryUID ), $this->allowCaching );
//		$markerArray['###LINK_BACK_TO_CATEGORY###'] = $this->local_cObj->stdWrap( $linkBack, '' );
		$markerArray['###LINK_BACK_TO_CATEGORY###'] = '<a href="javascript:history.go(-2)">' . $this->pi_getLL( 'll_back' ) . '</a>';
		$markerArray['###LL_LI_ADD_THX###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_li_add_thx' ), '' );

		// Finally substitute the marker array
		$templateCode = $this->cObj->substituteMarkerArray( $templateCode, $markerArray );

		// Return the generated content
		$content = $templateCode;
		return $content;
	}

	/**
	 * getViewReportBrokenLink( $uid = null, $categoryUID )
	 *
	 * When a user wants to report a broken link, this view is displayed. The
	 * user has to accept the report, then an e-mail is sent to the given admin address.
	 *
	 * @param	integer		$uid	UID of the broken link record.
	 * @param	integer		$categoryUID	UID of the category the link belongs to.
	 * @return	string		The generated HTML source for this view.
	 */
	function getViewReportBrokenLink( $uid = null, $categoryUID )	{

		// Init some vars
		$content = null;
		$templateCode = null;						 // Hold the template source code
		$conf['subpartMarker'] = 'VIEW_REPORT_BROKEN_LINK';

		// Get the html source between subpart markers from the template file
		$templateCode = $this->cObj->getSubpart( $this->originalTemplateCode, "###" . $conf['subpartMarker'] . '###' );

		if( $uid != null )	{

			// Query db for link
			$databaseTable = $this->tablePrefix . 'link';
			$theField = 'uid';
			$theValue = $uid;
			$whereClause = $this->enableFields;
			$groupBy = '';
			$orderBy = '';
			$limit = '';
			$linkResult = $GLOBALS['TYPO3_DB']->exec_SELECTquery( '*', $databaseTable, $theField . '=' . $GLOBALS['TYPO3_DB']->quoteStr( $theValue, $databaseTable ) . ' ' . $whereClause, $groupBy, $orderBy, $limit );
	
			// Get record overlay
			$link = $this->getRecordOverlay( $linkResult, $databaseTable );
	
			// Generate values for marker array
			$form_action = $this->pi_getPageLink( $GLOBALS['TSFE']->id, '_self', array( 'tx_ablinklist_pi1[action]' => 'getviewreportbrokenlink', 'tx_ablinklist_pi1[uid]' => $uid, 'tx_ablinklist_pi1[category_uid]' => $categoryUID ) );
			$form_yes_button_name = $this->prefixId . '[submit_button]';
			$form_yes_button_value = htmlspecialchars( $this->pi_getLL( 'FORM_YES_BUTTON' ) );
			$form_no_button_name = $this->prefixId . '[cancel_button]';
			$form_no_button_value = htmlspecialchars( $this->pi_getLL( 'FORM_NO_BUTTON' ) );
	
			$markerArray = array();
			$markerArray['###FORM_ACTION###'] = $this->local_cObj->stdWrap( $form_action, '' );
			$markerArray['###FORM_YES_BUTTON_NAME###'] = $this->local_cObj->stdWrap( $form_yes_button_name, '' );
			$markerArray['###FORM_YES_BUTTON_VALUE###'] = $this->local_cObj->stdWrap( $form_yes_button_value, '' );
			$markerArray['###FORM_NO_BUTTON_NAME###'] = $this->local_cObj->stdWrap( $form_no_button_name, '' );
			$markerArray['###FORM_NO_BUTTON_VALUE###'] = $this->local_cObj->stdWrap( $form_no_button_value, '' );
			$markerArray['###LINK_LABEL###'] = $this->local_cObj->stdWrap( $link[0]['label'], '' );
			$markerArray['###LINK_HREF###'] = $this->local_cObj->stdWrap( $link[0]['href'], '' );
	
	//		$linkBack = $this->pi_LinkTP( $this->pi_getLL( 'll_back' ), array( 'tx_ablinklist_pi1[action]' => 'getviewcategory', 'tx_ablinklist_pi1[category_uid]' => $categoryUID ), $this->allowCaching );
	//		$markerArray['###LINK_BACK_TO_CATEGORY###'] = $this->local_cObj->stdWrap( $linkBack, '' );
			$markerArray['###LINK_BACK_TO_CATEGORY###'] = '<a href="javascript:history.back()">' . $this->pi_getLL( 'll_back' ) . '</a>';
	
			/**
			 * LL VALUES
			 */
	
			$markerArray['###LL_REPORT_LINK_BROKEN_TEXT###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_report_link_broken_text' ), $this->conf['reportLinkBrokenText_stdWrap.'] );
	
			// Finally substitute the marker array
			$templateCode = $this->cObj->substituteMarkerArray( $templateCode, $markerArray );
		} else	{
			die( 'ERROR: No link UID given!' );
		}

		// Return the generated content
		$content = $templateCode;
		return $content;
	}

	/**
	 * getViewReportBrokenLinkResult( $uid = null, $categoryUID )
	 *
	 * Updates the status of the link to 'Reported broken' => '2' and shows a result page to the submitting user.
	 *
	 * @param	integer		$uid	UID of the broken link record.
	 * @param	integer		$categoryUID	UID of the category the link belongs to.
	 * @return	string		The generated HTML source for this view.
	 */
	function getViewReportBrokenLinkResult( $uid = null, $categoryUID )	{

		// Init some vars
		$content = null;
		$templateCode = null;						 // Hold the template source code
		$conf['subpartMarker'] = 'VIEW_REPORT_BROKEN_LINK_RESULT';

		// Get the html source between subpart markers from the template file
		$templateCode = $this->cObj->getSubpart( $this->originalTemplateCode, "###" . $conf['subpartMarker'] . '###' );

		if( $uid != null )	{

			// Query db for link
			$databaseTable = $this->tablePrefix . 'link';
			$theField = 'uid';
			$theValue = $uid;
			$whereClause = $this->enableFields;
			$groupBy = '';
			$orderBy = '';
			$limit = '';
			$linkResult = $GLOBALS['TYPO3_DB']->exec_SELECTquery( '*', $databaseTable, $theField . '=' . $GLOBALS['TYPO3_DB']->quoteStr( $theValue, $databaseTable ) . ' ' . $whereClause, $groupBy, $orderBy, $limit );

			// Get record overlay
			$link = $this->getRecordOverlay( $linkResult, $databaseTable );
	
			// Update the status of the link to 'Reported broken' => '2'
			$whereClause = "uid=$uid";
			$updateFields = array(
					'status' => '2',
			);
			$GLOBALS['TYPO3_DB']->exec_UPDATEquery( $this->tablePrefix . 'link', $whereClause, $updateFields );
	
			// Generate and send notification email to admin
			$email = $this->pi_getFFvalue( $this->flexform, 'adminEmail', 'sDEF' ) ? $this->pi_getFFvalue( $this->flexform, 'adminEmail', 'sDEF' ) : $this->conf['adminEmail'];
			$subject = $this->pi_getFFvalue( $this->flexform, 'emailSubjectBroken', 'sDEF' ) ? $this->pi_getFFvalue( $this->flexform, 'emailSubjectBroken', 'sDEF' ) : $this->conf['emailSubjectBroken'];
			$ll_label = $this->pi_getLL( 'll_label' );
			$ll_href = $this->pi_getLL( 'll_www' );
			$ll_description = $this->pi_getLL( 'll_description' );
			$ll_category = $this->pi_getLL( 'll_cat' );

			$headers = "From: \"Modern Linklist\" <$email>\r\n";
			$headers .= "X-Mailer: Modern Linklist Info Mailer\r\n";

			$message = $ll_label . ': ' . $link[0]['label'] . "\r\n" .
				   $ll_href . ': ' . $link[0]['href'] . "\r\n" .
				   $ll_description . ': ' . $link[0]['description'] . "\r\n" .
				   $ll_category . ': ' . $this->getCategoryPath( $link[0]['category'], false );

			$encoding = $GLOBALS['TSFE']->tmpl->setup['config.']['notification_email_encoding'] ? $GLOBALS['TSFE']->tmpl->setup['config.']['notification_email_encoding'] : 'quoted-printable';
	
			t3lib_div::plainMailEncoded( $email, $subject, $message, $headers, $encoding );
	
			$markerArray = array();
	//		$linkBack = $this->pi_LinkTP( $this->pi_getLL( 'll_back' ), array( 'tx_ablinklist_pi1[action]' => 'getviewcategory', 'tx_ablinklist_pi1[category_uid]' => $categoryUID ), $this->allowCaching );
	//		$markerArray['###LINK_BACK_TO_CATEGORY###'] = $this->local_cObj->stdWrap( $linkBack, '' );
			$markerArray['###LINK_BACK_TO_CATEGORY###'] = '<a href="javascript:history.go(-2)">' . $this->pi_getLL( 'll_back' ) . '</a>';
			$markerArray['###LL_LI_BROKEN_THX###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_li_broken_thx' ), '' );
	
			// Finally substitute the marker array
			$templateCode = $this->cObj->substituteMarkerArray( $templateCode, $markerArray );
		} else	{
			die( 'ERROR: No link UID given!' );
		}

		// Return the generated content
		$content = $templateCode;
		return $content;
	}

	/**
	 * getViewRateLink( $uid = null, $categoryUID )
	 *
	 * When a user wants to rate a link, this view is displayed. The
	 * user has to accept the report.
	 *
	 * @param	integer		$uid	UID of the link record to rate.
	 * @param	integer		$categoryUID	UID of the category the link belongs to.
	 * @return	string		The generated HTML source for this view.
	 */
	function getViewRateLink( $uid = null, $categoryUID )	{

		// Init some vars
		$content = null;
		$templateCode = null;	   // Hold the template source code
		$conf['subpartMarker'] = 'VIEW_RATE_LINK'; // Holds a subpart marker.

		// Get the html source between subpart markers from the template file
		$templateCode = $this->cObj->getSubpart( $this->originalTemplateCode, "###" . $conf['subpartMarker'] . '###' );

		if( $uid != null )	{

			// Query db for link
			$databaseTable = $this->tablePrefix . 'link';
			$theField = 'uid';
			$theValue = $uid;
			$whereClause = $this->enableFields;
			$groupBy = '';
			$orderBy = '';
			$limit = '';
			$linkResult = $GLOBALS['TYPO3_DB']->exec_SELECTquery( '*', $databaseTable, $theField . '=' . $GLOBALS['TYPO3_DB']->quoteStr( $theValue, $databaseTable ) . ' ' . $whereClause, $groupBy, $orderBy, $limit );

			// Get record overlay
			$link = $this->getRecordOverlay( $linkResult, $databaseTable );
	
			// Generate values for marker array
			$form_action = $this->pi_getPageLink( $GLOBALS['TSFE']->id, '_self', array( 'tx_ablinklist_pi1[action]' => 'getviewratelink', 'tx_ablinklist_pi1[uid]' => $uid, 'tx_ablinklist_pi1[category_uid]' => $categoryUID ) );
			$form_submit_button_name = $this->prefixId . '[submit_button]';
			$form_submit_button_value = htmlspecialchars( $this->pi_getLL( 'FORM_SUBMIT_BUTTON' ) );
			$form_cancel_button_name = $this->prefixId . '[cancel_button]';
			$form_cancel_button_value = htmlspecialchars( $this->pi_getLL( 'FORM_CANCEL_BUTTON' ) );
	
			$markerArray = array();
			$markerArray['###FORM_ACTION###'] = $this->local_cObj->stdWrap( $form_action, '' );
			$markerArray['###FORM_SUBMIT_BUTTON_NAME###'] = $this->local_cObj->stdWrap( $form_submit_button_name, '' );
			$markerArray['###FORM_SUBMIT_BUTTON_VALUE###'] = $this->local_cObj->stdWrap( $form_submit_button_value, '' );
			$markerArray['###FORM_CANCEL_BUTTON_NAME###'] = $this->local_cObj->stdWrap( $form_cancel_button_name, '' );
			$markerArray['###FORM_CANCEL_BUTTON_VALUE###'] = $this->local_cObj->stdWrap( $form_cancel_button_value, '' );
			$markerArray['###LINK_LABEL###'] = $this->local_cObj->stdWrap( $link[0]['label'], '' );
			$markerArray['###LINK_HREF###'] = $this->local_cObj->stdWrap( $link[0]['href'], '' );
			$markerArray['###LINK_RATING###'] = round( $this->local_cObj->stdWrap( $link[0]['rating'], '' ), 2);
			$markerArray['###LINK_VOTES###'] = $this->local_cObj->stdWrap( $link[0]['votes'], '' );
	
	//		$linkBack = $this->pi_LinkTP( $this->pi_getLL( 'll_back' ), array( 'tx_ablinklist_pi1[action]' => 'getviewcategory', 'tx_ablinklist_pi1[category_uid]' => $categoryUID ), $this->allowCaching );
	//		$markerArray['###LINK_BACK_TO_CATEGORY###'] = $this->local_cObj->stdWrap( $linkBack, '' );
			$markerArray['###LINK_BACK_TO_CATEGORY###'] = '<a href="javascript:history.back()">' . $this->pi_getLL( 'll_back' ) . '</a>';
	
			/**
			 * LL VALUES
			 */

			$markerArray['###LL_RATE_LINK_TEXT###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_rate_link_text' ), $this->conf['rateLinkText_stdWrap.'] );
			$markerArray['###LL_VERY_BAD###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_very_bad' ), '' );
			$markerArray['###LL_VERY_GOOD###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_very_good' ), '' );
			$markerArray['###LL_RATING_CURRENT###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_rating_current' ), '' );
			$markerArray['###LL_VOTES###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_votes' ), '' );
	
			// Finally substitute the marker array
			$templateCode = $this->cObj->substituteMarkerArray( $templateCode, $markerArray );
		} else	{
			die( 'ERROR: No link UID given!' );
		}

		// Return the generated content
		$content = $templateCode;
		return $content;
	}

	/**
	 * getViewRateLinkResult( $uid = null, $categoryUID )
	 *
	 * Rates the link and shows a result page to the submitting user.
	 *
	 * @param	integer		$uid	UID of the link record to rate.
	 * @param	integer		$categoryUID	UID of the category the link belongs to.
	 * @return	string		The generated HTML source for this view.
	 */
	function getViewRateLinkResult( $uid = null, $categoryUID )	{
		// Init some vars
		$content = null;
		$templateCode = null;	   // Hold the template source code
		$conf['subpartMarker'] = 'VIEW_RATE_LINK_RESULT'; // Holds a subpart marker.
		$subSub_1 = 'LINK';

		// Get the html source between subpart markers from the template file
		$templateCode = $this->cObj->getSubpart( $this->originalTemplateCode, "###" . $conf['subpartMarker'] . '###' );

		if( $uid != null )	{

			// Query db for link
			$databaseTable = $this->tablePrefix . 'link';
			$theField = 'uid';
			$theValue = $uid;
			$whereClause = $this->enableFields;
			$groupBy = '';
			$orderBy = '';
			$limit = '';
			$linkResult = $GLOBALS['TYPO3_DB']->exec_SELECTquery( '*', $databaseTable, $theField . '=' . $GLOBALS['TYPO3_DB']->quoteStr( $theValue, $databaseTable ) . ' ' . $whereClause, $groupBy, $orderBy, $limit );

			// Get record overlay
			$link = $this->getRecordOverlay( $linkResult, $databaseTable );
	
			// Get user's IP address
			$ip = t3lib_div::getIndpEnv( 'REMOTE_ADDR' );
	
			// Check for multiple-rating
			if( !t3lib_div::cmpIP( $ip, $link[0]['vote_ip'] ) )	{
				// Get old rating and votes of the link
				$oldRating = $link[0]['rating'];
				$oldVotes = $link[0]['votes'];
	
				// Get submitted rating
				$submittedRating = intval( $this->piVars['rating'] );
	
				if( $submittedRating > 0 )	{
					$newVotes = $oldVotes + 1;
					$newRating = ( $oldRating * $oldVotes + $submittedRating ) / $newVotes;
	
					// Update rating, votes and vote_ip of the link
					$whereClause = "uid=$uid";
					$updateFields = array(
							'rating' => $newRating,
							'votes' => $newVotes,
							'vote_ip' => $ip,
					);
					$GLOBALS['TYPO3_DB']->exec_UPDATEquery( $this->tablePrefix . 'link', $whereClause, $updateFields );
				}
			}
	
			$markerArray = array();
	//		$linkBack = $this->pi_LinkTP( $this->pi_getLL( 'll_back' ), array( 'tx_ablinklist_pi1[action]' => 'getviewcategory', 'tx_ablinklist_pi1[category_uid]' => $categoryUID ), $this->allowCaching );
	//		$markerArray['###LINK_BACK_TO_CATEGORY###'] = $this->local_cObj->stdWrap( $linkBack, '' );
			$markerArray['###LINK_BACK_TO_CATEGORY###'] = '<a href="javascript:history.go(-2)">' . $this->pi_getLL( 'll_back' ) . '</a>';
			$markerArray['###LL_LI_RATE_THX###'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_li_rate_thx' ), '' );
	
			// Finally substitute the marker array
			$templateCode = $this->cObj->substituteMarkerArray( $templateCode, $markerArray );
		} else	{
			die( 'ERROR: No link UID given!' );
		}

		// Return the generated content
		$content = $templateCode;
		return $content;
	}

	/**
	 * makePageBrowser( $pointerName = 'pointer' )
	 *
	 * This is a copy of the function pi_list_browseresults from class.tslib_piBase.php
	 * Returns a results browser. This means a bar of page numbers plus a "previous" and "next" link. For each entry in the bar the piVars "$pointerName" will be pointing to the "result page" to show.
	 * Using $this->piVars['$pointerName'] as pointer to the page to display
	 * Using $this->internal['res_count'], $this->internal['results_at_a_time'] and $this->internal['maxPages'] for count number, how many results to show and the max number of pages to include in the browse bar.
	 *
	 * @param	string	varname for the pointer
	 * @return	string	Output HTML, wrapped in <div>-tags with a class attribute
	 */
	function makePageBrowser( $pointerName = 'pointer' )	{

		// Initializing variables
		$showResultCount = $this->conf['pageBrowser.']['showResultCount'];
		$tableParams = $this->conf['pageBrowser.']['tableParams'];
		$pointer = intval( $this->piVars[$pointerName] );
		$count = $this->internal['res_count'];
		$results_at_a_time = t3lib_div::intInRange( $this->internal['results_at_a_time'], 1, 1000);
		$maxPages = t3lib_div::intInRange( $this->internal['maxPages'], 1, 100);
		$max = t3lib_div::intInRange( ceil( $count/$results_at_a_time), 1, $maxPages );
		$action = $this->internal['action'];
		$categoryUID = $this->internal['category_uid'];
		$links = array();

		// Make browse-table/links:
		if( $this->pi_alwaysPrev >= 0 )	{
			if( $pointer > 0 )	{
				$links[] = '<td nowrap="nowrap"><p>' . $this->pi_linkTP_keepPIvars( $this->pi_getLL( 'pi_list_browseresults_prev', '< Previous' ), array( 'tx_ablinklist_pi1[action]' => $action, 'tx_ablinklist_pi1[category_uid]' => $categoryUID, $pointerName => ( $pointer - 1 ? $pointer - 1 : '' ) ), $this->allowCaching ) . '</p></td>';
			} elseif( $this->pi_alwaysPrev )	{
				$links[] = '<td nowrap="nowrap"><p>' . $this->pi_getLL( 'pi_list_browseresults_prev', '< Previous' ) . '</p></td>';
			}
		}

		for( $a= 0; $a < $max; $a++ )	{
			$links[] = '<td' .( $pointer == $a ? $this->pi_classParam( 'browsebox-SCell' ) : '' ) . ' nowrap="nowrap"><p>' . $this->pi_linkTP_keepPIvars(trim( $this->pi_getLL( 'pi_list_browseresults_page', 'Page' ) . ' ' . ( $a + 1) ), array( 'tx_ablinklist_pi1[action]' => $action, 'tx_ablinklist_pi1[category_uid]' => $categoryUID, $pointerName => ( $a ? $a : '' ) ), $this->allowCaching ) . '</p></td>';
		}

		if( $pointer < ceil( $count/$results_at_a_time ) - 1 )	{
			$links[] = '<td nowrap="nowrap"><p>' . $this->pi_linkTP_keepPIvars( $this->pi_getLL( 'pi_list_browseresults_next', 'Next >' ), array( 'tx_ablinklist_pi1[action]' => $action, 'tx_ablinklist_pi1[category_uid]' => $categoryUID, $pointerName => $pointer + 1), $this->allowCaching ) . '</p></td>';
		}

		$pR1 = $pointer * $results_at_a_time + 1;
		$pR2 = $pointer * $results_at_a_time + $results_at_a_time;
		$sTables = '
			<!--
			 List browsing box:
			-->
			<div' . $this->pi_classParam( 'browsebox' ) . '>' . ( $showResultCount ? '<p>' . ( $this->internal['res_count'] ?
				sprintf( str_replace( '###SPAN_BEGIN###', '<span' . $this->pi_classParam( 'browsebox-strong' ) . '>', $this->pi_getLL( 'pi_list_browseresults_displays', 'Displaying results ###SPAN_BEGIN###%s to %s</span> out of ###SPAN_BEGIN###%s</span>' ) ),
				$this->internal['res_count'] > 0 ? $pR1 : 0, min(array( $this->internal['res_count'], $pR2) ), $this->internal['res_count'] ) :
				$this->pi_getLL( 'pi_list_browseresults_noResults', 'Sorry, no items were found. ' ) ) . '</p>' : '' ) . '
				<' . trim( 'table ' . $tableParams ) . '><tr>' .implode( '', $links ) . '</tr></table></div>';

		return $sTables;
	}

	/**
	 * userProcess( $configKey, $variable )
	 *
	 * Calls a user function defined with TypoScript.
	 *
	 * @param	string	$configKey	If empty $variable is not processed.
	 * @param	mixed		$variable	This variable is processed in the user function.
	 * @return	mixed		The processed $variable
	 */
	function userProcess( $configKey, $variable ) {
		if ( $this->conf[$configKey] )	{
			$functionConfig = $this->conf[$configKey . '.'];
			$functionConfig['parentObj'] = & $this;
			$variable = $GLOBALS['TSFE']->cObj->callUserFunction( $this->conf[$configKey], $functionConfig, $variable );
		}

		return $variable;
	}

	/**
	 * initPidList()
	 *
	 * Extends the pid_list given from $conf or FF recursively by the pids of the subpages.
	 * Generates an array from the pagetitles of those pages.
	 *
	 * @return	void
	 */
	function initPidList()	{
		// Create pid_list with page IDs from where to fetch the category/link records
		$pidList = $this->pi_getFFvalue( $this->flexform, 'pages', 'sDEF' );
		$pidList = $pidList ? $pidList : trim($this->cObj->stdWrap( $this->conf['pid_list'], $this->conf['pid_list.'] ) );
		$pidList = $pidList ? implode( t3lib_div::intExplode( ',', $pidList ), ',' ) : $GLOBALS['TSFE']->id;

		// Set recursive setting
		$recursive = $this->pi_getFFvalue( $this->flexform, 'recursive', 'sDEF' );
		$recursive = is_numeric( $recursive ) ? $recursive : $this->cObj->stdWrap( $this->conf['recursive'], $this->conf['recursive.'] );

		// Extend the pid_list by recursive levels
		$this->pid_list = $this->pi_getPidList( $pidList, $recursive );
		$this->pid_list = $this->pid_list ? $this->pid_list : 0;
	}

	/**
	 * zzz_recursiveLinkCount( $categoryUID )
	 * NOT USED NOW
	 * Counts the number of links in the current category and calls itself recursively to sum up
	 * the number of links in all subcategories.
	 *
	 * @param	integer		$categoryUID	The UID of the category.
	 * @return	integer		The number of links in the current category and in all subcategories.
	 */
	function zzz_recursiveLinkCount( $categoryUID )	{

		// Get subcategories

		$databaseTable = $this->tablePrefix . 'category';
		$theField = 'catuid_before';
		$theValue = $categoryUID;
		$whereClause = $this->enableFieldsCategory;
		$groupBy = '';
		$orderBy = '';
		$limit = '';
		$categoriesResults = $GLOBALS['TYPO3_DB']->exec_SELECTquery( '*', $databaseTable, $theField . '=' . $GLOBALS['TYPO3_DB']->quoteStr( $theValue, $databaseTable ) . ' ' . $whereClause, $groupBy, $orderBy, $limit );


		
		// Get record overlay
		$categories = $this->getRecordOverlay( $categoriesResults, $databaseTable );

		if( count( $categories ) > 0 )	{
			// Get number of links in current category
/*
			$databaseTable = $this->tablePrefix . 'link';
			$theField = 'category';
			$theValue = $categoryUID;
			$whereClause = 'AND status IN (1,2)' . $this->enableFields;
			$groupBy = '';
			$orderBy = '';
			$limit = '';
			$linksCurrentCategoryResults = $GLOBALS['TYPO3_DB']->exec_SELECTquery( '*', $databaseTable, $theField . '=' . $GLOBALS['TYPO3_DB']->quoteStr( $theValue, $databaseTable ) . ' ' . $whereClause, $groupBy, $orderBy, $limit );
*/
			
			// Count number of links in current category
			$databaseTable = $this->tablePrefix . 'link';
			$relationTable = $this->tablePrefix .'link_category_mm';
			$foreignTable = $this->tablePrefix .'category';
			$theField = $foreignTable.'.uid';
			$theValue = $categoryUID;
			$whereClause = 'AND '.$databaseTable.'.status IN (1,2)'. $this->enableFields;
			$groupBy = '';
			$orderBy = '';
			$limit = '';
	
			$linksCurrentCategoryResults = $GLOBALS['TYPO3_DB']->exec_SELECT_mm_query( $databaseTable.'.*', $databaseTable,$relationTable,$foreignTable, ' AND '.$theField . '=' . $GLOBALS['TYPO3_DB']->quoteStr( $theValue, $databaseTable ) . ' ' . $whereClause, $groupBy, $orderBy, $limit );
//			debug ($GLOBALS['TYPO3_DB']->debug_lastBuiltQuery, 'recursiveLinkCount');
			
			
			// Get record overlay
			$linksCurrentCategory = $this->getRecordOverlay( $linksCurrentCategoryResults, $databaseTable );
//			debug ($linksCurrentCategoryResults, 'linksCurrentCategoryResults');
//			debug ($linksCurrentCategory, 'linksCurrentCategory');

			// Do the recursion for all subcategories
			for( $i = 0; $i < count( $categories ); $i++ )	{
				$categoryCount += $this->recursiveLinkCount( $categories[$i]['uid'] );
			}

			// Return the number of links in the current category and in all subcategories
			
			
			return count( $linksCurrentCategory ) + $categoryCount;
		} else	{
			// No subcategories below the current level => return number of links in the current category
/*
			$databaseTable = $this->tablePrefix . 'link';
			$theField = 'category';
			$theValue = $categoryUID;
			$whereClause = 'AND status IN (1,2)' . $this->enableFields;
			$groupBy = '';
			$orderBy = '';
			$limit = '';
			$numberOfLinksResults = $GLOBALS['TYPO3_DB']->exec_SELECTquery( '*', $databaseTable, $theField . '=' . $GLOBALS['TYPO3_DB']->quoteStr( $theValue, $databaseTable ) . ' ' . $whereClause, $groupBy, $orderBy, $limit );
*/
			$databaseTable = $this->tablePrefix . 'link';
			$relationTable = $this->tablePrefix .'link_category_mm';
			$foreignTable = $this->tablePrefix .'category';
			$theField = $foreignTable.'.uid';
			$theValue = $categoryUID;
			$whereClause = 'AND '.$databaseTable.'.status IN (1,2)'. $this->enableFields;
			$groupBy = '';
			$orderBy = '';
			$limit = '';
	
			$numberOfLinksResults  = $GLOBALS['TYPO3_DB']->exec_SELECT_mm_query( $databaseTable.'.*', $databaseTable,$relationTable,$foreignTable, ' AND '.$theField . '=' . $GLOBALS['TYPO3_DB']->quoteStr( $theValue, $databaseTable ) . ' ' . $whereClause, $groupBy, $orderBy, $limit );
//			debug ($GLOBALS['TYPO3_DB']->debug_lastBuiltQuery);

			// Get record overlay
			$numberOfLinks = $this->getRecordOverlay( $numberOfLinksResults, $databaseTable );

			return count( $numberOfLinks );
		}
	}

	/**
	 * recursiveLinkCount( $categoryUID )
	 *
	 * Counts the number of links in the current category and calls itself recursively to sum up
	 * the number of links in all subcategories.
	 *
	 * @param	integer		$categoryUID	The UID of the category.
	 * @return	integer		The number of links in the current category and in all subcategories.
	 */
	
	function recursiveLinkCount( $categoryUID )	{

		$categoryUIDs = $this->recursiveCategoryGet( $categoryUID );

		foreach( $categoryUIDs as $key => $value )
			$categoryUIDsImploded .= $value . ',';

		// Finally, append current category UID
		$categoryUIDsImploded .= $categoryUID;

		$databaseTable = $this->tablePrefix . 'link';
		$relationTable = $this->tablePrefix .'link_category_mm';
		$foreignTable = $this->tablePrefix .'category';
		$theField = $foreignTable.'.uid';
		$theValue = $categoryUID;
		$whereClause = ' AND '. $theField.' IN (' . $categoryUIDsImploded . ')AND '.$databaseTable.'.status IN (1,2)'. $this->enableFields;
		$groupBy = '';
		$orderBy = '';
		$limit = '';

		$linksCurrentCategoryResults = $GLOBALS['TYPO3_DB']->exec_SELECT_mm_query( $databaseTable.'.*', $databaseTable,$relationTable,$foreignTable, $whereClause, $groupBy, $orderBy, $limit );
//		debug ($GLOBALS['TYPO3_DB']->debug_lastBuiltQuery, 'recursiveLinkCount');
	
		// Get record overlay
		$linksCurrentCategory = $this->getRecordOverlay( $linksCurrentCategoryResults, $databaseTable );
//		debug ($linksCurrentCategoryResults, 'linksCurrentCategoryResults');
//		debug ($linksCurrentCategory, 'linksCurrentCategory');

		return count( $linksCurrentCategory );
	}		
		


	/**
	 * recursiveCategoryGet( $categoryUID )
	 *
	 * Adds the UID of the current category to an array and calls itself recursively to add
	 * the UIDs of all subcategories.
	 *
	 * @param	integer		$categoryUID	The UID of the category.
	 * @return	array		An array with the UID of the current category and of all categories below the current level.
	 */
	function recursiveCategoryGet( $categoryUID )	{

		// Get subcategories
		$databaseTable = $this->tablePrefix . 'category';
		$theField = 'catuid_before';
		$theValue = $categoryUID;
		$whereClause = $this->enableFieldsCategory;
		$groupBy = '';
		$orderBy = '';
		$limit = '';
		$categoriesResults = $GLOBALS['TYPO3_DB']->exec_SELECTquery( '*', $databaseTable, $theField . '=' . $GLOBALS['TYPO3_DB']->quoteStr( $theValue, $databaseTable ) . ' ' . $whereClause, $groupBy, $orderBy, $limit );
//		debug ($GLOBALS['TYPO3_DB']->debug_lastBuiltQuery, 'categoriesResults');

		// Get record overlay
		$categories = $this->getRecordOverlay( $categoriesResults, $databaseTable );

		$array = array();

		if( count( $categories ) > 0 )	{
			// Do the recursion for all subcategories
			for( $i = 0; $i < count( $categories ); $i++ )	{
				$array = array_merge( $array, $this->recursiveCategoryGet( $categories[$i]['uid'] ));
			}

			// Return array with the current category UID and the UIDs of all subcategories
			$array = array_merge( $array, array( $categoryUID ) );
//			debug ($array, 'array - recursiveCategoryGet');
			return $array;
		} else	{
			// No subcategories below the current level => return array with the UID of the current category
//			debug (array( $categoryUID ), ' one array - recursiveCategoryGet');
			return array( $categoryUID );
		}
	}

	/**
	 * getCategoryPath( $categoryUID, $showLinks = true )
	 *
	 * Generates a path menu with the correspondig category labels. This enables
	 * the user to reach all levels in the category tree with one click.
	 *
	 * @param	integer		$categoryUID	The UID of the category the user clicked on.
	 * @param	boolean		$showLinks	If set (default) links are created, only labels otherwise.
	 * @return	string		The HTML source for the path menu.
	 */
	function getCategoryPath( $categoryUID, $showLinks = true )	{

		// Init some vars
		$content = null;
		$catuid_before = null;

		if( $categoryUID != null )	{
			do {
				$res = null;
				$categoryLabel = null;

				// Get label and catuid_before from link record with uid = categoryUID
				$databaseTable = $this->tablePrefix . 'category';
				$theField = 'uid';
				$theValue = $categoryUID;
				$whereClause = $this->enableFieldsCategory;
				$groupBy = '';
				$orderBy = '';
				$limit = '';
				$categoryResult = $GLOBALS['TYPO3_DB']->exec_SELECTquery( '*', $databaseTable, $theField . '=' . $GLOBALS['TYPO3_DB']->quoteStr( $theValue, $databaseTable ) . ' ' . $whereClause, $groupBy, $orderBy, $limit );

				// Get record overlay
				$category = $this->getRecordOverlay( $categoryResult, $databaseTable );

				// Append category link to content
				$categoryLabel = $category[0]['label'];
				$pageID = intval( $this->pi_getFFvalue( $this->flexform, 'pageIDListPlugin', 'sDEF' ) ? $this->pi_getFFvalue( $this->flexform, 'pageIDListPlugin', 'sDEF' ) : $GLOBALS['TSFE']->id );
				$pageIDHome = intval( $this->pi_getFFvalue( $this->flexform, 'pageIDHome', 'sDEF' ) ? $this->pi_getFFvalue( $this->flexform, 'pageIDHome', 'sDEF' ) : $GLOBALS['TSFE']->id );

				if( $showLinks )	{
					if( $this->linkMode == 'TREE' )	{
						$conf = array(
							'useCacheHash' => $this->pi_USER_INT_obj ? 0 : $this->allowCaching,
							'no_cache' => $this->pi_USER_INT_obj ? 0 : !$this->allowCaching,
							'parameter' => $pageID,
							'section' => 'cat_' . $categoryUID,
							// FIXME: Repair empty GET parameter or remove additionalParams at all if possible
							'additionalParams' => t3lib_div::implodeArrayForUrl( '', array( 'tx_ablinklist_pi1[category_uid]' => '' ), '', 0 ),
						);
						$link = $this->local_cObj->typoLink( $categoryLabel, $conf );

						$content = ' ' . $link . $content;
					} else	{
						$content = ' ' . $this->pi_LinkTP( $categoryLabel, array( 'tx_ablinklist_pi1[category_uid]' => $categoryUID ), $this->allowCaching, $pageID ) . $content;
					}
				} else	{
					$content = ' ' . $categoryLabel . $content; 
				}

				// Set categoryUID to parent category to continue one level up
				$categoryUID = $category[0]['catuid_before'];

				// Add a '>>' between category links
				if( $showLinks )	{
					$content = ' &raquo;' . $content;
				} else	{
					$content = ' >' . $content;
				}

			} while( $categoryUID != null && $categoryUID != '0' );

			// Finally add the link to the root
			if( $showLinks )	{
				$content = $this->pi_LinkTP( $this->pi_getLL( 'll_home' ), array(), $this->allowCaching, $pageIDHome ) . $content;
			} else	{
				$content = $this->pi_getLL( 'll_home' ) . $content;
			}
		} else	{
			return "";
		}

		// Return the generated content
		return $content;
	}

	/**
	 * getRecordOverlay( &$resultSet, $databaseTable )
	 *
	 * Returns the record overlay for categories/links.
	 *
	 * @param	object		$resultSet	The original SQL result set.
	 * @param	string		$databaseTable	The database table to fetch overlay records from.
	 * @return	array		The overlaid SQL result set.
	 */
	function getRecordOverlay( &$resultSet, $databaseTable )	{

		// FIXME: Use $this->sys_language_mode (strict: Don't display not translated records at all)
		if( $resultSet != null && $databaseTable != null )	{

			while ( $row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc( $resultSet ) )	{
				if ( $GLOBALS['TSFE']->sys_language_content )	{
					$row = $GLOBALS['TSFE']->sys_page->getRecordOverlay( $databaseTable, $row, $GLOBALS['TSFE']->sys_language_content, $GLOBALS['TSFE']->sys_language_contentOL );
				}
				$overlaidSet[] = $row;
			}
	
			return $overlaidSet;
		} else	{
			return array();
		}
	}

	/**
	 * getCategorySelect( $categoryUID, $selectedID = 0 )
	 *
	 * Generates a nested category select form field with category labels.
	 *
	 * @param	integer		$categoryUID	Start category ID from which the select is generated.
	 * @param	integer		$selectedID	ID from preselected entry.
	 * @return	string		The HTML source for the nested category select.
	 */
	function getCategorySelect( $categoryUID, $selectedID = 0 )	{

		// Get category label
		if( $categoryUID == 0 )	{
			$category[0]['label'] = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_cats' ), '' );
		} else	{
			$databaseTable = $this->tablePrefix . 'category';
			$theField = 'uid';
			$theValue = $categoryUID;
			$whereClause = $this->enableFieldsCategory;
			$groupBy = '';
			$orderBy = '';
			$limit = '';
			$categoryResult = $GLOBALS['TYPO3_DB']->exec_SELECTquery( '*', $databaseTable, $theField . '=' . $GLOBALS['TYPO3_DB']->quoteStr( $theValue, $databaseTable ) . ' ' . $whereClause, $groupBy, $orderBy, $limit );

			// Get record overlay
			$category = $this->getRecordOverlay( $categoryResult, $databaseTable );
		}

		$content .= '<select name="tx_ablinklist_pi1[selectedCategoryUID]"><option value=""></option><optgroup label="' . $category[0]['label'] . '">';

		// Get subcategories
		$databaseTable = $this->tablePrefix . 'category';
		$theField = 'catuid_before';
		$theValue = $categoryUID;
		$whereClause = $this->enableFieldsCategory;
		$groupBy = '';
		$orderBy = 'label ASC';
		$limit = '';
		$categoriesResults = $GLOBALS['TYPO3_DB']->exec_SELECTquery( '*', $databaseTable, $theField . '=' . $GLOBALS['TYPO3_DB']->quoteStr( $theValue, $databaseTable ) . ' ' . $whereClause, $groupBy, $orderBy, $limit );

		// Get record overlay
		$categories = $this->getRecordOverlay( $categoriesResults, $databaseTable );

		if( count( $categories ) > 0 )	{
			for( $i = 0; $i < count( $categories ); $i++ )	{
				if( $selectedID == $categories[$i]['uid'] )	{
					$content .= '<option value="' . $categories[$i]['uid'] . '" selected="selected">' . $categories[$i]['label'] . '</option>';
				} else	{
					$content .= '<option value="' . $categories[$i]['uid'] . '">' . $categories[$i]['label'] . '</option>';
				}
			}
		}

		$content .= '</optgroup></select>';

		return $content;
	}

	/**
	 * displayFEHelp( $type )
	 *
	 * Returns a help message wich will be displayed on the website.
	 *
	 * @param	string		$type	The type of the help message.
	 * @return	string		HTML code for the help message.
	 */
	function displayFEHelp( $type )	{

		switch ( $type )	{
			case 'noTopListSet':
				return "Please set at least one TOP list to display in the backend.";
			break;
		}
	}

	/**
	 * validURI( $href )
	 *
	 * Checks if the given href is valid.
	 *
	 * @param	string		$href	The href to check.
	 * @return	boolean		TRUE if href is valid, FALSE otherwise
	 */
	function validURI( $href )	{

		if( !strstr( $href, 'http://' ) && !strstr( $href, 'ftp://' ) )  {
			return false;
		} else	{
			return true;
		}
	}

	/**
	 * containsBlacklistedWords( $text )
	 *
	 * Checks if the given text contains any of the blacklisted words.
	 *
	 * @param	string		$text	The text to check.
	 * @return	boolean		TRUE if text contains blacklisted words, FALSE otherwise
	 */
	function containsBlacklistedWords( $text )	{

		$blacklist = $this->pi_getFFvalue( $this->flexform, 'blacklist', 'sDEF' );
		if( $blacklist )	{
			$blacklistArray = explode( ',', $blacklist );
	
			foreach( $blacklistArray as $index => $word )	{
				if( stristr( $text, $word ) )
					return true;
			}

			return false;
		} else	{
			return false;
		}
	}

	/**
	 * returnStarsForRating( $rating )
	 *
	 * Returns an image representation of a link rating.
	 *
	 * @param	integer		$rating	The rating to represent as an image.
	 * @return	string		The image representation.
	 */
	function returnStarsForRating( $rating )	{
		$string = null;

		$iconText = $this->local_cObj->stdWrap( $this->pi_getLL( 'll_rating' ), '' ) . ': ' . round( $rating, 2 );
		if( $rating )	{
			while ( $rating >= 1 )	{
				$rating -= 1;
				$string .= $this->local_cObj->fileResource( $this->conf['iconStar'], 'alt="'.$iconText.'" title="'.$iconText.'"' );
			}
	
			if( $rating >= 0.5 )
				$string .= $this->local_cObj->fileResource( $this->conf['iconHalfStar'], 'alt="'.$iconText.'" title="'.$iconText.'"' );
	
			return $string;
		} else	{
			return $this->local_cObj->fileResource( $this->conf['iconDisabledStar'], 'alt="'.$iconText.'" title="'.$iconText.'"' );
		}
	}
}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/ab_linklist/pi1/class.tx_ablinklist_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/ab_linklist/pi1/class.tx_ablinklist_pi1.php']);
}

?>
