<?php
if(!defined ('TYPO3_MODE') ) die ('Access denied.');

$TCA['tx_ablinklist_category'] = Array (
	'ctrl' => $TCA['tx_ablinklist_category']['ctrl'],
	'interface' => Array (
		'showRecordFieldList' => 'hidden,fe_group,label,catuid_before,image'
	),
	'columns' => Array (
		'sys_language_uid' => Array (
		    'exclude' => 1,
		    'label' => 'LLL:EXT:lang/locallang_general.php:LGL.language',
		    'config' => Array (
			'type' => 'select',
			'foreign_table' => 'sys_language',
			'foreign_table_where' => 'ORDER BY sys_language.title',
			'items' => Array(
			    Array( 'LLL:EXT:lang/locallang_general.php:LGL.allLanguages', -1 ),
			    Array( 'LLL:EXT:lang/locallang_general.php:LGL.default_value', 0 )
			)
		    )
		),
		'l18n_parent' => Array (
		    'displayCond' => 'FIELD:sys_language_uid:>:0',
		    'exclude' => 1,
		    'label' => 'LLL:EXT:lang/locallang_general.php:LGL.l18n_parent',
		    'config' => Array (
			'type' => 'select',
			'items' => Array (
			    Array( '', 0 )
			),
			'foreign_table' => 'tx_ablinklist_category',
			'foreign_table_where' => 'AND tx_ablinklist_category.uid=###REC_FIELD_l18n_parent### AND tx_ablinklist_category.sys_language_uid IN (-1,0)'
		    )
		),
		'l18n_diffsource' => Array (
		    'config' => Array (
			'type' => 'passthrough'
		    )
		),
		'hidden' => Array (
			'l10n_mode' => 'mergeIfNotBlank',
			'exclude' => 1,
			'label' => 'LLL:EXT:lang/locallang_general.php:LGL.hidden',
			'config' => Array (
				'type' => 'check',
				'default' => '0'
			)
		),
		'fe_group' => Array (
			'l10n_mode' => 'mergeIfNotBlank',
			'exclude' => 1,
			'label' => 'LLL:EXT:lang/locallang_general.php:LGL.fe_group',
			'config' => Array (
				'type' => 'select',
				'items' => Array (
					Array( '', 0 ),
					Array( 'LLL:EXT:lang/locallang_general.php:LGL.hide_at_login', -1 ),
					Array( 'LLL:EXT:lang/locallang_general.php:LGL.any_login', -2 ),
					Array( 'LLL:EXT:lang/locallang_general.php:LGL.usergroups', '--div--' )
				),
				'foreign_table' => 'fe_groups'
			)
		),
		'label' => Array (
			'l10n_mode' => 'prefixLangTitle',
			'exclude' => 1,	
			'label' => 'LLL:EXT:ab_linklist/locallang_db.php:tx_ablinklist_category.label',	
			'config' => Array (
				'type' => 'input',
				'size' => '40',
				'eval' => 'required'
			)
		),
		'description' => Array (
			'l10n_mode' => 'prefixLangTitle',
			'exclude' => 1,	
			'label' => 'LLL:EXT:ab_linklist/locallang_db.php:tx_ablinklist_category.description',	
			'config' => Array (
				'type' => 'text',
				'cols' => '30',
				'rows' => '5'
			)
		),
/*
		'catuid_before' => Array (
			'l10n_mode' => 'exclude',
			'exclude' => 1,	
			'label' => 'LLL:EXT:ab_linklist/locallang_db.php:tx_ablinklist_category.catuid_before',	
			'config' => Array (
				'type' => 'select',
				'items' => Array (
					Array( '', 0 ),
				),
				'foreign_table' => 'tx_ablinklist_category',
				'foreign_table_where' => 'AND tx_ablinklist_category.sys_language_uid=0 AND tx_ablinklist_category.pid=###CURRENT_PID### ORDER BY tx_ablinklist_category.uid',
				'size' => 1,
				'minitems' => 0,
				'maxitems' => 1,
//			        'MM' => 'tx_ablinklist_category_catuid_before_mm'
			)
		),

*/		
		'catuid_before' => Array (
			'exclude' => 1,
			'l10n_mode' => 'exclude',
			'label' => 'LLL:EXT:ab_linklist/locallang_db.php:tx_ablinklist_category.catuid_before',	
			'config' => Array (
				'type' => 'select',
//				'items' => Array (
//					Array( '', 0 ),
//				),
				'form_type' => 'user',
				'userFunc' => 'tx_ablinklist_treeview->displayCategoryTree',
				'treeClass' => 'tx_ablinklist_tceFunc_categoryTree',
				'treeView' => 1,
				'foreign_table' => 'tx_ablinklist_category',
				'foreign_table_where' => ' AND (sys_language_uid=0 OR sys_language_uid=-1)',
				'size' => 1,
				'autoSizeMax' => 10,
				'minitems' => 0,
				'maxitems' => 2,
		
				
//			        'MM' => 'tx_ablinklist_category_catuid_before_mm'
				)
		),
		
		
		
		
		'image' => Array (
			'l10n_mode' => 'exclude',
			'exclude' => 1,
			'label' => 'LLL:EXT:ab_linklist/locallang_db.php:tx_ablinklist_category.image',
			'config' => Array (
				'type' => 'group',
				'internal_type' => 'file',
				'allowed' => $GLOBALS['TYPO3_CONF_VARS']['GFX']['imagefile_ext'],
				'max_size' => '30000',
				'uploadfolder' => 'uploads/tx_ablinklist/categoryImages',
				'show_thumbs' => '1',
				'size' => 1,
				'minitems' => 0,
				'maxitems' => 1
			)
		)
	),
	'types' => Array (
		'0' => Array( 'showitem' => 'hidden;;1;;1-1-1, label;;2;;, description;;2;;, image, catuid_before' )
	),
	'palettes' => Array (
		'1' => Array( 'showitem' => 'fe_group' ),
		'2' => Array( 'showitem' => 'l18n_parent, sys_language_uid' )
	)
);

$TCA['tx_ablinklist_link'] = Array (
	'ctrl' => $TCA['tx_ablinklist_link']['ctrl'],
	'interface' => Array (
		'showRecordFieldList' => 'hidden,fe_group,label,description,href,clicks,rating,votes,status,category,contact,image'
	),
	'columns' => Array (
		'sys_language_uid' => Array (
		    'exclude' => 1,
		    'label' => 'LLL:EXT:lang/locallang_general.php:LGL.language',
		    'config' => Array (
			'type' => 'select',
			'foreign_table' => 'sys_language',
			'foreign_table_where' => 'ORDER BY sys_language.title',
			'items' => Array(
			    Array( 'LLL:EXT:lang/locallang_general.php:LGL.allLanguages', -1 ),
			    Array( 'LLL:EXT:lang/locallang_general.php:LGL.default_value', 0 )
			)
		    )
		),
		'l18n_parent' => Array (
		    'displayCond' => 'FIELD:sys_language_uid:>:0',
		    'exclude' => 1,
		    'label' => 'LLL:EXT:lang/locallang_general.php:LGL.l18n_parent',
		    'config' => Array (
			'type' => 'select',
			'items' => Array (
			    Array( '', 0 )
			),
			'foreign_table' => 'tx_ablinklist_link',
			'foreign_table_where' => 'AND tx_ablinklist_link.uid=###REC_FIELD_l18n_parent### AND tx_ablinklist_link.sys_language_uid IN (-1,0)'
		    )
		),
		'l18n_diffsource' => Array (
		    'config' => Array (
			'type' => 'passthrough'
		    )
		),
		'hidden' => Array (
			'l10n_mode' => 'mergeIfNotBlank',	
			'exclude' => 1,
			'label' => 'LLL:EXT:lang/locallang_general.php:LGL.hidden',
			'config' => Array (
				'type' => 'check',
				'default' => '0'
			)
		),
		'fe_group' => Array (
			'l10n_mode' => 'mergeIfNotBlank',
			'exclude' => 1,
			'label' => 'LLL:EXT:lang/locallang_general.php:LGL.fe_group',
			'config' => Array (
				'type' => 'select',
				'items' => Array (
					Array( '', 0 ),
					Array( 'LLL:EXT:lang/locallang_general.php:LGL.hide_at_login', -1 ),
					Array( 'LLL:EXT:lang/locallang_general.php:LGL.any_login', -2 ),
					Array( 'LLL:EXT:lang/locallang_general.php:LGL.usergroups', '--div--' )
				),
				'foreign_table' => 'fe_groups'
			)
		),
		'label' => Array (
			'l10n_mode' => 'prefixLangTitle',
			'exclude' => 1,	
			'label' => 'LLL:EXT:ab_linklist/locallang_db.php:tx_ablinklist_link.label',	
			'config' => Array (
				'type' => 'input',
				'size' => '40',
				'eval' => 'required'
			)
		),
		'description' => Array (
			'l10n_mode' => 'prefixLangTitle',
			'exclude' => 1,	
			'label' => 'LLL:EXT:ab_linklist/locallang_db.php:tx_ablinklist_link.description',	
			'config' => Array (
				'type' => 'text',
				'cols' => '30',
				'rows' => '5'
			)
		),
		'href' => Array (
			'l10n_mode' => 'exclude',
			'exclude' => 1,	
			'label' => 'LLL:EXT:ab_linklist/locallang_db.php:tx_ablinklist_link.href',	
			'config' => Array (
				'type' => 'input',	
				'size' => '40',
				'max' => '255',
				'checkbox' => '',
				'eval' => 'trim',
				'wizards' => Array(
					'_PADDING' => 2,
					'link' => Array(
						'type' => 'popup',
						'title' => 'Link',
						'icon' => 'link_popup.gif',
						'script' => 'browse_links.php?mode=wizard',
						'JSopenParams' => 'height=300,width=500,status=0,menubar=0,scrollbars=1'
					)
				)
			)
		),
		'clicks' => Array (
			'l10n_mode' => 'exclude',
			'exclude' => 1,	
			'label' => 'LLL:EXT:ab_linklist/locallang_db.php:tx_ablinklist_link.clicks',	
			'config' => Array (
				'type' => 'input',
				'size' => '4',
				'max' => '4',
				'eval' => 'int',
				'checkbox' => '0',
				'range' => Array (
					'upper' => '5000',
					'lower' => '0'
				),
				'default' => 0
			)
		),
		'rating' => Array (
			'l10n_mode' => 'exclude',
			'exclude' => 1,	
			'label' => 'LLL:EXT:ab_linklist/locallang_db.php:tx_ablinklist_link.rating',	
			'config' => Array (
				'type' => 'input',
				'size' => '4',
				'max' => '4',
				'eval' => 'int',
				'checkbox' => '0',
				'range' => Array (
					'upper' => '10',
					'lower' => '0'
				),
				'default' => 0
			)
		),
		'votes' => Array (
			'l10n_mode' => 'exclude',
			'exclude' => 1,	
			'label' => 'LLL:EXT:ab_linklist/locallang_db.php:tx_ablinklist_link.votes',	
			'config' => Array (
				'type' => 'input',
				'size' => '4',
				'max' => '4',
				'eval' => 'int',
				'checkbox' => '0',
				'range' => Array (
					'upper' => '5000',
					'lower' => '0'
				),
				'default' => 0
			)
		),
		'status' => Array (
			'l10n_mode' => 'exclude',
			'exclude' => 1,	
			'label' => 'LLL:EXT:ab_linklist/locallang_db.php:tx_ablinklist_link.status',	
			'config' => Array (
				'type' => 'select',
				'items' => Array (
					Array( 'LLL:EXT:ab_linklist/locallang_db.php:tx_ablinklist_link.status.i.0', '0' ),
					Array( 'LLL:EXT:ab_linklist/locallang_db.php:tx_ablinklist_link.status.i.1', '1' ),
					Array( 'LLL:EXT:ab_linklist/locallang_db.php:tx_ablinklist_link.status.i.2', '2' ),
					Array( 'LLL:EXT:ab_linklist/locallang_db.php:tx_ablinklist_link.status.i.3', '3' )
				)
			)
		),
		
/*		
		'category' => Array (
			'l10n_mode' => 'exclude',
			'exclude' => 1,	
			'label' => 'LLL:EXT:ab_linklist/locallang_db.php:tx_ablinklist_link.category',	
			'config' => Array (
				'type' => 'select',
				'items' => Array (
					Array( '', 0 )
				),
				'foreign_table' => 'tx_ablinklist_category',
				'foreign_table_where' => 'AND tx_ablinklist_category.sys_language_uid=0 AND tx_ablinklist_category.pid=###CURRENT_PID### ORDER BY tx_ablinklist_category.uid',
				'size' => 1,
				'minitems' => 0,
				'maxitems' => 1
			)
		),
*/		
		'category' => Array (
			'exclude' => 1,
			'l10n_mode' => 'exclude',
			'label' => 'LLL:EXT:ab_linklist/locallang_db.php:tx_ablinklist_link.category',	
			'config' => Array (
				'type' => 'select',

				'form_type' => 'user',
				'userFunc' => 'tx_ablinklist_treeview->displayCategoryTree',
				'treeClass' => 'tx_ablinklist_tceFunc_categoryTree',
				'treeView' => 1,
				'foreign_table' => 'tx_ablinklist_category',
				'foreign_table_where' => $fTableWhere.' AND (sys_language_uid=0 OR sys_language_uid=-1)',
				'size' => 10,
				'autoSizeMax' => 25,
				'minitems' => 0,
				'maxitems' => 500,
				'MM' => 'tx_ablinklist_link_category_mm',
			)
		),

		
		
		'contact' => Array (
			'l10n_mode' => 'exclude',
			'exclude' => 1,	
			'label' => 'LLL:EXT:ab_linklist/locallang_db.php:tx_ablinklist_link.contact',   
			'config' => Array (
				'type' => 'input',
				'size' => '40'
			)
		),
		'image' => Array (
			'l10n_mode' => 'exclude',
			'exclude' => 1,
			'label' => 'LLL:EXT:ab_linklist/locallang_db.php:tx_ablinklist_link.image',
			'config' => Array (
				'type' => 'group',
				'internal_type' => 'file',
				'allowed' => $GLOBALS['TYPO3_CONF_VARS']['GFX']['imagefile_ext'],
				'max_size' => '30000',
				'uploadfolder' => 'uploads/tx_ablinklist/linkImages',
				'show_thumbs' => '1',
				'size' => 1,
				'minitems' => 0,
				'maxitems' => 1
			)
		),
		'promotion_status' => Array (
			'l10n_mode' => 'exclude',
			'exclude' => 1,	
			'label' => 'LLL:EXT:ab_linklist/locallang_db.php:tx_ablinklist_link.promotion_status',	
			'config' => Array (
				'type' => 'select',
				'items' => Array (
					Array( 'LLL:EXT:ab_linklist/locallang_db.php:tx_ablinklist_link.promotion_status.i.0', '0' ),
					Array( 'LLL:EXT:ab_linklist/locallang_db.php:tx_ablinklist_link.promotion_status.i.1', '1' ),
					Array( 'LLL:EXT:ab_linklist/locallang_db.php:tx_ablinklist_link.promotion_status.i.2', '2' ),
				)
			)
		),
	),
	'types' => Array (
		'0' => Array( 'showitem' => 'hidden;;1;;1-1-1, label;;2;;, description;;2;;, href, category, image, contact, clicks, rating, votes, status, promotion_status' )
	),
	'palettes' => Array (
		'1' => Array( 'showitem' => 'fe_group' ),
		'2' => Array( 'showitem' => 'l18n_parent, sys_language_uid' )
	)
);
?>